commit 80b30d12519ac54fc5b2b05500521d9c8269be9c
Author: Matt Turner <mattst88@gmail.com>
Date:   Wed Mar 30 13:54:13 2022 -0700

    libX11 1.7.4
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 8a368d808fec166b5fb3dfe6312aab22c7ee20af
Author: Hodong <hodong@yozmos.com>
Date:   Thu Jan 20 00:57:41 2022 +0900

    Fix two memory leaks in _XFreeX11XCBStructure()
    
    Even when XCloseDisplay() was called, some memory was leaked.
    
    XCloseDisplay() calls _XFreeDisplayStructure(), which calls
    _XFreeX11XCBStructure().
    
    However, _XFreeX11XCBStructure() did not destroy the condition variables,
    resulting in the leaking of some 40 bytes.
    
    Signed-off-by: Hodong <hodong@yozmos.com>

commit da97120f2322882a17f14e5d7da00c1e772679e8
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Mar 22 14:32:49 2022 -0400

    xcb: Clarify the XInitThreads error message
    
    XInitThreads has been called if _Xglobal_lock != NULL, we may as well
    check that before printing a misleading error message.
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 257927c51b08242aa5bf239346717fc817b2b286
Author: Giovanni Mascellani <gmascellani@codeweavers.com>
Date:   Fri Feb 4 10:49:25 2022 +0100

    xcb_io: Allow jumps backwards when widening the request number.
    
    Request numbers are not always seen in the numeric order by widen(),
    for example due to Mesa directly calling _XError(). When this happens,
    widen() adds 2^32 to the reported widened number, triggering failed
    assertions and bad behavior.
    
    With this commit, wrapping of the lower dword is detected in a more
    robust way, by requiring that a skip of at least 2^31 is seen.
    
    This fixes issue #152.
    
    Signed-off-by: Giovanni Mascellani <gmascellani@codeweavers.com>

commit 918063298cb893bee98040c9dca45ccdb2864773
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Thu Mar 3 12:00:45 2022 +0100

    nls: add a compose sequence for the peace symbol
    
    As the thing in the circle looks a bit like an upside-down Y,
    use <O> <Y> as the sequence, similar to <O> <A> for anarchism.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 4f9eb32709dca705f02ca771bbd47d6c08aba5e0
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Feb 25 12:45:06 2022 +0100

    nls: remove obsolete locale aliases with uppercase in the language code
    
    (These aliases may have been useful on some systems twenty years ago,
    but nowadays all should have settled on lowercase language code plus
    uppercase country code.)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit ba0d3b437deb2212bc7fc7c6f1c603fa6ced443c
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Feb 25 12:35:28 2022 +0100

    nls: map eo.UTF-8 directly to en_US.UTF-8 instead of using a relay alias
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit cfddb79981f23650feb0f9a0f4442c9cad584b33
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Feb 25 12:12:05 2022 +0100

    nls: remove the mistaken eo_EO names -- EO is not a valid country code
    
    (Debian has had several of these lines commented out for years.)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit eb5885245a1ba6955d058a03e31894c23b9f5490
Author: iyzana <iyzana@protonmail.com>
Date:   Mon Feb 21 13:20:23 2022 +0100

    nls: add locale alias from eo.UTF-8 to eo_XX.UTF-8
    
    There is no matching locale in the locale.dir and compose.dir files for
    the locale eo.UTF-8. Setting it as the locale resulted in compose files
    not being loaded.
    
    Signed-off-by: iyzana <iyzana@protonmail.com>

commit 24df23dff9d8c1cf5e918a5f040b852bdf2cfb84
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Thu Feb 3 17:19:05 2022 +0100

    nls: group the compose sequences for tilde, degree, and cedilla together
    
    Also, correct the comment for the double quote character ("), and move
    the soft hyphen and the interrobangs to a special punctuation group.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit c0191f020f94907770937bc8ae67ea8acd7d63be
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Thu Feb 3 16:33:05 2022 +0100

    nls: use shape-based compose sequences for hammer-and-sickle instead
    
    Using a misspelled abbreviation (CCCP) of an obsolete country's name
    to compose a fairly general communist symbol does not seem right.
    
        https://en.wikipedia.org/wiki/Hammer_and_sickle
    
    Many compose sequences instead combine characters that together look
    similar to the target character.  Do the same here: question mark (?)
    plus backslash (\) look a bit like ☭ .
    
    In the bargain, this fixes issue #63.
    
    Reported-by: Marc Mezzarobba
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 582dc6f89e1f9288710a55cb2b8fbf2af99d7616
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Feb 20 11:49:42 2022 -0800

    gitlab CI: enable Static Application Security Testing (SAST)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 336e8f72559b489396c5cd503c4586ef800c2a8f
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Feb 20 15:06:02 2022 +0100

    nls: add compose sequences for leftward, upward and downward double arrow
    
    These sequences follow the logic of: the arrow shaft (=) first, the
    arrow head (< or > or ^ or v) second.  This is so because the sequence
    <= is already taken for ≤, and there is no obvious ASCII character for
    a double vertical line, so we have to make do with a horizontal one.
    
    Since commit 6101b967b6 from eight years ago, there is a compose sequence
    for the rightward double arrow, but not for the other three directions.
    
    This fixes issue #138.
    
    Requested-by: Mélanie Chauvel
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 623b77d4f30b47258a40f89262e5aa5d25e95fa7
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Mon Feb 14 11:33:25 2022 +0100

    imDefLkup: verify that a pointer isn't NULL before using it
    
    It is possible for _XimICOfXICID() to return NULL, so it is necessary
    to check this isn't actually the case before dereferencing the pointer.
    All other callers of _XimICOfXICID() do this check too.
    
    (The check itself is ugly, but it follows the style of the code in the
    rest of the module.)
    
    Fixes issue #45.
    
    Reported-by: Bhavi Dhingra
    
    Original-patch-by: Bhavi Dhingra
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit b83938f7f97aa6210b00835002e6e7d614b2374a
Author: Christopher Chavez <chrischavez@gmx.us>
Date:   Mon Feb 14 01:00:45 2022 +0000

    Xlib.h: fix spelling in comment
    
    Signed-off-by: Christopher Chavez <chrischavez@gmx.us>

commit 4791055682552b4cc8e775479700fb06980d0b59
Author: Christopher Chavez <chrischavez@gmx.us>
Date:   Sun Feb 13 05:26:14 2022 +0000

    Xlib.h: spelling fix in comment

commit 9304e645bdcdd3a71ff449a1157c4815e6304d7a
Author: Denis Drakhnia <numas13@gmail.com>
Date:   Wed Feb 2 11:54:43 2022 +0200

    nls: Add ru_UA.utf8 locale alias.
    
    Signed-off-by: Denis Drakhnia <numas13@gmail.com>

commit 9ef2551f0c201f9163b66d17189a98076b5be07a
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Feb 2 16:50:35 2022 +0100

    nls: do some manual adjustment of whitespace in the compose sequences
    
    This achieves a more consistent vertical alignment (per group) of the
    target character and the trailing comments.
    
    (Most blocks were aligned in some fashion, except the "Greek Extended"
    block, which has lines of greatly varying lengths.)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 0dad289ead6eb3412027c9365192441cc539d747
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Feb 2 14:08:22 2022 +0100

    nls: among the compose sequences, replace all runs of spaces with tabs
    
    It was done with this script:
    
        cat nls/en_US.UTF-8/Compose.pre |
        sed 's!\(^<.\{6,13\}>\)\s*:!\1\t\t\t\t:!' |
        sed 's!\(^<.\{14,21\}>\)\s*:!\1\t\t\t:!' |
        sed 's!\(^<.\{22,29\}>\)\s*:!\1\t\t:!' |
        sed 's!\(^<.\{30,37\}>\)\s*:!\1\t:!' |
        sed 's!\(: ".*"\)\s*!\1\t!' |
        sed 's!\(\s*# \)! # !' > trimmed &&
        mv  trimmed  nls/en_US.UTF-8/Compose.pre
    
    This saves 37 kilobytes of whitespace.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit fc79e39c236501357e1fdbe8964882864eeef5d3
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Feb 2 14:06:29 2022 +0100

    docs: add missing word, wrap line, fix typo, and trim an excess space
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 93446455c46dfc019984ab822ffa662cf6e2949c
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Thu Jan 27 15:01:18 2022 +0100

    KeyBind: reshuffle two ifs into the general order of ascending codes
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 93f15f5f29378ec4cc1dd011b155104e9a52b058
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Thu Jan 27 14:27:41 2022 +0100

    KeyBind: slightly speed up some case conversions by adding missing returns
    
    This avoids pointlessly tumbling through several more ifs when the
    conversion has aleady been done.
    
    Also remove two redundant conditions (as lower codes have already
    been handled) and fold two other conditions together.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 317c7abbcc848011393d1336b9d020af8cabb000
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Thu Jan 27 13:54:29 2022 +0100

    KeyBind: update the Greek case-conversion tables to Unicode Data 14.0
    
    A few symbols, like Heta and Sampi and dotted lunate Sigma, have been
    assigned code points since Unicode Data 4.0, and need their entries.
    
    This fixes issue #132.
    
    Reported-by: Ray Vine
    
    Original-patch-by: Ray Vine
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 402b843fa72166d9ceefd887f5cea4728cbc6995
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 26 17:20:28 2022 +0100

    remove a commented-out code fragment, and remove a stray blank line
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit fbbc3cf8b8b03f74f778772d4703fc4fec242282
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 26 16:55:50 2022 +0100

    XKBCvt: remove an if that never gets triggered
    
    The 'if' at the beginning of _XkbHandleSpecialSym() allows only symbols
    from the numeric keypad and some control symbols to pass -- XK_hyphen
    is not among them, so the check for XK_hyphen in the later 'if' will
    always be false.
    
    (The corresponding conversion in _XTranslateKeySym() in KeyBind.c was
    removed in March 1994.)
    
    (Also, several keyboard layouts nowadays contain the 'hyphen' symbol,
    allowing the user to enter soft hyphens into a document.  So we really
    don't want to remap this symbol.)
    
    Fixes issue #48.
    
    Reported-by: Bhavi Dhingra
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 6786744f636b3fc545157a13cb2f6169b5be9fa5
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Jan 23 17:12:03 2022 +0100

    nls: add the es_CU locale name, for Cuba
    
    It was added to glibc ten years ago.
    
    This fixes issue #57.
    
    Reported-by: Dominique Michel
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit d241d8af7f24e95949c2cf7ce791e35df7665e98
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Jan 23 16:44:03 2022 +0100

    nls: remove some obsolete Norwegian and Yugoslavian locale names
    
    They have not existed in glibc for more than fifteen years.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 32dd7c03e92e01015744867b9b3148c250cc159a
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sat Jan 22 17:56:32 2022 +0100

    nls: put some entries in their alphabetical order, and adjust alignment
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 46a066f25103bb909259baea25de8dd5c4a2b338
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sat Jan 22 18:00:20 2022 +0100

    nls: fix a typo (be_BG => bg_BG) and drop an obsolete comment
    
    The typo was only partially fixed in commit 22a5255b80 sixteen years ago,
    and the internet shows that there was at least one user frustrated that
    bg_BG.utf8 didn't work but bg_BG.UTF-8 did.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 84efc0aa598c8f7d6dd9a49e7450e85c8bc4773b
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 19 15:32:15 2022 +0100

    nls: remove the compose sequences with the deviant KP_Space symbol
    
    Using this KP_Space symbol as a stand-in for the symbol 2 doesn't make
    sense.  It looks like a mistake, or as if someone had a broken keyboard
    and used KP_Space as a substitute for 2.
    
    Also, no keyboard layout in the last fifteen years has contained the
    KP_Space symbol, so I don't see how anyone could type it.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit b76e661ca223489da9027b0ab1ca1586efd0a280
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 19 13:49:56 2022 +0100

    nls: move the block of Jamo to its logical place (ascending Unicodes)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 21f82fb9c69f8fdbf0bdc1aac6f8c11c2c6d55d1
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 19 13:40:56 2022 +0100

    nls: delete some ineffective compose sequences (that were commented out)
    
    They have never worked; there is no point in keeping them in the file.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 6cc31eafa8095d2117ff1906d7c14c1c01173248
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 19 12:18:21 2022 +0100

    nls: group some compose sequences better, and add some comments
    
    Also, align a few trailing comments more consistently, and change
    some comments so they will be excluded from the installed file --
    there is no need for those comments there.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit d60ede7843612f3c2967f83d629bf8272ba09ff1
Author: ArenaL5 <arenal5@protonmail.com>
Date:   Thu Jan 13 01:13:56 2022 +0100

    nls: add a compose sequence for the copyleft symbol
    
    Probably not used anywhere yet, let alone seriously, as stated in
    https://en.wikipedia.org/wiki/Copyleft#Symbol
    
    Signed-off-by: ArenaL5 <arenal5@protonmail.com>

commit df4dcdf9125c595f6df3a302356647cb8df38553
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Mon Jan 17 17:31:08 2022 +0100

    nls: remove redundant compose sequences with deprecated Hebrew symbols
    
    The compose sequences with the valid Hebrew key symbols are right there.
    
    Also, no keyboard layout in the past seventeen years has contained these
    deprecated symbols on any key.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 4268472bd11a07a799716fb5833ea46cad3dd479
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Jan 16 17:51:29 2022 +0100

    nls: remove redundant compose sequences with the deprecated 'underbar'
    
    The key symbol 'underbar' is equivalent to 'underscore' -- the mirror
    compose sequences with the latter symbol continue to exist.
    
    Also, no keyboard layout in the past fifteen years has contained the
    symbol 'underbar' on any key -- except a Telugu layout since a few
    years, but that will be corrected soon.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 86e9749ef37189486c205ee7f77e43fed655ac70
Author: ArenaL5 <arenal5@protonmail.com>
Date:   Sat Jan 15 16:20:56 2022 +0100

    nls: add a compose sequence for the middle dot (·) using dead_circumflex
    
    This makes the middle dot compose sequences consistent with others that
    begin with <dead_circumflex> and <Multi_key> <asciicircum>, e.g.
    superscripted 3 (³)
    
    Signed-off-by: ArenaL5 <arenal5@protonmail.com>

commit 1adb531cd5be2b6489c2a8106e850e7418fae056
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Jan 14 13:06:10 2022 +0100

    docs: unwrap the comments of structure elements in the man pages
    
    It doesn't matter that these lines get wider than 80 columns, as it's
    easy enough to make the pager scroll a bit to the right, or to have a
    terminal that is a 100 or more columns wide.  It looks better to not
    hard-wrap these comments.
    
    Also, fix the layout of two table elements.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit da330a1644f10f9669c8dd9ee06489c40f9f0bd1
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Jan 14 12:33:23 2022 +0100

    docs: unwrap some mistakenly wrapped lines, and correct a comment
    
    The wrapped lines messed up the table.  Also, add some blank lines
    to make the table more readable.
    
    Elsewhere, add spaces around an operator (for consistency),
    and correct a copy-paste error.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit b9e0346abebb0c9e5c80c780bba4372419e63bde
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Jan 14 15:57:56 2022 +0100

    XKBMAlloc: use the correct first-key variable when extending a key range
    
    When extending the range of changed virtual-modifier keys, one should
    pass the two variables relevant to that range.
    
    These two mistakes were found by grepping for 'modmap_key' and then
    looking for asymmetries between the handling of the plain modmap thing
    and the virtual modmap thing.  Inspired by issue #76.
    
    (I suspect these mistakes were at the base of some intractable bugs
    reported against xkeyboard-config where virtual modifiers refused
    to work and had to be worked around by making other changes too.)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit f15d2a01f75304bc2d9dac109d9a5a47d1ce28e0
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Jan 12 11:34:23 2022 +0100

    lcUTF8: remove two unneeded ifs and two elses that are never reached
    
    When there is a break at the end of the while loop, it means that the
    loop will finish the first time that _XlcGetCharSetWithSide() returns
    a non-NULL result, which means that the first '(last_charset == NULL)'
    will always be true and the else part is redundant.
    
    Fixes issue #46.
    
    Reported-by: Bhavi Dhingra
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 033f37d507801645a8251fd33c25ebd145d22cce
Author: Antti Savolainen <antti.savo@gmail.com>
Date:   Wed Jan 12 16:10:21 2022 +0000

    nls: add two compose sequences for an upwards arrow using dead_circumflex
    
    Signed-off-by: Antti Savolainen <antti.savo@gmail.com>

commit b7d724df615311c35418afc733e1fcc68c740aba
Author: Hodong <hodong@nimfsoft.com>
Date:   Fri Jan 7 10:41:15 2022 +0000

    specs/XIM: fix a missing "EXT" in the documentation
    
    There was an "EXT" in the original text, but it seems to be missing.
    
    See: https://gitlab.freedesktop.org/xorg/lib/libx11/-/blob/4e66da0783b2e5e3b288aaecd3c89396ed425c20/specs/XIM/xim.ms#L693
    
    Signed-off-by: Hodong Kim <hodong@nimfsoft.com>

commit 4c96f3567a8d045ee57b886fddc9618b71282530
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Dec 9 19:51:52 2021 -0800

    libX11 1.7.3.1
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c1710589bb00d6f442a383fc41f0d6496b436c88
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Dec 7 08:29:43 2021 -0800

    specs/XIM: Fix "encording" typos
    
    Fixes: #145
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e30771b4bbdd84fc7ff64a1cda483a46edb5707b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Dec 6 17:04:14 2021 -0800

    libX11 1.7.3
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 934417b1e89fe715b9cf6c0d62a3867fa1f5bccb
Author: Liang Chang <l-chang@users.sourceforge.net>
Date:   Tue Sep 7 18:54:10 2021 +0800

    Make Xutf8DrawString works correctly with ISO10646 fonts.
    
    Signed-off-by: Liang Chang <l-chang@users.sourceforge.net>

commit 3ad36c5d3ddca3e4c97faaf87b72a53954d1f473
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Dec 2 17:48:55 2021 -0800

    Build xz tarballs instead of bzip2
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 93a050c3ad2d2264d3880db3791387b1a9bf2e9e
Author: Tatu Frisk <tatu.frisk@ge.com>
Date:   Tue Mar 14 14:41:27 2017 +0200

    Fix hanging issue in _XReply
    
    Assume event queue is empty if another thread is blocking waiting for event.
    
    If one thread was blocking waiting for an event and another thread sent a
    reply to the X server, both threads got blocked until an event was
    received.
    
    Signed-off-by: Tatu Frisk <tatu.frisk@ge.com>
    Signed-off-by: Jose Alarcon <jose.alarcon@ge.com>

commit 8382253010267b93c9aeffc769e3f5e43d698094
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Mon Aug 30 21:47:09 2021 +0200

    Avoid NULL pointer deref. Fixes issue #47.
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 58d7b540c453601faf942c6f19f8277a5c5f78cc
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 1 14:31:16 2021 +1000

    gitlab CI: update to use the ci-fairy image
    
    Let's use the pre-prepared image instead of building our own.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 150154c994829f9f3734a560f99f70b21d86b49c
Author: Hodong <hodong@nimfsoft.com>
Date:   Sun Nov 14 06:36:42 2021 +0000

    Fix a typo

commit 2356e59ff24f8d1b25cdc4dffc5171c65dc2b86e
Author: Igor V. Kovalenko <igor.v.kovalenko@gmail.com>
Date:   Sun Sep 5 10:25:38 2021 +0300

    libX11: do not crash in GetResReq() macro
    
    When _XGetRequest() detects that requested length exceeds remaining display
    output buffer capacity it would return NULL. GetResReq() macro obtains "req"
    pointer from a call to _XGetRequest() and then proceeds to assign request id
    through "req" pointer which leads to NULL pointer dereference in this case.
    
    Fix this by checking if "req" is valid before assigning request id.
    
    Signed-off-by: Igor V. Kovalenko <igor.v.kovalenko@gmail.com>

commit e92efc63acd7b377faa9e534f4bf52aaa86be2a9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 27 11:46:19 2021 +1000

    makekeys: handle the new _EVDEVK xorgproto symbols
    
    These keys are all defined through a macro in the form:
       #define XF86XK_BrightnessAuto                _EVDEVK(0x0F4)
    
    The _EVDEVK macro is simply an offset of 0x10081000.
    Let's parse these lines correctly so those keysyms end up in our
    hashtables.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d01d23374107f6fc55511f02559cf75be7bdf448
Author: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>
Date:   Wed Jun 16 12:17:04 2021 +0100

    Avoid undefined behaviour after realloc()
    
    Adding the offset between the realloc result and the old allocation to
    update pointers into the new allocation is undefined behaviour: the
    old pointers are no longer valid after realloc() according to the C
    standard. While this works on almost all architectures and compilers,
    it causes  problems on architectures that track pointer bounds (e.g.
    CHERI or Arm's Morello): the value_list pointers will still have the
    bounds of the previous allocation and therefore any dereference will
    result in a run-time trap.
    
    I found this due to a crash (dereferencing an invalid capability) while
    trying to run `xev` over SSH on a CHERI-RISC-V system. With these two
    realloc changes, and https://gitlab.freedesktop.org/xorg/proto/xorgproto/-/merge_requests/41
    I am able to succesfully run `xev` compiled for CHERI-RISC-V.
    
    Signed-off-by: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>

commit 1c845834a32421abb59408aee259ac0bef054d30
Author: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>
Date:   Tue Jun 15 08:46:53 2021 +0100

    Fix cross-compilation from macOS
    
    We can't use `LC_CTYPE=C sed` there since /usr/bin/sed is not compatible
    with the expressions in nls/ (`sed: RE error: illegal byte sequence`).
    To fix this use $(SED) instead which autotools will set to a GNU
    version of sed (usually /usr/local/bin/gsed) on macOS.
    
    Signed-off-by: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>

commit 401f58f8ba258d4e7ce56a8f756595b72e544c15
Author: Lev Korol <epicatsupercell@gmail.com>
Date:   Sun Apr 11 21:57:45 2021 +0300

    nls: Add en_IL locale
    
    Signed-off-by: Lev Korol <epicatsupercell@gmail.com>

commit f906fe8e9769e4313294b68e61c402610ade69da
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jun 5 09:12:13 2021 -0700

    libX11 1.7.2
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 51b73ac0acda65005c8a9f17ca4ea7281b00ca84
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Sun May 23 15:05:17 2021 +0200

    Protect against overly long strings
    
    Checking against upper limit of USHRT_MAX must happen before truncating
    size_t to int. On 64 bit systems with strings larger than 2 GB this
    could otherwise lead to negative ints or ints smaller than USHRT_MAX.
    
    In XParseColor this could lead to out of boundary access with strings
    starting with a # (color sequence). A modulo 12 operation is performed
    to validate the string length, but with an overflown length, the for
    loop would eventually read behind terminating '\0' character.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>

commit ab2f59530b16bdfbf023b8e025c7c8aba3b6fd0c
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Sun May 30 16:33:48 2021 +0200

    Check for NULL strings before getting their lengths
    
    Problem reported by Karsten Trulsen
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit a8216e8653a246db664e1443ecf707b27de65067
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Sat May 22 17:35:47 2021 +0200

    include <limits.h> always, not if HAVE_CONFIG_H is set.
    
    via Matthew Green from the NetBSD project
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 6953a586df4819143c4d55e011b3a5e5377981b8
Author: Matthieu Herrb <matthieu.herrb@laas.fr>
Date:   Tue May 18 15:27:58 2021 +0200

    Version 1.7.1
    
    Release notes in README.md, version bump in configure.ac

commit 8d2e02ae650f00c4a53deb625211a0527126c605
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Fri Feb 19 15:30:39 2021 +0100

    Reject string longer than USHRT_MAX before sending them on the wire
    
    The X protocol uses CARD16 values to represent the length so
    this would overflow.
    
    CVE-2021-31535
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 838ea5a5a0267c25b20c095c9a70684edeeefba4
Author: Gaurav Ujjwal <gujjwal00@gmail.com>
Date:   Sun May 9 05:04:36 2021 +0000

    Fix out-of-bound access in KeySymToUcs4()
    
    Array `keysym_to_unicode_590_5fe` is only valid for range  [0x590, 0x5fe] but current lower-bound is checked against 0x589.
    
    So invalid values from 0x58a to 0x58f are being allowed by current check.
    
    If any of these invalid value is passed as `keysym`,    `keysym - 0x590` would underflow.
    
    Signed-off-by: Gaurav Ujjwal <gujjwal00@gmail.com>

commit 32491b02c76ac22f99dc433a32466e22bdc181a7
Author: Christopher Chavez <chrischavez@gmx.us>
Date:   Mon May 3 15:46:44 2021 +0000

    Xlib.h: spelling fix in comment

commit 5faa8dc0b364f55f19034c370436074646d9ad54
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Tue Nov 24 18:54:24 2020 +0100

    nls: adjust three comments about the APL compose sequences
    
    Commit 0bbc0d5e605e (from eight years ago) removed the lines that two
    of these comments referred to.  Without those lines, the comments don't
    make sense any more.  Reword and shorten them.
    
    Also reword a comment about two sequences that don't work.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit b126bfd7fe990b8c1df088f55c31d9b3fd440cde
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Tue Nov 24 12:23:32 2020 +0100

    nls: allow composing all breved letters also with a lowercase "u"
    
    The letters ă and ŭ can already be composed with "u a" and "u u", but
    ĕ, ğ, ĭ, and ŏ can be composed only with an uppercase U.  Emancipate
    the latter four and understand also a lowercase "u" to mean 'breve'.
    
    (Yesterday I needed ğ and was annoyed that "u g" did not work.)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 78027fdb7aa07621a3b7cdf37050bae39012f2fb
Author: Walter Harms <wharms@bfs.de>
Date:   Sat Nov 28 21:05:33 2020 +0100

    fix same roff code
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit 4f15cfc64548098fef3ddd24f7359b76cf1bbda7
Author: Walter Harms <wharms@bfs.de>
Date:   Sat Nov 28 20:56:35 2020 +0100

    Fix some roff code add see also
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit daa106927f78e6c5c9c36558a4b951d7cb58a8d1
Author: Walter Harms <wharms@bfs.de>
Date:   Sat Nov 28 17:49:25 2020 +0100

    fix broken nroff coding for code comments
    
    the comments /* */ are code as /\(**  */ that does not work.
    the coding in other X11 man pages is /\&* */ so we do the same here.

commit 7bdeae239b17db002964ac73d06f43f216d1cf86
Author: Walter Harms <wharms@bfs.de>
Date:   Fri Nov 27 22:43:21 2020 +0100

    FIX: warning: macro `hN' not defined
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit b7ec67d3ea78ab68857328d8f72d923324e68cc2
Author: Walter Harms <wharms@bfs.de>
Date:   Fri Nov 27 22:26:15 2020 +0100

    FIX: warning: macro `IN' not defined
    
    just remove an other dead macro use.

commit 7ca3ceb9175a829a40c347cb3b2e98341ec5a2df
Author: Walter Harms <wharms@bfs.de>
Date:   Fri Nov 27 21:58:04 2020 +0100

    fix warning: macro `s' not defined
    
    this is caused by bad nroff coding, fix some more issues on the fly

commit 14fb4e535626ba934cad5bc4308f511524cd1103
Author: Walter Harms <wharms@bfs.de>
Date:   Fri Nov 27 20:04:22 2020 +0100

    FIX: warning: macro `hN' not defined
    
    this was found by checking man pages with
     groff -t -mandoc -Z  -wmac -Tutf8 $FILE >/dev/null
    
    In most cases .hN could be replaced with .BR
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit cb03da4447aa53e8e5382f124917d89b50148036
Author: Walter Harms <wharms@bfs.de>
Date:   Fri Nov 27 19:00:00 2020 +0100

    FIX: warning: macro `Pn' not defined
    
    The missing macro is found via:
    roff -t -mandoc -Z  -wmac -Tutf8 XAnyEvent.man >/dev/null
    
    To fix the problem the macro is replaced with .RB.
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit cc9f8878f2cbe17c7b4035b4ff4352b52ece38e0
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Wed Nov 25 16:58:27 2020 +0100

    nls: add 'C.utf8' as an alias for 'en_US.UTF-8'
    
    The normal form is 'C.UTF-8', but 'C.utf8' has been seen in the wild.
    
    Fixes #102.
    
    Reported-by: Tomas Korbar
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit ca8115186f810eccb7d86b0979980eff3ba95f0b
Author: Keith Packard <keithp@keithp.com>
Date:   Thu Nov 19 11:30:41 2020 -0800

    Version 1.7.0
    
    Release notes in README.md, version bump in configure.ac
    
    Signed-off-by: Keith Packard <keithp@keithp.com>

commit 325ac177fb6d38f4c7689d9ce059792eaef388ef
Author: Keith Packard <keithp@keithp.com>
Date:   Mon Nov 16 15:48:40 2020 -0800

    Update libX11 .so version to 6.4.0
    
    There have been API additions since the previous release, so the
    .so version needs to change.
    
    Signed-off-by: Keith Packard <keithp@keithp.com>

commit 103e2e11519984aa5746c06e7d90d1f5bc8174a3
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Oct 31 09:24:01 2020 -0700

    Don't leave dangling pointers in Free functions
    
    While these are mostly called during teardown of larger structures
    that are about to themselves be freed, there's no guarantee that
    will always be the case, so try to be safer here.
    
    [ This bug was found by the Parfait 4.0 bug checking tool.
      http://labs.oracle.com/pls/apex/f?p=labs:49:::::P49_PROJECT_ID:13 ]
    
    v2: Deduplicate & simplify pointer clearing in _XFreeEventCookies
        as suggested by @keithp
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7d70e302218e2ec8518548ddcdc02d828e7889af
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Oct 31 08:56:34 2020 -0700

    XimProto.h: wrap XIM_HEADER_SIZE definition in parens
    
    Resolves parfait warning of potential macro misinterpretation if
    expanded in the midst of other arithmetic operations with higher
    precedence.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a3c0b5dbd6b12ae64bc78b11795647a7f6df0c7a
Author: Keith Packard <keithp@keithp.com>
Date:   Tue Nov 17 13:15:18 2020 -0800

    Copy locale modifiers when creating XimInstCallback [v2]
    
    Locale modifiers may be freed whenever XSetLocaleModifiers gets
    called, even if the locale hasn't changed. This means that we cannot
    save a pointer to those modifiers in the XimInstCallback record and
    must, instead, make a copy of them instead.
    
    This fixes a problem uncovered when running wish under libasan as
    follows (on current Debian unstable):
    
            $ LD_PRELOAD=/usr/lib/x86_64-linux-gnu/libasan.so.6 wish
    
    Reported-by: Vittorio Zecca <zeccav@gmail.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    
    v2:
            Remove incorrect 'else' token found by @alanc

commit 960e2e0cfac12c3477c672d0d40818a0dc74aca5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Nov 16 09:34:57 2020 +1000

    gitlab CI: add a basic build test
    
    Using Arch as base distribution here because we can expect our dependencies to
    be up-to-date. We rely on the Arch for our dependencies rather than building
    those from git (notably: xorg-macros, xtrans and libxcb).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dbb55e1a5e82870466b095097d9e46046680ec25
Author: Frediano Ziglio <fziglio@redhat.com>
Date:   Wed Jan 29 09:06:54 2020 +0000

    Fix poll_for_response race condition
    
    In poll_for_response is it possible that event replies are skipped
    and a more up to date message reply is returned.
    This will cause next poll_for_event call to fail aborting the program.
    
    This was proved using some slow ssh tunnel or using some program
    to slow down server replies (I used a combination of xtrace and strace).
    
    How the race happens:
    - program enters into poll_for_response;
    - poll_for_event is called but the server didn't still send the reply;
    - pending_requests is not NULL because we send a request (see call
      to  append_pending_request in _XSend);
    - xcb_poll_for_reply64 is called from poll_for_response;
    - xcb_poll_for_reply64 will read from server, at this point
      server reply with an event (say sequence N) and the reply to our
      last request (say sequence N+1);
    - xcb_poll_for_reply64 returns the reply for the request we asked;
    - last_request_read is set to N+1 sequence in poll_for_response;
    - poll_for_response returns the response to the request;
    - poll_for_event is called (for instance from another poll_for_response);
    - event with sequence N is retrieved;
    - the N sequence is widen, however, as the "new" number computed from
      last_request_read is less than N the number is widened to N + 2^32
      (assuming last_request_read is still contained in 32 bit);
    - poll_for_event enters the nested if statement as req is NULL;
    - we compare the widen N (which now does not fit into 32 bit) with
      request (which fits into 32 bit) hitting the throw_thread_fail_assert.
    
    To avoid the race condition and to avoid the sequence to go back
    I check again for new events after getting the response and
    return this last event if present saving the reply to return it
    later.
    
    To test the race and the fix it's helpful to add a delay (I used a
    "usleep(5000)") before calling xcb_poll_for_reply64.
    
    Original patch written by Frediano Ziglio, see
    https://gitlab.freedesktop.org/xorg/lib/libx11/-/merge_requests/34
    
    Reworked primarily for readability by Peter Hutterer, see
    https://gitlab.freedesktop.org/xorg/lib/libx11/-/merge_requests/53
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 30ccef3a48029bf4fc31d4abda2d2778d0ad6277
Author: Keith Packard <keithp@keithp.com>
Date:   Sat Nov 7 22:22:47 2020 -0800

    Avoid recursing through _XError due to sequence adjustment
    
    This patch is based on research done by Dmitry Osipenko to uncover the
    cause of a large class of Xlib lockups.
    
    _XError must unlock and re-lock the display around the call to the
    user error handler function. When re-locking the display, two
    functions are called to ensure that the display is ready to generate a request:
    
        _XIDHandler(dpy);
        _XSeqSyncFunction(dpy);
    
    The first ensures that there is at least one XID available to use
    (possibly calling _xcb_generate_id to do so). The second makes sure a
    reply is received at least every 65535 requests to keep sequence
    numbers in sync (possibly generating a GetInputFocus request and
    synchronously awaiting the reply).
    
    If the second of these does generate a GetInputFocus request and wait
    for the reply, then a pending error will cause recursion into _XError,
    which deadlocks the display.
    
    One seemingly easy fix is to have _XError avoid those calls by
    invoking InternalLockDisplay instead of LockDisplay. That function
    does everything that LockDisplay does *except* call those final two
    functions which may end up receiving an error.
    
    However, that doesn't protect the system from applications which call
    some legal Xlib function from within their error handler. Any Xlib
    function which cannot generate protocol or wait for events is valid,
    including many which invoke LockDisplay.
    
    What we need to do is make LockDisplay skip these two function calls
    precisely when it is called from within the _XError context for the
    same display.
    
    This patch accomplishes this by creating a list of threads in the
    display which are in _XError, and then having LockDisplay check the
    current thread against those list elements.
    
    Inspired-by: Dmitry Osipenko <digetx@gmail.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    Tested-by: Dmitry Osipenko <digetx@gmail.com>
    Reviewed-by: Dmitry Osipenko <digetx@gmail.com>

commit c9c4d6efbf92ab51695e2e740319503221d68eed
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Nov 13 11:34:04 2020 +0100

    nls: improve the comments for the Serbian compose sequences
    
    Also put an extra space before the lone combining characters
    so they have some room to breathe.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 3497dae3d9c52a252110b2a0983b82000be0fe8e
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Nov 13 11:23:09 2020 +0100

    nls: remove mistaken Serbian compose sequences with combining diacritics
    
    Combining characters are not dead keys -- they have an immediate effect
    and combine with the preceding character.  So they cannot be used in
    compose sequences.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 5cd60398b7787297008b13a848ed3cfbd7ef178d
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Mon Nov 2 16:34:39 2020 +0100

    nls: rename the obsolete sr_CS locale to sr_RS
    
    Fixes #107, for the most part.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 7cf1729590534e257b851899cf03421b65c538e3
Author: Keith Packard <keithp@keithp.com>
Date:   Sat Nov 7 17:02:56 2020 -0800

    Don't attempt to unload locale context data
    
    Most locale context users call _XlcCurrentLC, which returns a pointer
    which never needs to be passed to _XCloseLC, meaning it has unbounded
    lifetime, so that locale data can never be freed.
    
    Remove all reference counting and just leave all locales that were
    ever used in memory.
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>

commit 87a8fd8051b823636c3c4f3c37c4cfd11fdb880d
Author: Jacek Caban <jacek@codeweavers.com>
Date:   Mon Aug 14 19:20:19 2017 +0200

    Don't cache last lcd in _XlcCurrentLC.
    
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=55678
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=68538
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=69088
    
    The way it's currently cached is not thread safe. As long as locale doesn't change, the same object is reused anyway.
    
    Signed-off-by: Jacek Caban <jacek@codeweavers.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>

commit 7a38c09b82ee2522d987c3da4af8af186e562c61
Author: Keith Packard <keithp@keithp.com>
Date:   Sat Nov 7 16:59:37 2020 -0800

    Don't cache converters in _Xlcmbtowc and Xlcwctomb
    
    These functions were caching encoding conversion functions in static
    variables which is not thread safe. Let the conversion loader do its
    job and cache locale to converters there. It's less efficient, but
    it's also (now) thread safe.
    
    Signed-off-by: Keith Packard <keithp@keithp.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>

commit b52ba5c209165fc2c533b77b86147b31763299f3
Author: Jacek Caban <jacek@codeweavers.com>
Date:   Mon Aug 14 19:20:20 2017 +0200

    Make conv_list thread safe.
    
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=55678
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=68538
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=69088
    Signed-off-by: Jacek Caban <jacek@codeweavers.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>

commit 8b5ce3a9b1219c81711944880e5a1e1cfad3d956
Author: Antti Savolainen <antti.savo@gmail.com>
Date:   Wed Sep 16 07:47:26 2020 +0000

    Added DOWNWARD ARROW support

commit 7138826dccba9d538dfb142ce9af1a40d64ea849
Author: Antti Savolainen <antti.savo@gmail.com>
Date:   Tue Sep 8 00:54:23 2020 +0300

    Added support for UPWARDS ARROW and ALMOST EQUAL TO
    
    Signed-off-by: Antti Savolainen <antti.savo@gmail.com>

commit 56d59299f7433cdeb88bac970b06eb7df44df5bb
Author: Jonathan Belsewir <jonbel@jonasund.de>
Date:   Thu Nov 5 22:57:50 2020 +0000

    Add less and greater to characters that are difficult to access on some keyboards

commit 5caf45f8d3bebad5b72ac88545adc156ccfd754d
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Fri Oct 23 17:12:22 2020 +0200

    nls: Allow all letters with a caron to be composed also with v.
    
    It was strange that the accented letters Ž and ž can be composed with
    sequences that start with "v" ("v Z" and "v z"), but not Č and č and
    Š and š (and other letters with a caron).  For these letters, compose
    sequences that start with a "c" had to be used, which was frustrating
    because it is hard to remember that "c" stands for "caron", AND the
    graphically more obvious "v" is right next to it.
    
    (Unfortunately, the sequence "v l" is already taken for vertical line.
    Maybe the compose sequences for vertical line could be reduced to just
    "V L" and "L V"?)
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 62de4ac9025e2cb3f62a890241c06ebc75acce62
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Nov 1 20:23:55 2020 +0100

    nls: vertically align the target column of aliases
    
    Also improve the grammar of the initial comment.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit f5b26a16ef959fc6860e9cf58b97a042600900b4
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Nov 1 20:17:05 2020 +0100

    nls: remove some twenty aliases that have been obsolete for fifteen years
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 3e61f3b49660e081108f06bc514366f1784cb2e0
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Nov 1 19:50:56 2020 +0100

    nls: remove country-specific aliases for two constructed languages
    
    These artificial languages are meant to be international and are
    thus not specific to any country.  If one would want to support
    aliases like ia_FR or ia_CH, then one would also have to support
    ia_AU, ia_DE, ia_ES, et cetera, et cetera.  That would be silly.
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 3f9c43adde22bb2ab4bef5837bc8401af9bb537c
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Sun Nov 1 17:28:24 2020 +0100

    nls: remove four aliases where the name is identical to the definition
    
    They were found with:
    
        while read one two; do
            if [[ $one == $two: ]]; then echo $two; fi;
        done  <nls/locale.alias.pre
    
    Signed-off-by: Benno Schulenberg <bensberg@telfort.nl>

commit 9f9c5365816bdd036fd80d54b22e86764ea4b7a7
Author: Carlos Garnacho <carlosg@gnome.org>
Date:   Fri Jun 14 17:55:14 2019 +0200

    Add XSetIOErrorExitHandler() function
    
    This function complements XSetIOErrorHandler(), allowing to override
    the default behavior that trusts on I/O errors never coming back
    (i.e. exit()ing the process).
    
    This is meant as a mechanism for Wayland compositors (that are too
    a X11 client + compositing manager) to unfasten seatbelts and jump
    through the car window. It might get lucky and land on a stack of
    pillows.
    
    In consequence, some functions labeled as _X_NORETURN can as a
    matter of fact return. So those hints were removed.
    
    Signed-off-by: Carlos Garnacho <carlosg@gnome.org>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 4cb758019e374fa7c022fe79d28444e13441717b
Author: Carlos Garnacho <carlosg@gnome.org>
Date:   Fri Jun 14 17:54:47 2019 +0200

    Prepare for _XIOError() possibly returning
    
    Ensure current state is cut short on _XIOError(), possible reentrancy
    should be skipped through the XlibDisplayIOError flag checks.
    
    Signed-off-by: Carlos Garnacho <carlosg@gnome.org>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit a37986f7a7d4ae9b8292b132dbb0da2885ea919c
Author: Ross Burton <ross.burton@intel.com>
Date:   Wed Jan 22 17:11:23 2020 +0000

    cpprules.in: squash whitespace in generated files
    
    CPP is used to generate files, but as cpp reads files from the build host the
    output has a number of blank lines at the beginning which varies depending on
    what GCC and friends is used.
    
    Pathalogical example:
    
     $ cpp -undef -traditional /dev/null
     # 1 "/dev/null"
     # 1 "<built-in>"
     # 1 "<command-line>"
     # 31 "<command-line>"
     # 1 "/usr/include/stdc-predef.h" 1 3 4
    
     # 17 "/usr/include/stdc-predef.h" 3 4
    
     [ 40 blank line ]
    
     # 32 "<command-line>" 2
     # 1 "/dev/null"
    
    So depending on the content of stdc-predef.h and what other headers CPP will
    load, the amount of whitespace in the generates files varies. This can result in
    differences in reproducible environments, and file conflicts in multilib
    environments.
    
    As whitespace is irrelevant to these machine-readable files, extend the sed to
    just delete blank lines.

commit 16192ce2a7e462e09f95aa45ce9eaa180e483c43
Author: Carmina16 <mistresssilvara@hotmail.com>
Date:   Sun Jun 16 02:54:25 2019 +0000

    Adding ia and ie locales

commit caa71668af7fd3ebdd56353c8f0ab90824773969
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Sep 28 16:16:07 2020 -0700

    Use __builtin_popcountl if available to replace Ones() in GetImage.c
    
    If the compiler knows of a better algorithm for counting the number of
    bits set in a word for the target CPU, let it use that, instead of the
    classic algorithm optimized for PDP-6.
    
    Based on libXext commit 490a25e6f8a4d2482af4364c700b68ad11a4d10b
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 1a9269a95c353e3de9f4d33bab9f1363d84e79db
Author: Krzesimir Nowak <qdlacz@gmail.com>
Date:   Mon Jun 1 12:58:30 2020 +0000

    Fix leaking modifiers string.
    
    Reported by valgrind:
    
    ```
    ==118175== 17 bytes in 1 blocks are definitely lost in loss record 13 of 1,675
    ==118175==    at 0x483A809: malloc (vg_replace_malloc.c:307)
    ==118175==    by 0x5CD1B46: _XlcDefaultMapModifiers (in /usr/lib64/libX11.so.6.3.0)
    ==118175==    by 0x5CD1F1A: XSetLocaleModifiers (in /usr/lib64/libX11.so.6.3.0)
    ==118175==    by 0x496841C: X11_InitKeyboard (SDL_x11keyboard.c:324)
    ==118175==    by 0x496F0CA: X11_VideoInit (SDL_x11video.c:455)
    ==118175==    by 0x494747B: SDL_VideoInit_REAL (SDL_video.c:532)
    ==118175==    by 0x489E886: SDL_InitSubSystem_REAL (SDL.c:206)
    ==118175==    by 0x402634: main (fade.cc:35)
    ```

commit d127217f26df1bf7566c1f372d8b5329a06754ea
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 16 17:03:24 2020 -0700

    Exempt XLookupKeysym from XKeycodeToKeysym deprecation warnings
    
    Gets rid of:
    src/xkb/XKBBind.c: In function ‘XLookupKeysym’:
    src/xkb/XKBBind.c:234:5: warning: ‘XKeycodeToKeysym’ is deprecated
    [https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wdeprecated-declarations-Wdeprecated-declarations]
      234 |     return XKeycodeToKeysym(dpy, event->keycode, col);
          |     ^~~~~~
    src/xkb/XKBBind.c:96:1: note: declared here
       96 | XKeycodeToKeysym(Display *dpy,
          | ^~~~~~~~~~~~~~~~
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a64eb5f478c6ca84ef3457a01f9a7c3db8ecf1e5
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 16 16:50:43 2020 -0700

    lcUTF8: Increase string buffer size from 20 to 32 bytes
    
    While we don't expect large enough ints to need it, we don't
    enforce a maximum size, so gcc assumes the worst and warns:
    
    ../../../src/xlibi18n/lcUTF8.c: In function ‘create_tofontcs_conv’:
    ../../../src/xlibi18n/lcUTF8.c:1736:34: warning: ‘.charset.name’ directive output may be truncated writing 13 bytes into a region of size between 8 and 17 [-Wformat-truncation=]
     1736 |  snprintf(buf, sizeof(buf), "fs%d.charset.name", i);
          |                                  ^~~~~~~~~~~~~
    ../../../src/xlibi18n/lcUTF8.c:1736:2: note: ‘snprintf’ output between 17 and 26 bytes into a destination of size 20
     1736 |  snprintf(buf, sizeof(buf), "fs%d.charset.name", i);
          |  ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../../../src/xlibi18n/lcUTF8.c:1739:46: warning: ‘snprintf’ output may be truncated before the last format character [-Wformat-truncation=]
     1739 |      snprintf(buf, sizeof(buf), "fs%d.charset", i);
          |                                              ^
    ../../../src/xlibi18n/lcUTF8.c:1739:6: note: ‘snprintf’ output between 12 and 21 bytes into a destination of size 20
     1739 |      snprintf(buf, sizeof(buf), "fs%d.charset", i);
          |      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../../../src/xlibi18n/lcUTF8.c:1754:41: warning: ‘.charset.name’ directive output may be truncated writing 13 bytes into a region of size between 8 and 17 [-Wformat-truncation=]
     1754 |         snprintf(buf, sizeof(buf), "fs%d.charset.name", i);
          |                                         ^~~~~~~~~~~~~
    ../../../src/xlibi18n/lcUTF8.c:1754:9: note: ‘snprintf’ output between 17 and 26 bytes into a destination of size 20
     1754 |         snprintf(buf, sizeof(buf), "fs%d.charset.name", i);
          |         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../../../src/xlibi18n/lcUTF8.c:1757:53: warning: ‘snprintf’ output may be truncated before the last format character [-Wformat-truncation=]
     1757 |             snprintf(buf, sizeof(buf), "fs%d.charset", i);
          |                                                     ^
    ../../../src/xlibi18n/lcUTF8.c:1757:13: note: ‘snprintf’ output between 12 and 21 bytes into a destination of size 20
     1757 |             snprintf(buf, sizeof(buf), "fs%d.charset", i);
          |             ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 54925250ad9c825bea671dcade5c913bad88abee
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 16 16:33:59 2020 -0700

    i18n: use memcpy instead of strncpy on unterminated char arrays
    
    Avoids gcc warnings that we're using strncpy wrong to copy a known-length
    set of characters without a terminating '\0' to a buffer whose length we
    are checking separately.  (Should also be imperceptibly faster since we
    no longer check if each byte is '\0' when we already know it won't be.)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 8754868dbbbc5fa096282df0504aa7880488eeb9
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 16 16:02:01 2020 -0700

    Mark FreeBlueTblElements label unused in LRGB.c
    
    Quiets gcc 10.2 warning of:
    src/xcms/LRGB.c: In function ‘LINEAR_RGB_InitSCCData’:
    src/xcms/LRGB.c:798:1: warning: label ‘FreeBlueTblElements’ defined
     but not used
    [https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wunused-label-Wunused-label]
      798 | FreeBlueTblElements:
          | ^~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 52b0cd67073f2f4665884b5a7decfedeb3b7ca1e
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 16 14:54:47 2020 -0700

    Raise minimum required xproto version to 7.0.25 (released 2013-11-23)
    
    Allows us to depend on _X_COLD directly instead of having to check for it.
    
    (Since we also use _X_UNUSED, 7.0.22 or later was implicitly required
     already but not checked for.)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit deafb99fd8faf8b044eaee13d072440ce4db76af
Author: Maya Rashish <maya@NetBSD.org>
Date:   Sun Aug 23 21:19:33 2020 +0300

    Avoid the use of "register" keyword in public headers.
    
    This causes issues when compiling code for C++17.

commit 505420662577749e36640db48f6b6b9ae0236e09
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Mon Aug 24 15:42:25 2020 +0200

    libX11 1.6.12
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit acdaaadcb3d85c61fd43669fc5dddf0f8c3f911d
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Thu Aug 13 18:02:58 2020 +0200

    Fix an integer overflow in init_om()
    
    CVE-2020-14363
    
    This can lead to a double free later, as reported by Jayden Rivers.
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit d15c24c8b44be5e4054c8ecd0ff9dcf2c8e18e5b
Author: Niclas Zeising <zeising@daemonic.se>
Date:   Tue Aug 11 13:44:38 2020 +0200

    Fix input clients connecting to server
    
    Fix a bug where some input clients can't connect to the input server.
    This fixes #117.
    
    FreeBSD bugzilla reference:
    https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=248549
    
    Signed-off-by: Niclas Zeising <zeising@daemonic.se>

commit 6dd618e5ea8e7558dd8e99a2777ab7b69211789c
Author: Maya Rashish <maya@NetBSD.org>
Date:   Sat Aug 15 00:48:56 2020 +0300

    Avoid the use of "register" keyword in XkbTranslateKeySym.
    
    This causes issues when compiling code for C++17.
    While here, make function prototype match the header with regards
    to removal of another register keyword.

commit 780d222343098b4bfe3ec529b4a0dc2aadea19bf
Author: Christopher Chavez <chrischavez@gmx.us>
Date:   Mon Aug 10 17:08:39 2020 +0000

    Fix typo GCCLipYOrigin -> GCClipYOrigin in XCreateGC() manpage

commit 29a8251a456bb7dc10146b4713f499a624d6dacd
Author: Felix Yan <felixonmars@archlinux.org>
Date:   Thu Aug 6 16:03:38 2020 +0000

    Correct a typo in GetStCmap.c

commit 0d8f038db83f68724a84ef9d4ccd0d5e33ec6a70
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Aug 6 08:07:57 2020 -0700

    libX11 1.6.11
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 93fce3f4e79cbc737d6468a4f68ba3de1b83953b
Author: Yichao Yu <yyc1992@gmail.com>
Date:   Sun Aug 2 13:43:58 2020 -0400

    Fix size calculation in `_XimAttributeToValue`.
    
    The check here guards the read below.
    For `XimType_XIMStyles`, these are `num` of `CARD32` and for `XimType_XIMHotKeyTriggers`
    these are `num` of `XIMTRIGGERKEY` ref[1] which is defined as 3 x `CARD32`.
    (There are data after the `XIMTRIGGERKEY` according to the spec but they are not read by this
    function and doesn't need to be checked.)
    
    The old code here used the native datatype size instead of the wire protocol size causing
    the check to always fail.
    
    Also fix the size calculation for the header (size). It is 2 x CARD16 for both types
    despite the unused `CARD16` for `XimType_XIMStyles`.
    
    [1] https://www.x.org/releases/X11R7.6/doc/libX11/specs/XIM/xim.html#Input_Method_Styles
    
    This fixes a regression caused by 388b303c62aa35a245f1704211a023440ad2c488 in 1.6.10.
    
    Fix #116

commit 9949364ea761ab7efa2a9930ec7718f966a740c0
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Thu Jul 30 21:36:22 2020 +0200

    libX11 1.6.10
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 1703b9f3435079d3c6021e1ee2ec34fd4978103d
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Fri Jul 24 21:09:10 2020 +0200

    Change the data_len parameter of _XimAttributeToValue() to CARD16
    
    It's coming from a length in the protocol (unsigned) and passed
    to functions that expect unsigned int parameters (_XCopyToArg()
    and memcpy()).
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    Reviewed-by: Todd Carson <toc@daybefore.net>

commit 1a566c9e00e5f35c1f9e7f3d741a02e5170852b2
Author: Todd Carson <tc@daybefore.net>
Date:   Fri Jul 24 20:59:32 2020 +0200

    Zero out buffers in functions
    
    It looks like uninitialized stack or heap memory can leak
    out via padding bytes.
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 2fcfcc49f3b1be854bb9085993a01d17c62acf60
Author: Todd Carson <tc@daybefore.net>
Date:   Fri Jul 24 20:22:44 2020 +0200

    Fix more unchecked lengths
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 388b303c62aa35a245f1704211a023440ad2c488
Author: Todd Carson <tc@daybefore.net>
Date:   Fri Jul 24 19:36:51 2020 +0200

    fix integer overflows in _XimAttributeToValue()
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 0e6561efcfaa0ae7b5c74eac7e064b76d687544e
Author: Todd Carson <tc@daybefore.net>
Date:   Fri Jul 24 19:33:30 2020 +0200

    Fix signed length values in _XimGetAttributeID()
    
    The lengths are unsigned according to the specification. Passing
    negative values can lead to data corruption.
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 2b7598221d87049d03e9a95fcb541c37c8728184
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Jul 22 15:19:58 2020 -0700

    Fix spelling/wording issues
    
    Found by using:
        codespell --builtin clear,rare,usage,informal,code,names
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f9e3378ebcfc79ff00591b8617a68e97580a741e
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Sun Jul 19 22:19:24 2020 +0200

    xlibi18n: Fix converting horizline keysyms to UCS
    
    U+23BA - U+23BD are meant to represent the scan lines, and U+2500 is
    unified with scan line 5.
    
    Signed-off-by: Samuel Thibault <samuel.thibault@ens-lyon.org>

commit 4385a84c4a79c1b60bf12839899a1544198de975
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Thu Jun 4 02:19:13 2020 +0200

    Braille: Fix default lookup
    
    cbb59d172 ('Braille: Fix typing quickly') broke the default lookup that
    translates Braille keysym patterns to Braille Unicode patterns since it
    rightfully clears brl_committing, but then we do not have it any more to
    fill brl_committed.
    
    This change saves the committed pattern so we can return it in the
    default lookup.
    
    Signed-off-by: Samuel Thibault <samuel.thibault@ens-lyon.org>

commit fb65b67169105c82c243f265e0f993cf72efdacd
Author: Marko Myllynen <myllynen@redhat.com>
Date:   Fri Feb 28 13:59:36 2020 +0200

    Update Finnish compose sequences for SFS 5966:2019 standard
    
    U0219, U0218, U021B, U021A are now part of the standard.
    
    Fixes #70 which was printed incorrectly in the earlier standard version.

commit 07724ce046348a21cc82a874853b14b9a285df75
Author: Tristan Miller <psychonaut@nothingisreal.com>
Date:   Wed Sep 25 13:34:01 2019 +0200

    Add acute accent compose sequences for Russian vowels.
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/104
    
    Signed-off-by: Tristan Miller <psychonaut@nothingisreal.com>

commit 3ec9264d01a3a66c0fa0145a7c1db06a64be1507
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Sat Apr 25 14:40:54 2020 -0400

    document an ancient performance problem (see Debian #954845).
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 791c93816ce0520d54925b0b3ccbc29823370041
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Sat Apr 25 14:22:11 2020 -0400

    update/correct function prototypes in manpages to match headers
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 844271305a28e87031562dfeb43defbea02960a2
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Apr 21 20:53:35 2020 -0400

    reduce gcc-normal warnings using casts (no object change)
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 53b59ddfc114a55d26e9717a1b4822f1b18c40ca
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Apr 21 18:13:22 2020 -0400

    reduce gcc-normal warnings using casts (no object change)
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 68c72a7341b114277ab232f2499ee3bd035af8a0
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Dec 11 11:53:11 2019 -0500

    Fix XTS regression in XCopyColormapAndFree
    
    XCopyColormapAndFree/5 threw an assertion:
    
        520|4 5 00014017 1 2|Assertion XCopyColormapAndFree-5.(A)
        520|4 5 00014017 1 3|When a colourmap argument does not name a valid colourmap,
        520|4 5 00014017 1 4|then a BadColor error occurs.
        520|4 5 00014017 1 5|METH: Create a bad colourmap by creating and freeing a colourmap.
        520|4 5 00014017 1 6|METH: Call test function using bad colourmap as the colourmap argument.
        520|4 5 00014017 1 7|METH: Verify that a BadColor error occurs.
        520|4 5 00014017 1 8|unexpected signal 6 (SIGABRT) received
        220|4 5 2 15:05:53|UNRESOLVED
        410|4 5 1 15:05:53|IC End
        510|4|system 0: Abandoning testset: caught unexpected signal 11 (SIGSEGV)
    
    More specifically:
    
        lt-XCopyColormapAndFree: xcb_io.c:533: _XAllocID: Assertion `ret != inval_id' failed.
    
    This bug was introduced (by following my advice, d'oh) in:
    
        commit 99a2cf1aa0b58391078d5d3edf0a7dab18c7745d
        Author: Tapani Pälli <tapani.palli@intel.com>
        Date:   Mon May 13 08:29:49 2019 +0300
    
            Protect colormap add/removal with display lock
    
    In that patch we moved the call to _XcmsCopyCmapRecAndFree inside the
    display lock. The problem is said routine has side effects, including
    trying to implicitly create a colormap in some cases. Since we don't run
    the XID handler until SyncHandle() we would see inconsistent internal
    xlib state, triggering the above assert.
    
    Fix this by dropping and re-taking the display lock before calling into
    XCMS.
    
    Reviewed-by: Tapani Pälli <tapani.palli@intel.com>

commit 7f46a38139f66fda734f3a6c445b84ea89c8f310
Author: Alex Henrie <alexhenrie24@gmail.com>
Date:   Wed Jan 1 14:54:06 2020 -0700

    Handle small final sigma in XConvertCase
    
    lowercase: GREEK SMALL LETTER FINAL SIGMA (U+03C2)
    uppercase: GREEK CAPITAL LETTER SIGMA (U+03A3)
    
    This mapping was correct in UCSConvertCase, but the "legacy" mapping
    must also be correct for Caps Lock to work with the final sigma key.
    
    https://gitlab.freedesktop.org/xorg/lib/libx11/issues/5
    
    Signed-off-by: Alex Henrie <alexhenrie24@gmail.com>

commit a48787d3d155c8a09cead345f5055da30c1db537
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 11 14:12:27 2019 +1000

    Handle ssharp in XConvertCase()
    
    lowercase: LATIN SMALL LETTER SHARP S (U+00DF)
    uppercase: LATIN CAPITAL LETTER SHARP S (U+1E9E)
    
    The uppercase sharp s (XK_ssharp) is a relatively recent addition to unicode
    but was added to the relevant keyboard layouts in xkeyboard-config-2.25
    (d1411e5e95c)
    https://gitlab.freedesktop.org/xkeyboard-config/xkeyboard-config/issues/144
    
    Alas, the CapsLock behavior was broken on the finnish layout (maybe others).
    This was due to xkbcomp using XConvertCase() to determine whether a key
    requires the type FOUR_LEVEL_ALPHABETIC or FOUR_LEVEL_SEMIALPHABETIC.
    
    Let's make this function return the right lower/upper symbols for the sharp s
    and hope that the world won't get any worse because of it.
    
    https://gitlab.freedesktop.org/xorg/lib/libx11/issues/110
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b8766a438461e20b5c6f7a6111b703d4cb71501f
Author: Raul Fernandes <rgfernandes@gmail.com>
Date:   Wed Oct 9 18:39:26 2019 +0000

    Use memcmp and memcpy

commit db7cca17ad7807e92a928da9d4c68a00f4836da2
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Oct 9 13:41:29 2019 -0400

    libX11 1.6.9
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit f5ba2c632a4c84279bdd48c687271292f5dc4f87
Author: Dmitry Osipenko <digetx@gmail.com>
Date:   Sat May 18 19:10:32 2019 +0300

    Fix lockup in _XReply() caused by recursive synchronization
    
    This patch is based on a suggestion made by Uli Schlachter in a comment
    to the bug report https://gitlab.freedesktop.org/xorg/lib/libx11/issues/93.
    
    Explanation of the bug (given by Uli Schlachter as well):
    
    An error was received and handled. Since there was an error callback set,
    Xlib unlocks the display, runs the error callback, and then locks the display
    again. This goes through _XLockDisplay and then calls _XSeqSyncFunction.
    On this "lock the thing"-path, Xlib notices that sequence numbers are close to
    wrap-around and tries to send a GetInputFocus request. However, the earlier
    calls already registered themselves as "we are handling replies/errors, do
    not interfere!" and so the code here waits for "that other thread" to be done
    before it continues. Only that there is no other thread, but it is this thread
    itself and thus a deadlock follows.
    
    The bug is relatively easy to reproduce on any desktop environment by
    using actively a touchscreen input that supports multitouch, i.e. practically
    all mobile devices are affected.
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/93
    Suggested-by: Uli Schlachter <psychon@znc.in>
    Tested-by: Dmitry Osipenko <digetx@gmail.com>
    Reported-by: Dmitry Osipenko <digetx@gmail.com>
    Signed-off-by: Dmitry Osipenko <digetx@gmail.com>

commit 1f1ca0863fd81fd0538b104eb9d9841ddbc7c905
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Sep 13 16:44:32 2019 -0400

    xkb: Provide <X11/extensions/XKBgeom.h> ourselves
    
    This header refers to libX11 types, it doesn't belong in xorgproto and
    has been moved to legacy in 2019.2. Supply it ourselves.

commit edc7680ed5a03cedb5facf14693823455e12c29c
Author: Ross Burton <ross.burton@intel.com>
Date:   Tue Aug 6 14:53:43 2019 +0100

    src/util/Makefile: explicitly reset LINK to not use libtool
    
    Simply looking at libtool redefines LINK globally to use libtool, which when
    you're trying to cross-compile to Windows can cause complications.
    
    As in src/util/ we're simply building a small binary for the build host, reset
    LINK to the automake default so that the traditional compile/link steps occur
    without libtool.
    
    Also remove -all-static from LDFLAGS as that is a libtool-specific argument
    intended to solve this problem.
    
    Closes: #100
    Signed-off-by: Ross Burton <ross.burton@intel.com>

commit f111bf3ac091a3a6d1f094172621d9d033c3833c
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Jul 30 16:53:27 2019 -0400

    improve some formatting
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 1d0a6fe9126c7ce61c6648cabf43b2de4d6d3ba9
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Jul 30 15:49:09 2019 -0400

    fix a substitution error from recent commit, e.g, "s/^\.EE/XDe/"
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 8fe8aafe7e9beffaff0460fe08354dfcde1efe98
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Jul 30 05:07:40 2019 -0400

    split lines at sentence endings
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 6f2cbcea5d6dcd1df7ef309481cad1663284c061
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Jul 30 04:52:25 2019 -0400

    trim trailing whitespace from manpages
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit 4abf482d8e6b0b1ae84e0f528e71066afd6d18b5
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Jul 30 04:36:24 2019 -0400

    another fake-quote fix
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit c0f0651f2b4dfa9fef86d1374689220125631993
Author: Thomas E. Dickey <dickey@invisible-island.net>
Date:   Tue Jul 30 04:34:54 2019 -0400

    the last commit overlooked some fake-quote pairs
    
    Signed-off-by: Thomas E. Dickey <dickey@invisible-island.net>

commit ef31143c9decda54b3ab2937d3300fcf5b493fd6
Author: Walter Harms <wharms@bfs.de>
Date:   Mon Jul 29 18:50:19 2019 +0200

    fix ``fake quotes'' in text
    
    to remove the fake quotes replace them with propper
    predefined macros \*(lq and \*(rq. this will allow
    nroff to choose the propper characters when using ps etc.
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit 705027ea9b17d6552388d2067736ab4b0bf9dfb5
Author: Walter Harms <wharms@bfs.de>
Date:   Mon Jul 29 18:27:12 2019 +0200

    get rid of ``fake quotes''
    
    these fake quotes are inside a comment and can be replaced with
    some double quotes
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit fe46eb287106ad05538e896783a5cf877a4138df
Author: Walter Harms <wharms@bfs.de>
Date:   Mon Jul 29 17:57:02 2019 +0200

    remove all private macro defines
    
    after converting everything to st. man page macros there is
    no need to maintain X11 private nroff macros, so remove them.
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit b7f09ae19c9a098ecd545b4d4c45a6afe39a8764
Author: Walter Harms <wharms@bfs.de>
Date:   Mon Jul 29 17:47:35 2019 +0200

    Replace home-grown .Ds .De macro with man page .EX/.EE macro
    
    Same pages use the man page .EX/.EE macro. Replace all occurences
    of .De/.Ds with the std. macros to make the code better to maintain.
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit 951e772bc8d89bc62c4bbac14adc5d4f5027419f
Author: Walter Harms <wharms@bfs.de>
Date:   Wed Jul 3 18:23:51 2019 +0200

    fix TBL format
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit 4eb167f5aca4cca05a230c728ffdb4fd382a4e1e
Author: Walter Harms <wharms@bfs.de>
Date:   Wed Jul 3 18:18:09 2019 +0200

    replace home grown .ZN with std, .B and .BR
    
    Replace the home grown macro .ZN with std. macros
    from man macro paket. So we can get rid of the
    definition an get a clean header.
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit 08e6b36292ebf01ba2dcc4a48ec371c6f5d13458
Author: Walter Harms <wharms@bfs.de>
Date:   Sat Jun 22 18:33:48 2019 +0200

    remove in-text macros
    
    remove in-text macros an fix a few typos on the way.
    hopefuly that will make maintenance more easy.
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit cb0e894fe9927b07bd9d97c067fd0d007accb105
Author: Walter Harms <wharms@bfs.de>
Date:   Fri Jun 21 18:01:16 2019 +0200

    note that we can handle kbd==NULL
    
    Signed-off-by: Walter Harms <wharms@bfs.de>

commit 0327c427d62f671eced067c6d9b69f4e216a8cac
Author: Adam Jackson <ajax@redhat.com>
Date:   Mon Jun 17 13:36:08 2019 -0400

    makekeys: Detach ourselves from X headers entirely
    
    Subsequent to a121b7b0c210efe10bf93453b29050282324c906 we are no longer
    building makekeys with enough -I/foo/bar to find the X11 headers, so if
    they're not in a system include path, things fail. Since this utility is
    only needed at build time, there's no real reason to demand the X
    headers be installed for both the build and target machines if cross-
    compiling, we can just assume a vaguely ANSI environment instead.
    
    Tested-by: Niclas Zeising <zeising@daemonic.se>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

commit 57f0d421a1320090d3a4948181fe228d86cc8977
Author: Matt Turner <mattst88@gmail.com>
Date:   Mon Jun 17 10:45:45 2019 -0400

    libX11 1.6.8
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 5464b302bc0c4a055d3eac06c6ab15e209ff7668
Author: Matt Turner <mattst88@gmail.com>
Date:   Sun Jun 9 14:00:15 2019 -0700

    Use AC_SYS_LARGEFILE
    
    ... and include config.h in makekeys.c to get the definition of
    _FILE_OFFSET_BITS. Without it, libX11 can fail to build on a file
    system with 64-bit inode numbers.
    
    Bug: https://bugs.gentoo.org/550502
    Bug: https://bugs.gentoo.org/616140
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 33b9148a833ab2ea46e44871da3c031bf1b78f77
Author: Ran Benita <ran234@gmail.com>
Date:   Thu Feb 13 20:55:08 2014 +0200

    Compose.man: fix escaped hexadecimal char description
    
    The man page says:
        Strings may be direct text encoded in the locale for which the
        compose file is to be used, or an escaped octal or hexadecimal
        character code.   Octal codes are specified as "\123" and
        hexadecimal codes as "\0x123a".
    
    But the grammar in the parser and the implementation say:
        ESCAPED_CHAR  ::= ('\\' | '\"' | OCTAL | HEX )
        HEX           ::= '\' (x|X) HEX_CHAR [HEX_CHAR]]
        HEX_CHAR      ::= (0|1|2|3|4|5|6|7|8|9|A|B|C|D|E|F|a|b|c|d|e|f)
    
    So "\0x123a" -> "\x3a".
    
    Signed-off-by: Ran Benita <ran234@gmail.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d9b2cc35edf01e4f751a9ccb5ac185745184cec0
Author: ojab <ojab@ojab.ru>
Date:   Mon Apr 24 20:12:17 2017 +0000

    Compose sequences for rouble sign
    
    Cyrillic combinations mirror the Qwerty-Jcuken keyboard layout.
    
    Signed-off-by: Slava Kardakov <ojab@ojab.ru>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3f211616f6414bd9958566c0ca137e87a2b6df95
Author: Pavel Labath <pavelo@centrum.sk>
Date:   Fri Nov 30 20:45:04 2012 +0100

    Fix a leak in XCreateFontSet
    
    a simple snippet like XFreeFontSet(d, XCreateFontSet(d, ...)) will generate lots of memory leaks,
    as evidenced by the following valgrind output:
    ==983== HEAP SUMMARY:
    ==983==     in use at exit: 39,409 bytes in 341 blocks
    ==983==   total heap usage: 4,795 allocs, 4,454 frees, 489,086 bytes allocated
    ==983==
    ==983== 1,688 (136 direct, 1,552 indirect) bytes in 1 blocks are definitely lost in loss record
    40 of 46
    ==983==    at 0x4C2B042: realloc (in /usr/lib64/valgrind/vgpreload_memcheck-amd64-linux.so)
    ==983==    by 0x56D5A93: add_codeset.clone.9 (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56D5FE0: load_generic (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56D7612: initialize (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56D7E75: _XlcCreateLC (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56F9A5F: _XlcUtf8Loader (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56DF815: _XOpenLC (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56B255A: XOpenOM (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x56A665A: XCreateFontSet (in /usr/lib64/libX11.so.6.3.0)
    ==983==    by 0x4FCA80: conky::x11_output::create_gc() (x11.cc:746)
    ==983==    by 0x4FC3B4: conky::x11_output::use_own_window() (x11.cc:602)
    ==983==    by 0x4FAD42: conky::priv::own_window_setting::set(bool const&, bool) (x11.cc:92)
    ==983==
    ==983== LEAK SUMMARY:
    ==983==    definitely lost: 136 bytes in 1 blocks
    ==983==    indirectly lost: 1,552 bytes in 34 blocks
    ==983==      possibly lost: 0 bytes in 0 blocks
    ==983==    still reachable: 37,721 bytes in 306 blocks
    ==983==         suppressed: 0 bytes in 0 blocks
    
    This patch makes the leak dissappear (Well, at least the "definitely lost part". The "still
    reachable" thingy remains). After some analysis, I've discovered that the XLCd structure is
    destroyed improperly. The "constructor" is in lcGeneric.c, but the structure is destroyed using
    code from lcPublic.c. I've found that changing the destructor call to _XlcDestroyLC executes the
    correct code path, and I'm pretty sure this is correct (the object was constructed using
    _XlcCreateLC, it make sense to destroy it using its conterpart).
    
    So far I haven't observed any strange behaviour on my system caused by this change (although, I'm
    not sure, how many programs actually use this function).
    
    Signed-off-by: Pavel Labath <pavelo@centrum.sk>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 4645e219133458781e3fb48eaea6a74cccb1b9aa
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Tue Apr 30 14:39:06 2019 +0100

    Avoid using libtool wrapper for makekeys
    
    For Windows targets, libtool uses a wrapper executable, not a wrapper
    script (see [1]), which it compiles with the host compiler.  This
    doesn't work when cross-compiling.
    
    Since we don't actually need to link with anything, use the libtool flag
    -all-static to tell it to stay completely out of this.
    
    [1] https://www.gnu.org/software/libtool/manual/html_node/Wrapper-executables.html

commit 6886d9ba06826785a8ccb312c04ea82b91bb6a25
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Wed Apr 24 12:50:41 2019 +0100

    Use EXEEXT_FOR_BUILD for makekeys
    
    Use EXEXT_FOR_BUILD, to fix cross-compiling where EXEEXT differs from
    EXEEXT_FOR_BUILD, such as when building for Windows from unix.
    
    (Note: As written, this assumes EXEEXT_FOR_BUILD is always empty when
    cross-compiling.  There could be some elaborate autodetection for
    EXEXT_FOR_BUILD, but for the moment, if you are cross-compiling from
    Windows to Unix, you'll need to set EXEEXT_FOR_BUILD explicity...)

commit a121b7b0c210efe10bf93453b29050282324c906
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Tue Apr 30 14:30:41 2019 +0100

    Remove makekeys dependency on X headers
    
    This is the patch from https://bugs.freedesktop.org/show_bug.cgi?id=6669
    by Pierre Ossman, reworked for master.
    
    Avoid using LIBS (which are for host, but we don't need) and rewrite
    makekeys slightly to avoid needing to include any X headers, which
    avoids potentially having -I with host paths in CFLAGS, which can cause
    standard headers e.g. stdio.h for the host to also be used, which can
    break things...

commit cbb59d1727cb1bfcff91b54fd55f4139e360b7ab
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Fri Jun 7 23:35:33 2019 +0200

    Braille: Fix typing quickly
    
    On finishing releasing Braille keys, we should clear the just-commited
    pattern, to reset the state to initial state, and avoid having to wait for
    0.3s before typing the next pattern.
    
    Signed-off-by: Samuel Thibault <samuel.thibault@ens-lyon.org>
    Tested-by: Jean-Philippe Mengual <jpmengual@hypra.fr>

commit 99a2cf1aa0b58391078d5d3edf0a7dab18c7745d
Author: Tapani Pälli <tapani.palli@intel.com>
Date:   Mon May 13 08:29:49 2019 +0300

    Protect colormap add/removal with display lock
    
    This fixes a bug where concurrent threads call XCreateColormap and
    XFreeColormap corrupting a linked list where colormap structures
    are stored.
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/94
    
    v2: handle XCopyColormapAndFree also (Adam Jackson)
    
    Signed-off-by: Tapani Pälli <tapani.palli@intel.com>

commit fea80d03c381a4de379863c0d41f6d4c00f15e1e
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Wed Mar 13 13:12:20 2019 +0000

    Add autoconf checks for headers we include for FIONREAD
    
    Add autoconf checks for the extra headers we include to define FIONREAD.
    This needs sys/socket.h on Cygwin, and none of the alternatives on
    Windows.

commit 87c77a1e6d7034536e9d25ce24a667ebf53486a7
Author: Matthias Dieter Wallnöfer <matthias.wallnoefer@lugbz.org>
Date:   Mon Mar 11 14:19:52 2019 +0000

    locale.alias.pre - add the de_IT locale
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 568f77f414072506bbe48646637c872987c97e63
Author: Matthias Dieter Wallnöfer <matthias.wallnoefer@lugbz.org>
Date:   Mon Mar 11 14:17:10 2019 +0000

    locale.dir.pre - add the de_IT locale
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 38c0c92feaef7dc4a72920b1dd79872e6578086c
Author: Matthias Dieter Wallnöfer <matthias.wallnoefer@lugbz.org>
Date:   Mon Mar 11 14:12:07 2019 +0000

    compose.dir.pre - add de_IT locale
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 49f835611ba6ab82e68b7b851507931c142db7a5
Author: Matthias Dieter Wallnöfer <matthias.wallnoefer@lugbz.org>
Date:   Tue Jan 29 15:34:34 2019 +0000

    Update locale.alias.pre - introduce the de_LI aliases (equivalent to de_CH)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ed669234d0cd5933618aa5fd2da697b59845b9be
Author: Matthias Dieter Wallnöfer <matthias.wallnoefer@lugbz.org>
Date:   Tue Jan 29 15:28:18 2019 +0000

    locale.dir.pre - fix the de_LI latin15 locale
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 82b5c1454a49333b4d94984d40db79cff386d37f
Author: Josh Triplett <josh@joshtriplett.org>
Date:   Sun Feb 3 08:31:41 2019 +0100

    compose.dir.pre: Give the C.UTF-8 locale a full set of UTF-8 compose sequences
    
    Signed-off-by: Josh Triplett <josh@joshtriplett.org>

commit 603c3ab25a692194805fd4b0c62afac8093897fe
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 9 20:58:07 2019 -0800

    Add missing close paren to XrmGetStringDatabase synopsis in man page
    
    Fixes: commit 0642e99ac05afb0c
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6590cc41e3c5c5c836a49a2c82774d7cc9ab3c85
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 11:12:27 2019 -0800

    Include reallocarray.h in tarballs so "make distcheck" passes
    
    Fixes: commit bcf7b5aa06c23aee
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a4a7df06351ce9565d298a84547ff71f2d220fbf
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 11:04:41 2019 -0800

    XlibInt.c: include headers needed for ioctl(...FIONREAD...) on Solaris
    
    Fixes: commit 5538b3e4ae6dee
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 38ec04de7e537dde6b7b1eaca46b1a24fcdbc044
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 10:48:26 2019 -0800

    specs/XKB: Fix misprint in documentation of XkbFreeGeomOverlayKeys()
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/86
    aka: https://bugs.freedesktop.org/show_bug.cgi?id=23550
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 74f2f26811ae82b15dede31504b0eb541f7a3293
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 10:46:05 2019 -0800

    specs/XKB: Fix misprint in documentation of XkbAllocGeomOverlayKeys()
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/85
    aka: https://bugs.freedesktop.org/show_bug.cgi?id=23549
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 66b039a41690f076e962ac6bd46cca017360a7d1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 10:44:15 2019 -0800

    specs/XKB: Fix misprint in documentation of XkbAllocGeomOverlayRows()
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/84
    aka: https://bugs.freedesktop.org/show_bug.cgi?id=23548
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit cdea0e840315171f8390adc63a2397ddf111eea4
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 10:38:08 2019 -0800

    specs/XKB: Fix misprint in documentation of XkbGetNamedGeometry()
    
    Fixes: https://gitlab.freedesktop.org/xorg/lib/libx11/issues/82
    aka: https://bugs.freedesktop.org/show_bug.cgi?id=23520
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c72d17ada98723cd9e03ddf06680a0e54b2c3089
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 23 10:30:32 2019 -0800

    XkbAllocGeomOverlayKey man page should be named XkbAllocGeomOverlayKeys
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 05002b8aef9544c8545e0823a02cf14f335d2b68
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Feb 17 15:13:25 2019 -0800

    Fix man page typo: XkbAllBellNotifyMask -> XkbAllBellEventsMask
    
    Reported-by: Daniel Hahler <git@thequod.de>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5538b3e4ae6dee32c47db9dfc85b07bbe7b90f6c
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 24 11:07:36 2017 -0400

    _XDefaultIOError: Do better at detecting explicit shutdown
    
    Currently, when the X server crashes or a client is disconnected with
    XKillClient, you get a somewhat confusing error message from libX11
    along the lines of:
    
    XIO:  fatal IO error 11 (Resource temporarily unavailable) on X server ":0"
          after 98 requests (40 known processed) with 0 events remaining.
    
    What's happening here is the previous recvmsg has thrown EAGAIN, since
    the socket is non-blocking. In this case, check whether the socket has
    any more data to read, and if not treat it like EPIPE.
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 6d2cde9633b5ee020cb60caea1cf61e090b86dd2
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 24 11:07:35 2017 -0400

    _XDefaultIOError: Reformat to be less ugly
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 003e30a66a249f5c70b30d1c187385124cd4cdad
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jan 1 14:34:04 2019 -0800

    Avoid use-after-free in _XimProtoSetIMValues()
    
    Fixes gitlab issue #49
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 30656fd66ad47aeaca0bfc237a818f189554f07e
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jan 1 12:21:04 2019 -0800

    Fix implicit conversion warnings in _XlcCreateDefaultCharSet
    
    lcCharSet.c:187:50: warning: implicit conversion changes signedness:
          'int' to 'unsigned long' [-Wsign-conversion]
        tmp = Xmalloc(name_len + 1 + ct_sequence_len + 1);
              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~^~~~
    ../../include/X11/Xlibint.h:453:32: note: expanded from macro 'Xmalloc'
                           ~~~~~~  ^~~~
    lcCharSet.c:192:31: warning: implicit conversion changes signedness:
          'int' to 'unsigned long' [-Wsign-conversion]
        memcpy(tmp, name, name_len+1);
        ~~~~~~            ~~~~~~~~^~
    lcCharSet.c:216:45: warning: implicit conversion changes signedness:
          'int' to 'unsigned long' [-Wsign-conversion]
        memcpy(tmp, ct_sequence, ct_sequence_len+1);
        ~~~~~~                   ~~~~~~~~~~~~~~~^~
    lcCharSet.c:183:16: warning: implicit conversion loses integer precision:
          'unsigned long' to 'int' [-Wshorten-64-to-32]
        name_len = strlen(name);
                 ~ ^~~~~~~~~~~~
    lcCharSet.c:184:23: warning: implicit conversion loses integer precision:
          'unsigned long' to 'int' [-Wshorten-64-to-32]
        ct_sequence_len = strlen(ct_sequence);
                        ~ ^~~~~~~~~~~~~~~~~~~
    lcCharSet.c:198:37: warning: implicit conversion loses integer precision:
         'long' to 'unsigned int' [-Wshorten-64-to-32]
            unsigned int length = colon - charset->name;
                         ~~~~~~   ~~~~~~^~~~~~~~~~~~~~~
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 2e6300905784fa8adfcea019262ea58b3e1ed4ad
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jan 1 11:41:47 2019 -0800

    Remove no-longer-used name variable in _XGetAtomName
    
    Fixes gcc warning:
    GetAtomNm.c: In function ‘_XGetAtomName’:
    GetAtomNm.c:39:11: warning: unused variable ‘name’ [-Wunused-variable]
         char *name;
               ^~~~
    
    Introduced by commit 336c1e7a505698a8f3bcb6eb96dbbb8ed21ade96
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f077871c2a12cf098b0c50572e112c6dc5e04de0
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 29 11:39:29 2018 -0800

    Fix out-of-tree builds after commit 8a62e26515e528bb47917ec4a55cc2b492419eeb
    
    In-tree builds found reallocarray.h in $(top_builddir)/src but the
    out-of-tree build didn't find it at all.
    
    Reported-by: Emmanuele Bassi <ebassi@gmail.com> from GNOME continuous integration pipeline
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ba7f7cc783672784bebc6e69349b55c6c75c1973
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Sep 27 18:35:27 2015 -0700

    Convert src/xlibi18n to use reallocarray()
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 336c1e7a505698a8f3bcb6eb96dbbb8ed21ade96
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Sep 26 11:12:47 2015 -0700

    Replace Xmalloc+strcpy pairs with strdup calls
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 258a8ced681dc1bc50396be7439fce23f9807e2a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 19 11:58:50 2015 -0700

    Replace _XkbTypedRealloc & _XkbClearElems with new _XkbResizeArray
    
    Makes resizing & clearing more consistent and gets rid of some weird
    quirks like always subtracting 1 from the size passed to _XkbClearElems
    so it could always add 1 to the size passed in.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f94273e2f4284040306b888e5ca0381ee00591af
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 19 09:47:29 2015 -0700

    Add some missing allocation failure checks in src/xcms
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 76850471b4a5a6d30f5660234e87ec2772e7b426
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 19 09:33:21 2015 -0700

    Convert src/xcms to use reallocarray()
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 8a62e26515e528bb47917ec4a55cc2b492419eeb
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 19 09:24:02 2015 -0700

    Convert src/XKB to use reallocarray()
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6d1dc1f6169ebf0ba71785d461bd98129c65c862
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jun 4 23:30:43 2015 -0700

    Convert main src directory to use reallocarray()

commit bcf7b5aa06c23aee00af7999b58cb96a8571ac42
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jun 4 23:18:23 2015 -0700

    Import reallocarray() from OpenBSD
    
    Wrapper for realloc() that checks for overflow when multiplying
    arguments together, so we don't have to add overflow checks to
    every single call.  For documentation on usage, see:
    http://www.openbsd.org/cgi-bin/man.cgi/OpenBSD-current/man3/calloc.3
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9bdfe9c9af11d77d66e5ff651e82b20e695cb460
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Nov 19 21:26:23 2018 -0800

    Update README for gitlab migration
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c8bcc19970a2cc4ad337de1338c63a07325eefcd
Author: Albert Astals Cid <aacid@kde.org>
Date:   Fri Nov 9 22:24:52 2018 +0100

    locale.dir: Add ast_ES.UTF-8
    
    With this patch xev properly reports
       XLookupString gives 2 bytes: (c2 b4) "´"
    for the dead_acute key when using the Asturian locale

commit 117bb310b44ce03802c91a70949eb58dcc702a3c
Author: Albert Astals Cid <aacid@kde.org>
Date:   Fri Nov 9 22:18:43 2018 +0100

    compose.dir: Add ast_ES.UTF-8
    
    With this patch one can properly type dead keys like á when using the
    Asturian locale

commit d7e22252d68258a63ca537827c99d0ac0bc4b9d8
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Nov 10 13:30:47 2018 -0800

    Remove documentation of obsolete B16 & B32 tags in specs/libX11
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f3c978476e0be6813268af494efb7ac507451116
Author: Matt Turner <mattst88@gmail.com>
Date:   Tue Oct 9 10:26:05 2018 -0400

    libX11 1.6.7
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 823a0f8a820247b6c1e092f679b49cbdc2ea5c95
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Fri Sep 28 17:24:17 2018 +0200

    poll_for_event: Allow using xcb_poll_for_queued_event
    
    It avoids reading from the display connection again in cases where that
    was already done.
    
    Suggested-by: Uli Schlachter <psychon@znc.in>
    Reviewed-by: Uli Schlachter <psychon@znc.in>

commit 406afe4b0f1b655c0db19bbc9a0c48da9a46acf5
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Sep 25 17:10:58 2018 +0200

    poll_for_response: Call poll_for_event again if xcb_poll_for_reply fails
    
    If xcb_poll_for_reply fails to find a reply, poll_for_response would
    always return NULL. However, xcb_poll_for_reply may have read events
    from the display connection while looking for a reply. In that case,
    returning NULL from poll_for_response is wrong and can result in the
    client hanging, e.g. because it returns to waiting for the display
    connection file descriptor becoming readable after XPending incorrectly
    returned 0 pending events.
    
    The solution is to call poll_for_event again after xcb_poll_for_reply
    returned 0. This will return the first of any events read by
    xcb_poll_for_reply.
    
    Fixes issue #79.
    
    Reported-by: Yuxuan Shui <yshuiv7@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/108008
    Bugzilla: https://bugs.freedesktop.org/107992
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit d0416863d5bf75af54ce81f6c30d4c1476b5e04f
Author: Bhavi Dhingra <b.dhingra@samsung.com>
Date:   Mon Sep 28 08:33:40 2015 +0000

    XcmsLookupColor: fully initialize XColor structs passed to _XColor_to_XcmsRGB
    
    Fixes https://gitlab.freedesktop.org/xorg/lib/libx11/issues/44
    aka https://bugs.freedesktop.org/show_bug.cgi?id=92154
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 733f64bfeb311c1d040b2f751bfdef9c9d0f89ef
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Tue Aug 21 16:54:50 2018 +0200

    libX11 1.6.6
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 173704243fbcbea0b6de2068b4fb403c7408fb54
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Tue Aug 21 16:53:40 2018 +0200

    Remove statement with no effect.
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit e83722768fd5c467ef61fa159e8c6278770b45c2
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Fri Jul 27 16:38:00 2018 +0200

    Fixed crash on invalid reply (CVE-2018-14598).
    
    If the server sends a reply in which even the first string would
    overflow the transmitted bytes, list[0] (or flist[0]) will be set to
    NULL and a count of 0 is returned.
    
    If the resulting list is freed with XFreeExtensionList or
    XFreeFontPath later on, the first Xfree call:
    
        Xfree (list[0]-1)
     turns into
        Xfree (NULL-1)
    
    which will most likely trigger a segmentation fault.
    
    I have modified the code to return NULL if the first string would
    overflow, thus protecting the freeing functions later on.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>

commit dbf72805fd9d7b1846fe9a11b46f3994bfc27fea
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Fri Jul 27 16:37:17 2018 +0200

    Fixed out of boundary write (CVE-2018-14600).
    
    The length value is interpreted as signed char on many systems
    (depending on default signedness of char), which can lead to an out of
    boundary write up to 128 bytes in front of the allocated storage, but
    limited to NUL byte(s).
    
    Casting the length value to unsigned char fixes the problem and allows
    string values with up to 255 characters.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>

commit b469da1430cdcee06e31c6251b83aede072a1ff0
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Fri Jul 27 16:36:34 2018 +0200

    Fixed off-by-one writes (CVE-2018-14599).
    
    The functions XGetFontPath, XListExtensions, and XListFonts are
    vulnerable to an off-by-one override on malicious server responses.
    
    The server replies consist of chunks consisting of a length byte
    followed by actual string, which is not NUL-terminated.
    
    While parsing the response, the length byte is overridden with '\0',
    thus the memory area can be used as storage of C strings later on. To
    be able to NUL-terminate the last string, the buffer is reserved with
    an additional byte of space.
    
    For a boundary check, the variable chend (end of ch) was introduced,
    pointing at the end of the buffer which ch initially points to.
    Unfortunately there is a difference in handling "the end of ch".
    
    While chend points at the first byte that must not be written to,
    the for-loop uses chend as the last byte that can be written to.
    
    Therefore, an off-by-one can occur.
    
    I have refactored the code so chend actually points to the last byte
    that can be written to without an out of boundary access. As it is not
    possible to achieve "ch + length < chend" and "ch + length + 1 > chend"
    with the corrected chend meaning, I removed the inner if-check.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>

commit d81da209fd4d0c2c9ad0596a8078e58864479d0d
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Tue Jul 3 22:31:37 2018 +0200

    Validation of server response in XListHosts.
    
    If a server sends an incorrect length in its response, a client is prone
    to perform an out of boundary read while processing the data.
    
    The length field of xHostEntry is used to specify the amount of bytes
    used to represent the address. It is 16 bit, which means that it is not
    possible to perform an arbitrary memory access, but it might be enough
    to read sensitive information, e.g. malloc-related pointers and offsets.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit b676e62377483df77bcb6472d26b24f901323fa9
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Wed Jun 13 15:46:58 2018 +0200

    XkbOpenDisplay.3: fix typo
    
    XkbOpenDisplay returns a pointer to Display, not a Display.
    
    Signed-off-by: Samuel Thibault <samuel.thibault@ens-lyon.org>

commit 9c5845ff0dc080ff10bd68af4fc40fcd805728ca
Author: Martin Natano <natano@natano.net>
Date:   Sat Oct 8 19:57:50 2016 +0200

    Don't rebuild ks_tables.h if nothing changed.
    
    ks_tables.h is always considered out of date due to the forced rebuild
    of the makekeys util. This means the file is also rebuilt during 'make
    install', which is usually performed as root, which can to lead
    permission problems later on.
    
    Signed-off-by: Martin Natano <natano@natano.net>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 796f754cba6d75b676a0fc39b97802198fceda4f
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat May 5 14:43:30 2018 -0700

    Change fall through comment in lcDB.c to match gcc's requirements
    
    Needs to match one of the regexps shown under
    https://gcc.gnu.org/onlinedocs/gcc-7.3.0/gcc/Warning-Options.html#index-Wimplicit-fallthrough
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 82ca6308757126fa7ffc6588f1e5d8e3be04251b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 24 19:45:14 2018 -0700

    Use size_t for buffer sizes in SetHints.c
    
    These variables store values returned from strlen() as a size_t
    and are passed to Xmalloc, which expects a size_t, so lets stop
    converting back and forth to int along the way.
    
    Reported by: Konstantin SKliarov
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 50a5a98984097d614227d22a49265e12b172cac7
Author: Bhavi Dhingra <b.dhingra@samsung.com>
Date:   Tue Jul 5 11:37:50 2016 +0530

    Fix possible memory leak in cmsProp.c:140
    
    https://bugs.freedesktop.org/show_bug.cgi?id=96814
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a9dafdd57c71473fa3a2ec4887e973e4e9876d83
Author: Michal Srb <msrb@suse.com>
Date:   Thu Mar 15 09:50:58 2018 +0100

    Use flexible array member instead of fake size.
    
    The _XimCacheStruct structure is followed in memory by two strings containing
    fname and encoding. The memory was accessed using the last member of the
    structure `char fname[1]`. That is a lie, prohibits us from using sizeof and
    confuses checkers. Lets declare it properly as a flexible array, so compilers
    don't complain about writing past that array. As bonus we can replace the
    XOffsetOf with regular sizeof.
    
    Fixes GCC8 error:
      In function 'strcpy',
          inlined from '_XimWriteCachedDefaultTree' at imLcIm.c:479:5,
          inlined from '_XimCreateDefaultTree' at imLcIm.c:616:2,
          inlined from '_XimLocalOpenIM' at imLcIm.c:700:5:
      /usr/include/bits/string_fortified.h:90:10: error: '__builtin_strcpy'
      forming offset 2 is out of the bounds [0, 1] [-Werror=array-bounds]
         return __builtin___strcpy_chk (__dest, __src, __bos (__dest));
    
    Caused by this line seemingly writing past the fname[1] array:
      imLcIm.c:479:  strcpy (m->fname+strlen(name)+1, encoding);
    
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 34f4464f69a4d6ff0d1042500a62f9a5ed7f3647
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Mar 6 11:42:27 2018 -0800

    If XGetImage fails to create image, don't dereference it to bounds check
    
    Reported by gcc 7.3:
    
    GetImage.c:110:25: warning: potential null pointer dereference [-Wnull-dereference]
      if (planes < 1 || image->height < 1 || image->bytes_per_line < 1 ||
                        ~~~~~^~~~~~~~
    
    Introduced by 8ea762f94f4c942d898fdeb590a1630c83235c17 in Xlib 1.6.4
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Emil Velikov <emil.velikov@collabora.com>

commit e835a9dcc3362b5e92893be756dd7ae361e64ced
Author: wharms <wharms@bfs.de>
Date:   Sun Sep 3 14:17:45 2017 +0200

    silence gcc warning assignment discards 'const' qualifier from pointer target type

commit 36a1ac0253fea82ff79cc52ba56c5691cfd07a3b
Author: wharms <wharms@bfs.de>
Date:   Sun Aug 20 21:51:57 2017 +0200

    remove empty line

commit e02dfe54f32b4165351d2712a9d2e0584906a3ce
Author: wharms <wharms@bfs.de>
Date:   Sun Aug 20 21:50:33 2017 +0200

    add _X_UNUSED to avoid unused variable warnings

commit 2911c39cecd63ed3747072a5eeeb9eedffc881e9
Author: walter harms <wharms@bfs.de>
Date:   Sat Jun 4 17:19:59 2016 +0200

    Fixes: warning: variable 'req' set but not,used
    
    Fixes: warning: variable 'req' set but not used [-Wunused-but-set-variable]
           by marking req _X_UNUSED
            Solution was discussed on xorg-devel ML
           Peter Hutter, Alan Coopersmith
            Re: [PATCH libX11 3/5] fix: warning: pointer targets in passing argument 2 of '_XSend' differ in signedness [-Wpointer-sign]
    
    Signed-off-by: harms wharms@bfs.de

commit bf82ec0402479fd8399d69e7d62fc17d7956699a
Author: walter harms <wharms@bfs.de>
Date:   Sat Jun 4 17:22:07 2016 +0200

    mark _XDefaultIOError as no_return
    
    mark _XDefaultIOError as no_return. No one comes back from exit() ...
    
    Signed-off-by: harms wharms@bfs.de

commit 9abe8380074edea3ac4e72466ec47e921ca05e47
Author: walter harms <wharms@bfs.de>
Date:   Sat Jun 4 17:21:52 2016 +0200

    no need to check XFree arguments
    
    You can save a bit of code. The is no need to check XFree arguments bring  free_fontdataOM in line with other free function and check for NULL arg
    
    Signed-off-by: harms wharms@bfs.de

commit 433477fcb7e07d0c26a22ba78aae88827ed1f440
Author: walter harms <wharms@bfs.de>
Date:   Tue Apr 26 16:32:20 2016 +0200

    fix memleak in error path
    
    free all mem on error
    Signed-off-by: walter harms <wharms@bfs.de>

commit ed9f0d34abc645eee56e21863f23acb4d0bb8e9a
Author: walter harms <wharms@bfs.de>
Date:   Tue Apr 26 17:58:16 2016 +0200

    fix memleak in error path
    
    V2: remove unneeded NULL (reported by eric.engestrom@imgtec.com)
    
    fix mem leak in error path
    Signed-off-by: walter harms <wharms@bfs.de>

commit 7c78fc57693afa94cf26170f0f6276e3b7374ed0
Author: walter harms <wharms@bfs.de>
Date:   Tue Apr 26 16:34:11 2016 +0200

    no need to check args for Xfree()
    
    simplify code
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit c1c14af441ae73d1a8e67a971fafcf967e45ac48
Author: walter harms <wharms@bfs.de>
Date:   Tue Apr 26 16:23:46 2016 +0200

    remove stray extern
    
    remove stray extern
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit 714921f041a245dc5f37a689268b584226a2ccb9
Author: walter harms <wharms@bfs.de>
Date:   Mon Apr 11 18:26:52 2016 +0200

    no need to check argument for _XkbFree()
    
    simplify code by removing unneeded checks
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit d02c2466f65063a03c97dbcee05071c12a3676e6
Author: walter harms <wharms@bfs.de>
Date:   Mon Apr 11 18:22:38 2016 +0200

    fix more shadow warning
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit 0355c3926d5372f9762f235071dbd94a89bbbdad
Author: walter harms <wharms@bfs.de>
Date:   Thu Mar 31 19:16:33 2016 +0200

    fix shadow char_size
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit 916dffadf052135df3398651be873c353da629e1
Author: walter harms <wharms@bfs.de>
Date:   Thu Mar 31 19:14:32 2016 +0200

    remove argument check for free() adjust one inden
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit 6ec901ebca3fea6a762e22090dc35b1b90911133
Author: walter harms <wharms@bfs.de>
Date:   Thu Mar 31 19:12:17 2016 +0200

    _XIOError(dpy); will never return so remore dead
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit 83107a677b2ed458e4d62ea4a601e8181d3683d8
Author: walter harms <wharms@bfs.de>
Date:   Thu Mar 31 19:10:49 2016 +0200

    fix shadow warning
    
    Signed-off-by: walter harms <wharms@bfs.de>

commit 4fe66b1c5112b07bd09e28bbc021911d08a9621f
Author: Ryan C. Gordon <icculus@icculus.org>
Date:   Wed Aug 2 02:41:03 2017 -0400

    Valgrind fix for XStoreColor and XStoreColors.
    
    If the "pad" field isn't set, Valgrind will report it as uninitialized
    memory accesses when the struct is copied into the Display's send buffer.
    
    In practice, this is (probably) harmless, but Valgrind is correct in
    believing it's a bug.
    
    https://bugs.freedesktop.org/attachment.cgi?id=133189
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7d2010fec25c2f52b873ad0572479eb43128b038
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Apr 7 00:13:03 2017 -0700

    Improve table formatting in XkbChangeControls & XkbKeyNumGroups man pages
    
    Includes fix for Solaris Bug 24564279: "XkbKeyNumGroups.3x11 man page
    contains some malformed text" caused by extra whitespace after .TE macros
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b856d5d929047d1ea169814d56e43784ea404c83
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Mar 16 00:05:49 2017 -0700

    Clarify state parameter to XkbSetNamedDeviceIndicator
    
    Checking a Bool to see if it's NULL does not work well in C.
    Also reported in https://bugs.freedesktop.org/show_bug.cgi?id=251
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit c6dadd4cebd994aafb37a58b3adbaa82507c2d18
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Mar 15 23:50:26 2017 -0700

    Make Xkb{Get,Set}NamedIndicator spec & manpages match code
    
    The XKB Library spec and the man pages for XkbGetNamedIndicator &
    XkbSetNamedIndicator included a device_spec argument neither function
    takes, and do not include the XkbGetNamedDeviceIndicator &
    XkbSetNamedDeviceIndicator variants that do take it (along with two
    other arguments).
    
    This updates them to match the interfaces the code has provided for
    decades.
    
    This has been reported multiple times, so this fixes:
    https://bugs.freedesktop.org/show_bug.cgi?id=251
    https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=729812
    Sun Bug 4528016 XkbSetNamedIndicator & XkbGetNamedIndicator man pages are wrong
      (filed: alan.coopersmith@sun.com 2001-11-15 - now aka Oracle bug 15087506)
    X.Org Group Defect Id #9418
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 2d20890e7ffd3ee88a9ceb25cdd2ac1fe7aaceb6
Author: Arthur Huillet <ahuillet@nvidia.com>
Date:   Wed Feb 1 15:02:41 2017 +0100

    _XDefaultError: set XlibDisplayIOError flag before calling exit
    
    _XReply isn't reentrant, and it can lead to deadlocks when the default error
    handler is called: _XDefaultError calls exit(1). It is called indirectly by
    _XReply when a X protocol error comes in that isn't filtered/handled by an
    extension or the application. This means that if the application (or one of its
    loaded shared libraries such as the NVIDIA OpenGL driver) has registered any
    _fini destructor, _fini will get called while still on the call stack of
    _XReply. If the destructor interacts with the X server and calls _XReply, it
    will hit a deadlock, looping on the following in _XReply:
    
        ConditionWait(dpy, dpy->xcb->reply_notify);
    
    It is legal for an application to make Xlib calls during _fini, and that is
    useful for an OpenGL driver to avoid resource leaks on the X server side, for
    example in the dlopen/dlclose case. However, the driver can not readily tell
    whether its _fini is being called because Xlib called exit, or for another
    reason (dlclose), so it is hard to cleanly work around this issue in the driver.
    
    This change makes it so _XReply effectively becomes a no-op when called after
    _XDefaultError was called, as though an XIOError had happened. The dpy
    connection isn't broken at that point, but any call to _XReply is going to hang.
    This is a bit of a kludge, because the more correct solution would be to make
    _XReply reentrant, maybe by broadcasting the reply_notify condition before
    calling the default error handler. However, such a change would carry a grater
    risk of introducing regressions in Xlib.
    
    This change will drop some valid requests on the floor, but this should not
    matter, as it will only do so in the case where the application is dying: X will
    clean up after it once exit() is done running. There is the case of
    XSetCloseDownMode(RETAIN_PERMANENT), but an application using that and wishing
    to clean up resources in _fini would currently be hitting a deadlock, which is
    hardly a better situation.
    
    Signed-off-by: Aaron Plattner <aplattner@nvidia.com>
    Reviewed-by: Jamey Sharp <jamey@minilop.net>

commit 42f4d7af9cf6d1dbfa575552e057328b054a20c9
Author: Matt Turner <mattst88@gmail.com>
Date:   Sat Feb 25 21:54:22 2017 -0800

    libX11 1.6.5
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit a0da5835e8078445947c828fe2d86c1a31439012
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Feb 14 15:33:29 2017 -0500

    Revert "Compose sequences for rouble sign"
    
    This reverts commit d9e34061307748cb7318ed6b5f83ee5ee9b81fd0.
    
    Reported to break 'make check':
    
    https://lists.freedesktop.org/archives/xorg-devel/2017-February/052720.html

commit d9e34061307748cb7318ed6b5f83ee5ee9b81fd0
Author: Mihail Konev <k.mvc@ya.ru>
Date:   Fri Feb 10 18:48:18 2017 +0500

    Compose sequences for rouble sign
    
    Cyrillic combinations mirror the Qwerty-Jcuken keyboard layout.
    Also add Cyrillic sequences for hryvnia sign.
    
    Submitted-by: Victor V. Kustov <coyote@bks.tv>
    Reviewed-by: Victor V. Kustov <coyote@bks.tv>
    Signed-off-by: Mihail Konev <k.mvc@ya.ru>

commit 23d9623c661694aba8cf1e8f277dffa7a86cf065
Author: Petr Písař <petr.pisar@atlas.cz>
Date:   Sun Oct 30 12:49:11 2016 +0100

    Revert cs_CZ.UTF-8 XLC_LOCALE to en_US.UTF-8
    
    The cs_CZ.UTF-8/XLC_LOCALE is an empty file leading to unsupported cs_CZ.UTF-8
    locale and reporting this error:
    
    Warning: locale not supported by Xlib, locale set to C
    
    Therefore this patch reverts to the en_US.UTF-8 definition file that was used
    before. This patch also deduplicates the cs_CZ.UTF-8 entry.
    
    <https://bugs.freedesktop.org/show_bug.cgi?id=98219>
    
    This reverts commit 33840a5465a2e5fecab520bfbdd2d1bd0a456f51
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>

commit 71b0929ebc1f0f877f63e3f6de260f529daa6c69
Author: Mihail Konev <k.mvc@ya.ru>
Date:   Thu Jan 26 13:52:49 2017 +1000

    autogen: add default patch prefix
    
    Signed-off-by: Mihail Konev <k.mvc@ya.ru>

commit 2979011bc170c55894b9185b26376f8efc6db7d4
Author: Emil Velikov <emil.l.velikov@gmail.com>
Date:   Mon Mar 9 12:00:52 2015 +0000

    autogen.sh: use quoted string variables
    
    Place quotes around the $srcdir, $ORIGDIR and $0 variables to prevent
    fall-outs, when they contain space.
    
    Signed-off-by: Emil Velikov <emil.l.velikov@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4a0082a1b6affa65d38294f0e13511525cd8ad15
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 24 10:32:07 2017 +1000

    autogen.sh: use exec instead of waiting for configure to finish
    
    Syncs the invocation of configure with the one from the server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Emil Velikov <emil.velikov@collabora.com>

commit c74b070f2712c95f0db7c320a10232b0e5c83049
Author: Julien Cristau <jcristau@debian.org>
Date:   Sat Jan 7 16:20:31 2017 +0100

    Fix wrong Xfree in XListFonts failure path
    
    'ch' gets moved inside the allocated buffer as we're looping through
    fonts, so keep a reference to the start of the buffer so we can pass
    that to Xfree in the failure case.
    
    Fixes: commit 20a3f99eba5001925b8b313da3accb7900eb1927 "Plug a memory leak"
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 663f47075fe67bab4f99bc5d186c49175d4a4334
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jan 1 20:57:58 2017 -0800

    specs/libX11: Update Portability Considerations for the 21st century
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 28f4b989b52fcf45c7e75a878d8d9c2583cd6b3c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jan 1 20:39:53 2017 -0800

    specs/libX11: Fix broken synopsis for Data/Data16/Data32
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 382561951e3460b09c21a1a23748cde0315fbb19
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jan 1 20:31:54 2017 -0800

    specs/libX11: Add missing parameter types for XGetWindowProperty()
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 2beaecdb66965b861d6b790d151ba947f65f0a22
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jan 1 20:16:08 2017 -0800

    specs/libX11: Make paramdef spacing more consistent
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 4c436c6c14cfd4c397b011563bf13c2872861133
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jan 1 20:02:53 2017 -0800

    specs/libX11: Fix paramdef entries listing multiple parameters
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 1728b1a8a4718315da8e5c9cbc2c04bb75c74107
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jan 1 19:38:40 2017 -0800

    specs/libX11: More synopsis fixes
    
    Mostly transforming macro definitions and functions taking void arguments
    from undecorated <para> tags to use <funcsynopsis> tags to get decorations.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f0dc83db7e3a3d4a76c0f9d24763b80f01c893a9
Author: Lucien Gentis <lucien.gentis@waika9.com>
Date:   Wed Jun 1 17:02:47 2016 +0200

    Typos in "Xlib - C Language X Interface" document - Chapter 02
    
    This patch fixes typos and lack of tags in "Xlib - C Language X Interface" document - Chapter 02.
    
    Signed-off-by: Lucien Gentis <lucien.gentis@waika9.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 20a3f99eba5001925b8b313da3accb7900eb1927
Author: Emilio Pozuelo Monfort <pochu@debian.org>
Date:   Tue Oct 25 21:30:15 2016 +0200

    Plug a memory leak
    
    This was introduced in 8ea762f.
    
    Reported-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Emilio Pozuelo Monfort <pochu@debian.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8f349feac24aacc958bd816afcc52380764e3d92
Author: Matthieu Herrb <matthieu.herrb@laas.fr>
Date:   Tue Oct 4 21:01:39 2016 +0200

    libX11 1.6.4
    
    Signed-off-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 8ea762f94f4c942d898fdeb590a1630c83235c17
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Sun Sep 25 21:25:25 2016 +0200

    Validation of server responses in XGetImage()
    
    Check if enough bytes were received for specified image type and
    geometry. Otherwise GetPixel and other functions could trigger an
    out of boundary read later on.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 8c29f1607a31dac0911e45a0dd3d74173822b3c9
Author: Tobias Stoeckmann <tobias@stoeckmann.org>
Date:   Sun Sep 25 21:22:57 2016 +0200

    The validation of server responses avoids out of boundary accesses.
    
    v2: FontNames.c  return a NULL list whenever a single
    length field from the server is incohent.
    
    Signed-off-by: Tobias Stoeckmann <tobias@stoeckmann.org>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 78851f6a03130e3c720b60c3cbf96f8eb216d741
Author: walter harms <wharms@bfs.de>
Date:   Mon Aug 15 19:18:14 2016 +0200

    XFree will accept NULL as argument
    
    since Xfree is a define for free():
      Xlibint.h:#define Xfree(ptr) free((ptr))
    
    Xfree will accept NULL and do nothing.
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>

commit 83adf3d1e3d0d6602244381334f75c216da4ab6e
Author: Matthew D. Fuller <fullermd@over-yonder.net>
Date:   Sat Jun 4 11:24:01 2016 -0500

    Fixup param specification for XChangeProperty()
    
    Signed-off-by: Matthew D. Fuller <fullermd@over-yonder.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3129c757f9da8586ab8b8654a56c8f687cc9ef5c
Author: Mats Blakstad <mats.gbproject@gmail.com>
Date:   Sun Feb 28 13:22:03 2016 -0500

     New compose keys for local languages in Togo
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit e1011b9e2f6c82255959cf3cc1d8cda402ded0a9
Author: Daniel Albers <daniel@lbe.rs>
Date:   Wed Mar 9 14:35:48 2016 +0100

    Add Compose sequence for U+1F4A9.
    
    Signed-off-by: Daniel Albers <daniel@lbe.rs>

commit 6d7bb040c928485f2557c2c914b95cffb2354179
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 6 14:18:32 2016 -0800

    xcms: use size_t for pointer offsets passed to strncmp
    
    instead of converting to int and back
    
    Fixes clang warnings of the form:
    HVC.c:190:43: warning: implicit conversion changes signedness: 'int' to
          'unsigned long' [-Wsign-conversion]
              if (strncmp(spec, _XcmsTekHVC_prefix, n) != 0) {
                  ~~~~~~~
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a9266804eed38a83897ab5f0f9f8a8ab82a98882
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 6 13:32:44 2016 -0800

    xcms: use unsigned indexes when looping through unsigned values
    
    Clears many gcc warnings of the form:
    
    uvY.c: In function ‘XcmsCIEuvYToCIEXYZ’:
    uvY.c:263:19: warning: comparison between signed and unsigned integer
      expressions [-Wsign-compare]
         for (i = 0; i < nColors; i++, pColor++) {
                       ^
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0ee0d383b4488b7b90d8bd50b75c371e0dc0d397
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 6 13:01:25 2016 -0800

    xcms: use size_t for strlen/sizeof values instead of converting to int & back
    
    Fixes gcc warnings of the form:
    
    IdOfPr.c: In function ‘XcmsFormatOfPrefix’:
    IdOfPr.c:69:32: warning: comparison between signed and unsigned integer expressions [-Wsign-compare]
         if ((len = strlen(prefix)) >= sizeof(string_buf)) {
                                    ^
    IdOfPr.c:83:11: warning: comparison between signed and unsigned integer expressions [-Wsign-compare]
       if (len >= sizeof(string_buf)) Xfree(string_lowered);
               ^
    IdOfPr.c:97:11: warning: comparison between signed and unsigned integer expressions [-Wsign-compare]
       if (len >= sizeof(string_buf)) Xfree(string_lowered);
               ^
    IdOfPr.c:104:13: warning: comparison between signed and unsigned integer expressions [-Wsign-compare]
         if (len >= sizeof(string_buf)) Xfree(string_lowered);
                 ^
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 4de6ed3e7b1833c52c9d58ab74d59d57ca2a9f0d
Author: Dominik Muth <nxdomainuser-muth@yahoo.com>
Date:   Thu Mar 26 07:52:58 2015 +0100

    Xlib.h: Fix macros imitating C functions.
    
    The basic rule "put parantheses around macro parameters" should be
    observed where possible. Otherwise code like
    
        ConnectionNumber(foo = bar);
    
    fails to compile. (It obviously passes if ConnectionNumber is a C
    function.) There are several other macros amended for the same reason.
    
    This bug appeared while building http://ioccc.org/1993/cmills.c, so
    historically it was not present.
    
    Signed-off-by: Dominik Muth <muth@nxdomain.no-ip.biz>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3706b0f2b14cc97578a6bee620266edca2722ebf
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Nov 15 18:03:25 2013 -0800

    Don't need to link libX11-xcb against libX11
    
    libX11-xcb only accesses data structures defined in X11 headers,
    it doesn't call any functions or reference any global variables
    in libX11 itself.  (Seems to have been left from previous XCL
    implementation.)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit eddf1bbd18872b286a9f939140f0cd9ba4e93804
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jan 22 11:44:25 2016 -0800

    Stop checking for preferred order of local transports
    
    Removes --with-local-transport-order=... flag to configure.
    
    Code which used this ordered list was removed in commit 15e5eaf6289
    which outsourced X11 connection handling & authentication to libxcb.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 1a66c1e964ff8d11382313404f48b5a3d5ed8be8
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jan 22 09:39:28 2016 -0800

    Stop checking XTRANS_SECURE_RPC_FLAGS since we no longer use them
    
    Removes --enable-secure-rpc & --disable-secure-rpc flags to configure
    
    Code that used SECURE_RPC definitions was removed in commit 15e5eaf6289
    which outsourced X11 connection handling & authentication to libxcb.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 7eb724dc24505f1591ef32620fa63f079b540646
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Jan 21 11:54:19 2016 +0100

    XKB: fix XkbGetKeyboardByName with Xming server
    
    XkbGetKeyboardByName relies on flags to read the data from the server.
    
    If the X server sends us the wrong flags or if a subreply is smaller
    than it should be, XkbGetKeyboardByName will not read all the available
    data and leave data in the buffer, which will cause the next _XReply()
    to fail with:
    
    [xcb] Extra reply data still left in queue
    [xcb] This is most likely caused by a broken X extension library
    [xcb] Aborting, sorry about that.
    xcb_io.c:576: _XReply: Assertion `!xcb_xlib_extra_reply_data_left' failed.
    Aborted
    
    Check if there is some extra data left at the end of
    XkbGetKeyboardByName() and discard that data if any is found.
    
    Many thanks to Peter Hutterer <peter.hutterer@who-t.net> for finding the
    root cause of the issue and Adam Jackson <ajax@redhat.com> for helping
    with the analysis!
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Daniel Stone <daniels@collabora.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 43ba0a68d3d17b496ec1f48d44921122ddd7d7d9
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 18:03:41 2015 -0800

    lcPubWrap: replace malloc(strlen) + strcpy with strdup
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 6fc95cb12b70c5a67cb4fc5e5749f9f1ec741e2a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 10:21:04 2015 -0800

    XlcDL.c: reduce code duplication
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit f7ecc0856be58608881d2086954cb71857ad64e1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 10:19:25 2015 -0800

    XlcDL.c: replace strcpy+strcat sequences with snprintf
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 522989b34398bd6a6ea144c4af0ba69d6dc4faea
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 10:05:42 2015 -0800

    XDefaultOMIF: Remove comments referring to ancient Sun bug ids
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit b738a104ae80e4270dd1d215ad0c6a80016982c2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 10:00:22 2015 -0800

    XDefaultOMIF: additional code simplification
    
    Don't need to test for a case that we already returned for, don't need
    to store a count that will only ever be 1 if we didn't return, don't
    need to increment pointers to allow storing more than one item when we
    can only ever possibly do one.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 31011cf100419269eae7409581c784638be503cf
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 09:46:31 2015 -0800

    XDefaultOMIF: replace strlen+Xmalloc+strcpy with strdup
    
    Code seems to have been originally written to handle appending multiple
    strings, but only ever operates on a single string.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit c27c46d5e22bbf60fb5608eaabe584b7fdeb0b09
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Dec 19 09:20:55 2015 -0800

    Use strdup instead of Xmalloc+strcpy in _XDefaultOpenIM
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 4359dfabc04af082872d2bc2d5b52e26d6d93290
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Dec 4 22:20:53 2015 -0800

    Delete #if 0 hunks of code
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a2f9dfac286f37e54eb47d4736cc3f0150224a84
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Dec 3 23:38:07 2015 -0800

    Bug 93183: _XDefaultOpenIM memory leaks in out-of-memory error paths
    
    Rework code to store allocations directly into XIM struct instead of
    temporary local variables, so we can use _XCloseIM to unwind instead
    of duplicating it, and consistently jump to error handler on failure,
    instead of sometimes leaking and sometimes freeing.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93183
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 07a97b3944467dce085a1efd24706cc851d2caf2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Dec 3 23:19:48 2015 -0800

    Bug 93184: read_EncodingInfo invalid free
    
    Free the correct bits of memory if we run out and need to unwind
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93184
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 11118e9eb3705fcbe42b6a68d4a8aa86ab0211f1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Nov 28 13:18:11 2015 -0800

    Remove unused definition of XCONN_CHECK_FREQ
    
    The only use of XCONN_CHECK_FREQ was removed in commit 15e5eaf62897b3179
    when we dropped the old Xlib connection handling in favor of xcb's.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Mark Kettenis <kettenis@openbsd.org>

commit 5f0da8311a61498edf073cc877f5b467bfd5f863
Author: James Cloos <cloos@jhcloos.com>
Date:   Thu Dec 3 18:24:44 2015 -0500

    Fix another missing update in cf4d5989383a
    
    Reported in:
    
       https://bugs.freedesktop.org/show_bug.cgi?id=81875#c7
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 33840a5465a2e5fecab520bfbdd2d1bd0a456f51
Author: James Cloos <cloos@jhcloos.com>
Date:   Thu Dec 3 18:15:40 2015 -0500

    Fix missing update in cf4d5989383a
    
    Reported in:
    
       https://bugs.freedesktop.org/show_bug.cgi?id=81875#c7
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit dbcb847a08c44d99e4e1de2ba777d63238fb0e03
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Sep 27 18:38:32 2015 -0700

    Get rid of some extraneous ; at the end of C source lines
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Thomas Klausner <wiz@NetBSD.org>

commit 121a1bad334459f66f78bfca6df53dc841cf97f8
Author: Gunnar Hjalmarsson <gunnarhj@ubuntu.com>
Date:   Wed Sep 23 11:44:55 2015 -0400

    Add compose file for pt_PT similar to pt_BR
    
    This is a forward of the Ubuntu bug https://launchpad.net/bugs/518056
    
    One of the conclusions from the discussion on that bug report, which
    basically is about typing the ccedilla character easily on a non-
    Portuguese keyboard, is that X11 should include a compose file for
    pt_PT.UTF-8 similar to the file for pt_BR.UTF-8.
    
    FDO bug: https://bugs.freedesktop.org/show_bug.cgi?id=90300
    
    Signed-off-by: Gunnar Hjalmarsson <gunnarhj@ubuntu.com>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 3f41d8a7f82eb5ffbd5c5d36472cf7043186b904
Author: Julien Cristau <jcristau@debian.org>
Date:   Fri May 1 13:50:15 2015 +0200

    Mark _XNextRequest as hidden
    
    It's only used inside XNextRequest(), so doesn't need to be exported.
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a72d2d06c002b644b7040a0a9936c8525e092ba8
Author: Christian Linhart <chris@demorecorder.com>
Date:   Mon Sep 7 17:17:32 2015 +0200

    fix for Xlib 32-bit request number issues
    
    Make use of the new 64-bit sequence number API in XCB 1.11.1 to avoid
    the 32-bit sequence number wrap in libX11.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=71338
    Signed-off-by: Christian Linhart <chris@demorecorder.com>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 58af066a764305c506efea7065ef7679369a1a98
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Sun Jul 19 10:23:21 2015 +0200

    Ignore test-driver (used by newer autoconf).
    
    Signed-off-by: Thomas Klausner <wiz@NetBSD.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 80b9a346b9ba200fa4652560282e80d249519287
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Sun Jul 19 10:22:45 2015 +0200

    Do not return() after exit().
    
    Signed-off-by: Thomas Klausner <wiz@NetBSD.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c827edcd1c4a7f920aa25208083b5b58d60d2b44
Author: Ross Burton <ross.burton@intel.com>
Date:   Mon May 18 14:49:01 2015 +0100

    Add missing NULL checks to ICWrap
    
    ICWrap.c dereferences the xim parameter passed in from client code without a
    NULL check.  I have seen mplayer trigger this resulting in a segfault.  In this
    case mplayer had called XOpenIM and NULL was returned which was later passed
    into XCreateIC.
    
    Patch originally by Drew Moseley <drew_moseley@mentor.com>.
    
    Signed-off-by: Ross Burton <ross.burton@intel.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 26e0d2de294f8adf1ce65f1dbff0b59af41a00b9
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jun 4 20:51:17 2015 -0700

    Replace Xmalloc+memset pairs with Xcalloc calls
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f0286b2770ece10aef5e2e8c004260217f12fd25
Author: Bhavi Dhingra <b.dhingra@samsung.com>
Date:   Thu Jun 4 19:07:12 2015 -0700

    omGeneric.c: Correct the parameter usage of sizeof
    
    Incorrect parameter usage with sizeof. Earlier passed argument FontData
    will be 4 bytes always as its a pointer hence the change is needed and
    FontDataRec should be used for memset.
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 47da70d75f9e48e800719c0db752f9ccd2d77aea
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue May 19 12:30:22 2015 +1000

    Fix three "use of uninitialized variable" coverity warnings
    
    False positive, if rlen/nbytes are unset we quit early before using it. Still,
    initialize it so we don't have to deal with these warnings again.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 19a30f17f30e9ae9641a7c0634fc52134208b060
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 18 07:56:22 2015 +1000

    Fix an indentation issue
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 013ccece124b990217ad3bcf2c41688e8fda1df8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 18 07:55:17 2015 +1000

    Fix potential memory leak
    
    If we hit the depth limit, filename leaks. Move the depth check up before we
    allocate filename.
    Introduced in 226622349a4b1e16064649d4444a34fb4be4f464.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d3415d1f052530760b4617db45affcb984cfe35c
Author: Mike FABIAN <mfabian@redhat.com>
Date:   Mon Apr 20 17:59:30 2015 +0200

    Fix spelling mistake introduced by 748d47e69f5c12d8557d56a8a8ec166588da7b93
    
    Sorry, my patch to fix the spelling mistakes in the ks_IN and sd_IN
    locales fixed it only partly, I introduced a new spelling mistake
    in the sd_IN locales. This patch fixes this.
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 748d47e69f5c12d8557d56a8a8ec166588da7b93
Author: Mike FABIAN <mfabian@redhat.com>
Date:   Wed Feb 19 11:46:45 2014 +0100

    fix spelling mistakes in ks_IN and sd_IN devanagari locales
    
    The codeset must be *before* the modifier.
    
    See also: http://pubs.opengroup.org/onlinepubs/7908799/xbd/envvar.html
    
    opengroup> The syntax for these environment variables is thus defined as:
    opengroup>
    opengroup> [language[_territory][.codeset][@modifier]]
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit c64fe5553aa4738f9d1d74a795f5651fbb7b1b09
Author: Mike FABIAN <mfabian@redhat.com>
Date:   Wed Feb 19 11:50:55 2014 +0100

    add be_BY.UTF-8@latin and sr_RS.UTF-8@latin to locale.dir
    
    See also: https://bugzilla.redhat.com/show_bug.cgi?id=1066910
    
    If these are not in locale.dir,
    
        $ LANG=sr_RS.UTF-8@latin xterm
    
    and
    
        $ LANG=sr_RS@latin xterm
    
    give the warning:
    
        Warning: locale not supported by Xlib, locale set to C
    
    and some programs (like xmms) fail to find translations for Serbian
    in Latin because of this.
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit c85be01b006126c4407eebd1eb6e01a17312b7b4
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Mar 22 16:46:45 2015 -0700

    Move Compose \ o / to be with other emoji compose sequences
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5a499ca7b064bf7e6a4fcc169f22862dce0c60c5
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Mar 9 15:28:29 2015 -0700

    libX11 1.6.3
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c8e19b393defd53f046ddc2da3a16881221b3c34
Author: Joonas Javanainen <joonas.javanainen@gmail.com>
Date:   Thu Feb 5 17:31:04 2015 +0200

    Fix XErrorEvent struct field order in man page
    
    In the man page the field "resourceid" was in a different place than
    in the actual struct layout in Xlib.h
    
    Signed-off-by: Joonas Javanainen <joonas.javanainen@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ddf3b09bb262d01b56fbaade421ac85b0e60a69f
Author: Ran Benita <ran234@gmail.com>
Date:   Tue Feb 3 13:23:50 2015 -0500

    compose: fix the description of modifiers in compose sequences
    
    The Compose format has a feature which allows specifying certain
    modifiers must (or must not) be present with a given keysym in the
    sequence.
    
    The grammar in imLcPrs.c and the Compose man page both do not match what
    the code actually does (see the handling of the variables
    `modifier_mask` and `modifier` in parseline() in imLcPrs.c, which are
    eventually matched as `ev->state & modifier_mask == modifier`).
    
    Also explicitly list the accepted modifier names, since they are
    not standard (e.g. "Ctrl" instead of "Control").
    
    Signed-off-by: Ran Benita <ran234@gmail.com>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 129f13f385c50e3d8b53ea7441b17386b0f36aeb
Author: Ran Benita <ran234@gmail.com>
Date:   Tue Feb 3 13:23:49 2015 -0500

    xkb: fix misleading comment about consumed modifiers
    
    In the spec and the man page the `mods_rtrn` argument is described as
    "backfilled with unconsumed modifiers" but actually it is backfilled
    with the *consumed* modifiers. This is also mentioned a few lines below
    in each case.
    
    Signed-off-by: Ran Benita <ran234@gmail.com>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 446f5f7f41317a85a0cd0efa5e6a1b37bc99fba2
Author: Ingo Schwarze <schwarze@usta.de>
Date:   Tue Dec 9 10:44:13 2014 +0100

    Fix pasto in XkbGetKeyBehaviors(3) manual
    
    Reviewed-by: Thomas Klausner <wiz@NetBSD.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f3831dde6972e4da9e018c6a5f4013d8756a5e78
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Sun Nov 23 21:35:36 2014 +0100

    nls: Sorting compose sequences rigorously in mirroring pairs, as is custom.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>

commit a51681b60c84109fe19f5d449e13080522499324
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Thu Sep 19 16:42:01 2013 +0200

    nls: Remove a duplicate locale name, and sort some others more strictly.
    
    Also improve the grammar of the initial comment.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 426b7f850f5376db96a4b12420ee141603fcc3cd
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Fri Sep 20 12:37:29 2013 +0200

    nls: Add a comment to the block of accented Hebrew letters.
    
    And align them in a nicer manner.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 7474c6f1ee78dd097b1d0b4c7e3e4ea41317e335
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Fri Sep 20 12:05:09 2013 +0200

    nls: Add one lowercase compose variant for ®, to mirror those for ©.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 18dcd13514fa538afefa78c93523d9dbd4688e74
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Sat Sep 7 20:10:43 2013 +0200

    nls: Adding the visual composing characters to two comment lines.
    
    The lines around them also contain the characters in the comments.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 18d8307575af748913d5da17e3de45da2a22ede4
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Sat Sep 7 20:09:32 2013 +0200

    nls: Grouping a lone superscript minus together with its mates.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 33301cc45e6a2b8aa841ed6325547af970f8c4db
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Sat Sep 7 19:53:38 2013 +0200

    nls: Grouping the compose sequences for Dstroke/dstroke together.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 78fe1becb6c18fa33c0d5f04005b45d856f8952a
Author: Gioele Barabucci <gioele@svario.it>
Date:   Sun Sep 21 23:05:55 2014 +0200

    Add compose sequence for U+20B9 INDIAN RUPEE SIGN
    
    The compose sequence for the new Indian Rupee sign is modelled after
    the sequence for the Euro sign.
    
    Signed-off-by: Gioele Barabucci <gioele@svario.it>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 6101b967b641355dd863fd1ce52c6a7d58bcbe68
Author: Gabriel Souza Franco <gabrielfrancosouza@gmail.com>
Date:   Thu Jul 31 22:23:28 2014 -0300

    Add double-arrow compose sequence
    
    Signed-off-by: Gabriel Souza Franco <gabrielfrancosouza@gmail.com>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 368a6401c6a3275d3497fec38a3dcbc38cd9df60
Author: James Cloos <cloos@jhcloos.com>
Date:   Fri Aug 1 18:30:42 2014 -0400

    Add cs_CZ.UTF-8 locale to configure.ac
    
    Commit cf4d5989383a should have included this.
    
    Reported-by: Colin Harrison <colin.harrison@virgin.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit cf4d5989383acc4ed1b7eebadde9f380f2129766
Author: James Cloos <cloos@jhcloos.com>
Date:   Tue Jul 29 15:02:56 2014 -0400

    Add nls for cs_CZ.UTF-8
    
    Based on the iso8859-2 compose, and a bug report by Vladimír Marek,
    override the en_US.UTF-8 use of <dead_caron> <u> to enter »ǔ« instead
    to enter »ů«, and likewise for the majuscule, for the Czech locale.
    
    This evidently is the norm for Czech keyboards.
    
    Fixes bz#81875.
    
    The XI18N_OBJS and XLC_LOCALE.pre files are empty, as they are for
    several other locales.  That may require an update.
    
    Reported-by:  Vladimír Marek <vlmarek@volny.cz>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit d9f569572bd14db31921471e7b877523b5cf1e4c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 26 12:17:47 2014 -0700

    Fix source paths for out-of-tree lintlib builds
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0885cad1e4a9ed57266582be320be55259c881bf
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 20 09:21:20 2014 -0700

    specs/XKB: Markup fractions as <{super,sub}script> instead of <emphasis>
    
    Matches the way they were styled in original doc, before conversion
    to DocBook.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d0a9e9d56bb003315787201ee525b4d00fd54e06
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 23:55:47 2014 -0700

    specs/XKB: acknowledge my contributions
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9c0be82017f513e2eb63d59b095f1cf1955f2e2b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 23:53:48 2014 -0700

    specs/XKB: Trim leading spaces off text lines
    
    perl -i -p -e 's{/\*(\S)}{/* \1}g;' *.xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 75b0b10990f38d966c6fcc821bf15e58c5a90c91
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 20:30:55 2014 -0700

    specs/XKB: Add olinks to libX11 for "X Library Functions Affected by Xkb"
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5009621799444e9d1d284719f871d00be13e7330
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 12:34:28 2014 -0700

    specs/XKB: Fix miscelleanous typos & spelling errors
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ac219bf1522a592bd3e3283b1a6ea3dfd2c3c48c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 00:46:41 2014 -0700

    specs/XKB: add some more indexterms by hand
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5c3aa4c69e65ecf2e56d5e26f3833fb5d31973c2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 00:48:02 2014 -0700

    specs/XKB: fixup various formatting issues in <programlisting>s
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 70c648ff852fd9bc784967cfc77ea70bd7f14c8d
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 23:56:29 2014 -0700

    specs/XKB: fixup various formatting issues in <literallayout>s
    
    Including translating some that are really just lists into
    <simplelist> markup.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 94b56774784ac00b9db02403aecea10bb0814c10
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 23:18:52 2014 -0700

    specs/XKB: add some more links by hand
    
    random bits where a link looked handy
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7a15a934cdb07ed1b991bd0ef633f32ee00b1833
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 23:16:31 2014 -0700

    specs/XKB: add links for terms in definition list under figure 1.1
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 92b86fc3c50fbb7ab2e36af10a2fb3fe6284f58c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 22:52:16 2014 -0700

    specs/XKB: add links to more tables listing section references
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 06a4483a05053b4f8d8c0d4cc0513c68ea912676
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 22:49:34 2014 -0700

    specs/XKB: Table 4.1: remove page numbers & unnecessary para tags
    
    Page numbers refer to old doc format, didn't translate to new one
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 61bd55c6d1ab211b89d604bd05555dc417f6e53d
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 11:55:51 2014 -0700

    specs/XKB: remove unwanted white space around C -&gt; struct references
    
    perl -i -0 -p -e 's{\s*-&gt;\s*}{-&gt;}g' *xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 2be0cc0b2abbcc98cfd150210dea415a04787251
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 22:26:20 2014 -0700

    specs/XKB: replace -&gt; with &rarr; when used as arrow, not in C structs
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit bf1f3d6f6f995303624679ae546f507c70967dc0
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 22:21:10 2014 -0700

    specs/XKB: replace =&gt; with &rArr; for double arrows
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c7ee427fc0a72abd4a4f147ab16a5d1128a6a2ba
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 11:33:35 2014 -0700

    specs/XKB: Markup some ranges with &ndash; instead of -

commit ec4075303c6c0d1d64bfe378e585968f9a137da7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 22:10:45 2014 -0700

    specs/XKB: Markup some subtractions with &minus; instead of -
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 441a267e461132a38abed205245f028686526f1d
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 22:04:40 2014 -0700

    specs/XKB: make sure all files have DOCTYPEs so standard entities work
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 88fd70bee410f290b4f540405fdc7ecd85c26f25
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 21:55:41 2014 -0700

    specs/XKB: Markup quoted terms as <quote> instead of with ""
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3576587ff10334a8f48c34b4fe5b7e829dec9a1b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 19 09:01:26 2014 -0700

    specs/XKB: fixup newlines between tags and punctuation
    
    Get rid of unwanted whitespace before punctuation by moving them to the
    lines with the tags, instead of before & after.
    
    perl -i -0 -p -e 's{\>\s*\n([\.,;:])}{>\1\n}g' *xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6d5ec492cd28c206423337f926503349702af5a6
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 21:29:33 2014 -0700

    specs/XKB: fixup newlines between tags and parens
    
    Get rid of unwanted whitespace inside parens by moving them to the
    lines with the tags, instead of before & after.
    
    perl -i -0 -p \
         -e 's{(?<!--) \(\s*\n\<}{\n(<}g;' \
         -e 's{\>\s*\n\)([\.,;]?)(?! [^\n]*--)}{>)\1\n}g' *xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 59d688f4c787250e0b401a92b1db0437d8c60f2d
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 18 21:09:24 2014 -0700

    specs/XKB: Markup key terms as <firstterm> instead of <emphasis>
    
    Also add <indexterm> entries for most of them, to make their definitions
    or introductions easy to find from the index.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 861f3087ee0f501362a67501f384c2ca4c7bfe73
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 20:00:53 2014 -0700

    specs/XKB: Manual fixup of type markup
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6b96259dabe52701fd1bcaa0625b574180c4e769
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 15:00:30 2014 -0700

    specs/XKB: Manual fixup of parameter markup
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5526dce6812a84102f556fdde8f2b52b21c8bcdc
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 13:40:40 2014 -0700

    specs/XKB: Manual fixup of struct name/field markup
    
    Handles typos that caused the scripts to miss matches, misnamed structs, etc.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c36ee1a4db4e7876526190b8ab6b0da5867f76f7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Jul 9 23:26:37 2014 -0700

    specs/XKB: Manual fixup of symbol name markup
    
    Handles typos that caused the scripts to miss matches, misnamed masks, etc.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit eb1453a0c69606b8af96b90ddccf1b93a069fb35
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Jul 9 00:03:23 2014 -0700

    specs/XKB: Manual fixup of function name markup
    
    Handles typos that caused the scripts to miss matches, functions like
    malloc & free from other libraries, function name patterns, etc.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 252d99c87b60ac6f3f2b36f292f9b3880daabe26
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 19:42:31 2014 -0700

    specs/XKB: Markup protocol requests as <systemitem> instead of <emphasis>
    
    No great fit in DocBook, so follow what we used in Xlib spec.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ed60df10aad15057577d5714c955d22d2a446e51
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 15:45:57 2014 -0700

    specs/XKB: Markup keyboard keys as <keycap> instead of <emphasis>
    
    Also uses <guilabel> for LED names/labels, for lack of a better fit
    in DocBook.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f57b91ee497414083cc1bf481d28eb9ad9f965fb
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 15:41:19 2014 -0700

    specs/XKB: Markup characters & strings as <literal> instead of <emphasis>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit cfd4279c9b59d7e87c9f7c67692c87973adb7667
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Jul 10 11:08:14 2014 -0700

    specs/XKB: Markup structs as <struct{name,field}> instead of <emphasis>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a014bb4cc013b0d1b76524b7868e860c7e7ebc79
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Jul 9 23:30:54 2014 -0700

    specs/XKB: Markup symbol names in table entries too
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 907f7ad7a7a977bf4f19daa3143d47c4d07ca33d
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 23:35:48 2014 -0700

    specs/XKB: Markup *Ptr as <type> instead of <emphasis>
    
    perl -i -p -e 's{<emphasis>(\w*Ptr)</emphasis>}{<type>\1</type>}g' *xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9f6c00629fd4b713082cc11f9150f7aafd272c89
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 23:34:29 2014 -0700

    specs/XKB: Markup *Rec as <structname> instead of <emphasis>
    
    perl -i -p -e \
     's{<emphasis>(\w*Rec)</emphasis>}{<structname>\1</structname>}g' *xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 83839e37802b8b752c77859a95de60ad757feb79
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 23:29:49 2014 -0700

    specs/XKB: Markup XKB macros as <symbol> instead of <emphasis>
    
    Performed via:
     perl -n -e 'printf "s{<emphasis>\\s*%s\\s*</emphasis>}{<symbol>%s</symbol>};\n", $1, $1 if m{^#define\s+([^\s\(]*)}' \
      /usr/include/X11/extensions/XK*h /usr/include/X11/XKBlib.h \
      | sort -u > xkb-defines.pl
     perl -i -p -f xkb-defines.pl *.xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9e397ed37ce4cc70621de347de3a795df88d4506
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 22:53:12 2014 -0700

    specs/XKB: Use ° instead of o for degrees.
    
    Conversion from framemaker turned superscripted "o" into plain "o".
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3b8364c21f5119105a2c14ae8cc75a11494cb7a7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 22:46:03 2014 -0700

    specs/XKB: Markup keysyms as <keysym> instead of <emphasis>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 33bef065683c8f910f3722730503c0c0699ee8be
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 22:26:56 2014 -0700

    specs/XKB: Markup NULL as <symbol> instead of <emphasis>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f10aa1e09468bd28454d85ac8ab55d9dc7178029
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 22:22:29 2014 -0700

    specs/XKB: Markup function args as <parameter> instead of <emphasis>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 79ba58cceb69521fcb313c69233cf93a9fcb177f
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 23:56:13 2014 -0700

    specs/XKB: Convert remaining error names to errorname tags
    
    Most were caught by applying libX11 lists, but BadKeyboard & XKB*_Bad*
    are XKB-specific.   (Plus some were badly split across tag boundaries.)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 42b2f5388c399949ece377f9cc9c479c06964972
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 23:16:56 2014 -0700

    specs/XKB: manually fixup some more emphasis tagging mismatches
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3b2f47d44a55d93c65455ff183f3b47da04b1de1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 23:02:31 2014 -0700

    specs/XKB: re-normalize <emphasis> layout in xml files
    
    Same script as before, just with <!-- xref --> comments out of the way
    now.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ce95f152eda509263874c53fb7c6b4a6bdab2c29
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 22:59:25 2014 -0700

    specs/XKB: Remove remaining xref comments
    
    All the places marked by these have been turned into the appropriate
    link, xref, or olink tags now.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6590b66e19af8dff68888ac403ac82f5d585b4e2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 22:56:36 2014 -0700

    specs/XKB: make olinks to xkbproto for references in section 10.13
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit fcda446877a62e7443d7bc704ba3610e90d1e755
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 22:22:28 2014 -0700

    specs/XKB: Add <figure> tags and make Figure references link to them
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 087a2338476719e340dc3d5af0df6fdc4a26ce7a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 7 21:30:01 2014 -0700

    specs/XKB: Turn Table references into links
    
    Adds id attributes to all table tags so we can link to them
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 135fa07b74cb50172c6a75768d499cd87ddb336e
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 21:29:59 2014 -0700

    specs/XKB: Turn section references into xref links
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 53e931d79926af8a3996253efd8b5f6c21d9e5d7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 21:17:18 2014 -0700

    specs/XKB: Turn Chapter references into xref links
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b7f00ce5bcb0c00696bb82503ab548e14f04d17d
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 20:40:18 2014 -0700

    specs/XKB: Apply <emphasis> to semantic tag transformations from Xlib spec
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b00a7ddff2744238fbfe31c2298b02028a45a6ff
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 20:34:51 2014 -0700

    specs/XKB: Markup function names as <function> instead of <emphasis>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit bfbb58b7679221cb5c9212665209ea9099ad079a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 20:25:46 2014 -0700

    specs/XKB: normalize <emphasis> layout in xml files
    
    - Stop placing <emphasis> on empty space, commas, and periods.
    - Move periods & commas after closing </emphasis> tag
    - move <emphasis> open & close tags to same line, instead of mirroring
      nroff layout.
    
    Simplifies automating further transformations of these tags.
    
    Performed via:
     perl -i -0 -p \
        -e 's{<emphasis>(\s*)</emphasis>}{}msg;' \
        -e 's{<emphasis>([\s\.,]*)</emphasis>\s*}{\1}msg;' \
        -e 's{\n([\.,])\s*}{\1\n}msg;' \
        -e 's{([^\.])([\.,])\s*</emphasis>}{\1</emphasis>\2}msg;' \
        -e 's{\s*<emphasis>\n\s*}{\n<emphasis>}msg;' *xml
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b16ee69a0103109a661a88140a1765dcd7bda634
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 15:57:41 2014 -0700

    specs/XKB: Convert to funcsynopsis+variablelist instead of informaltable
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b41d43d4cf0c0a1a049a171ee8cf6fd8a3ee4335
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 19:29:38 2014 -0700

    specs/XKB: Add index
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 72ae1d793be078db521dda60af578ece71f364de
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 13:21:40 2014 -0700

    specs/XKB: Fix various markup issues in functiondecl tables
    
    - Merge some functionargdecl entries incorrectly split across rows
    - Add missing parameter name markup to some functionargdecls
    - Add missing function prototype markup to a functiondecl
    - Remove stray emphasis tags in a functiondecl
    
    Allows them to correctly convert to funcsynopsis markup in next step.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9fdb973012de80ac60dbc59c39162f4e839fc5a4
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 12:15:23 2014 -0700

    specs/XKB: Convert header filenames to filename tags
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5525e8433f93bce464412f27cffa203ea628f368
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 8 00:05:32 2014 -0700

    specs/libX11: disengender a user reference
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d8679eae9317b389ad4acb0430360ee0663e2af8
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 11 18:41:42 2014 -0700

    specs/libX11: Correct value of IconicState to match Xutil.h
    
    Xutil.h has always had a value of 3 for IconicState, since 2 was
    previously used for the long-obsolete ZoomState, so make the spec
    match what programs have used for decades.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 7ce2b0f12a48fb832f457cbafb0e1144ef557f9a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jul 11 10:34:08 2014 -0700

    Use C99 named initializers to fill in events passed to XSendEvent
    
    Forces compiler to zero-fill unset fields in the struct (fixing bug 81236)
    and allows optimizer to order field initialization to best fit cache layout
    or other considerations.
    
    Before & after output of gcc -S on AMD64 shows insertion of "rep stosq"
    instructions to rapidly zero-fill structs.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>

commit 169805e1dc8743b37b00e24cf3a5eb8748f733ad
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 11:13:49 2014 -0700

    Fix validation of ctrls parameter to XkbGetPerClientControls()
    
    Nothing in the XKB spec states that the memory pointed to by ctrls has to
    be initialized to any given value when passed to the function, only that
    it is set by the function to the values returned by the X server:
    http://www.x.org/releases/X11R7.7/doc/libX11/XKB/xkblib.html#The_Miscellaneous_Per_client_Controls
    
    The check for the incoming value seems to be copied from
    XkbSetPerClientControls without explanation.
    
    Instead change it to checking if ctrls is non-NULL, since there's no
    point asking the X server to return a value the caller won't even see.
    
    Found while investigating report from cppcheck-1.65:
    [src/xkb/XKB.c:699] -> [src/xkb/XKB.c:719]: (warning) Possible null pointer
     dereference: ctrls - otherwise it is redundant to check it against null.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 1e362fac92c6688fb42b195ccad16d7a337a34c1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 10:54:57 2014 -0700

    Fix map->num_types check in XkbAddKeyType()
    
    Check is intended to ensure we allocate at least XkbNumRequiredTypes
    in map, but was accidentally marked with a ! causing the wrong check.
    
    Reported-by: Harms <wharms@bfs,de>
    Reviewed-by: Matthieu Herrb <matthieu@herrb.eu>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ff9a5c199251a84fa59d14fd48dadb3f8920b54b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 15:08:21 2014 -0700

    specs/libX11: Add missing spaces to 'unsignedint' & 'unsignedlong' types
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a06ea86773568926c36ae650b188fc818d540db7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 15:04:27 2014 -0700

    specs/libX11: Fix height & width in parameter lists to be two separate entries
    
    "unsigned int width, unsigned int height", not a single parameter "height"
    of type "unsignedintwidth,".
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e4db5e503682b3304fe82e4b17b419a8e0f0a9f2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Jul 6 14:38:10 2014 -0700

    specs/libX11: Fix x & y in parameter lists to be two separate parameters
    
    "int x, int y" not a single parameter y of type "intx"
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit aa8bda0db2c6d82515b90ceb4a7d6403e38895e9
Author: walter harms <wharms@bfs.de>
Date:   Sat Jun 7 12:03:17 2014 +0200

    lcDefConv.c: fix use before check
    
    * Do not use variables before checked for NULL.
    * remove some superfluid spaces (Mark Kettenis)
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c0670e5d3ae330e611ecb05303d579a4f8a3d114
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jun 16 15:16:10 2014 -0700

    Start adding Unicode 7.0 support to compose table
    
    New characters defined in http://www.unicode.org/charts/PDF/U1F300.pdf
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a4679baaa18142576d42d423afe816447f08336c
Author: walter harms <wharms@bfs.de>
Date:   Sat Jun 7 11:54:34 2014 +0200

    rm redundant null checks
    
    remove more redundant NULL checks
    note that _XkbFree() is really Xfree()
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Rémi Cardona <remi@gentoo.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 602d7f5030fe93b2fe7f29fb7310deb6f50cb6df
Author: walter harms <wharms@bfs.de>
Date:   Sat Jun 7 15:17:27 2014 +0200

    libX11: rm redundante NULL checks
    
    This patch removes the last remaining  NULL checks for Xfree()
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d81fed46144d089bdfa1d916a28dffc9ebffe1e4
Author: walter harms <wharms@bfs.de>
Date:   Fri Jun 6 22:53:05 2014 +0200

    Remove more redundant null checks before Xfree()
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0b7fd7dbec136bae317bd9a329309eaa089beee3
Author: walter harms <wharms@bfs.de>
Date:   Thu Jun 5 18:37:40 2014 +0200

    Remove redundant null checks before free
    
    This patch removes some redundant null checks before free.
    It should not change the code otherwise. Be aware that this
    is only the first series.
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7d452fad5068ba92b964e92bc46708046f4044aa
Author: walter harms <wharms@bfs.de>
Date:   Wed Jun 4 17:12:31 2014 +0200

    libX11/lcUTF8.c fix: dereferenced before check
    
    * Do not use variables before checked for NULL.
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a3808f51517a720e7ff738208af60865779dd6ef
Author: walter harms <wharms@bfs.de>
Date:   Wed Jun 4 17:10:20 2014 +0200

    libX11/XKBNames.c fix: dereferenced before check
    
    * Do not use variables before checked for NULL.
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b3c9f6a17e430aabe16aecbe097f7312a0f6ff78
Author: walter harms <wharms@bfs.de>
Date:   Wed Jun 4 17:08:12 2014 +0200

    libX11/lcGenConv.c fix: dereferenced before check
    
    * Do not use variables before checked for NULL.
    
    Signed-off-by: Harms <wharms@bfs,de>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c6bc28d433243c32b3f74955f1478451b4fd27b5
Author: Andreas Schwab <schwab@linux-m68k.org>
Date:   Sun Jan 19 16:59:13 2014 +0100

    Restore lost tabs in sed commands
    
    Signed-off-by: Andreas Schwab <schwab@linux-m68k.org>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e3dc0d17339e61eaf0b51b8907510984e3bf23cb
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Thu Sep 19 11:01:11 2013 +0200

    nls: Transform Brazilian compose file to an include plus three overrides.
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 16c87dda4da2271aaecc5d8b6fe6ecd072cc584c
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Fri Sep 6 12:10:01 2013 +0200

    nls: Adding the missing compose sequences with <comma> for O with ogonek.
    
    All other vowels with ogoneks can already be composed using <comma>.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 655b60f48376069750b151c46da836fdd411c83b
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Fri Sep 6 12:04:24 2013 +0200

    nls: Adding the missing postfix sequences for composing vowels with ogoneks.
    
    It existed for lowercase i, but not for uppercase I nor the other vowels.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 7f8f9a36ef901f31279c385caf960a22daeb33fe
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Fri May 9 18:21:05 2014 -0400

    Fix XNextRequest() after direct usage of XCB
    
    When XCB owns the X socket, dpy->request is not updated, so
    NextRequest() and XNextRequest() return the wrong value. There's
    nothing we can do to fix NextRequest() while retaining ABI compat,
    but change XNextRequest() to grab the socket back from XCB,
    updating dpy->request.
    
    Signed-off-by: Owen W. Taylor <otaylor@fishsoup.net>
    Reviewed-by: Uli Schlachter <psychon@znc.in>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0f9e734ea96556fe750a4baf354d42d5a87bcd14
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun May 4 11:54:59 2014 -0700

    Add missing .TE tags to end tables in Xkb man pages
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 280274e5292e013b43e552274111fab434f5ed4e
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun May 4 11:23:17 2014 -0700

    XCreateGC.man: simplify table to work with Solaris tbl
    
    Having every table cell be a text diversion (T{...T}) was too much for
    Solaris tbl to handle, and thus "man XCreateGC" would print the error
    /usr/man/man3x11/XCreateGC.3x11: line 402: Too many text block diversions
    tbl quits
    and not display the table of mask bits or any text in the man page after
    that table.   Since the #define column doesn't need special handling,
    making it not use text diversions brings the table under the tbl limit.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 93bb325a54025dd15f4744abce54b358960420f9
Author: James Cloos <cloos@jhcloos.com>
Date:   Tue May 20 17:30:10 2014 -0400

    Revert "nls: Adding compose sequences (with <parenleft> first) that GTK also has."
    
    Parenleft is already in use for sequences of the form <(> <letter> <)>
    to generate circled letters.
    
    Eg, <Multikey> <parenleft> <a> <parenright> generates ⓐ.
    
    This reverts commit f020235f4bd91fb6eade82f8c9f7b85a57981768.
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 060707851be918f2f507a26d17b016f764ddf2b4
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Fri Sep 6 11:42:59 2013 +0200

    nls: Adding accessible compose sequences for Ș and Ț (with comma below).
    
    Compose sequences with <dead_belowcomma> exist, but very few keyboard
    layouts contain that symbol.  So a more usual character is needed to be
    able to easily compose Ș, ș, Ț and ț.  The semicolon is normally only
    used for composing letters with ogoneks -- but only vowels take ogoneks,
    so the character is free for consonants, and thus <semicolon> is used
    here to compose commas below.  It is somewhat fitting, because on most
    Romanian keyboards the Ș is placed on that key, and the Ț next to it.
    
    (Oh -- the more obvious sequences with <comma> were already taken for
    composing S and T with cedillas.)
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit ca435c2f753aa2961fb35ac448cdb2cc77112755
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Tue Sep 3 21:10:33 2013 +0200

    nls: Ordering some compose sequences in a more customary way.
    
    The custom seems to be: pairing the ones that have only the sequence of
    two keys reversed, and putting the one with the diacritic first first.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit f020235f4bd91fb6eade82f8c9f7b85a57981768
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Tue Sep 3 20:44:42 2013 +0200

    nls: Adding compose sequences (with <parenleft> first) that GTK also has.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit bda0b3b5bd19154206dc40166364e73d4b6b1374
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Tue Sep 3 11:14:16 2013 +0200

    nls: Allowing Romanian Ă and ă to be composed also with lowercase <u>.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 8be4610939b833587954957f5963eb4191b43d19
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Mar 13 23:22:48 2014 -0700

    Fix "follwing" typo in en_US.UTF-8/Compose comment
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6f30e9034f29c3ae6ad7e617b3d5e903aa107b6a
Author: Reuben Thomas <rrt@sc3d.org>
Date:   Mon Jan 27 14:18:24 2014 +0000

    en_US.UTF-8/Compose: Fix apparent copy-paste-o, changing capital to small A.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d6bd988bc00494914b38b95ee5df77ac4f32f19f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 3 12:38:48 2014 +1000

    man: fix man page for XkbGetMap
    
    Returned structure must be freed with XkbFreeKeyboard().
    
    Reported-by: Morten Bøgeskov <mb@dbc.dk>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a6dcf2201a05adbff54122df05a1e6325936abb6
Author: Ran Benita <ran234@gmail.com>
Date:   Tue Feb 11 13:26:16 2014 +0200

    Remove dead USE_OWN_COMPOSE-protected code
    
    The build doesn't provide any way to define this option. It also refers
    to files (imComp.h) and functions (e.g. XimCompInitTables(),
    XimCompProcessSym()) which are not found anywhere, and the ordinary
    Compose implementation in xim doesn't use any of it.
    
    Signed-off-by: Ran Benita <ran234@gmail.com>
    Reviewed-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b64bee2ddb7b96f00713a8b8435f11ad9ac1c9e0
Author: Ran Benita <ran234@gmail.com>
Date:   Sun Feb 16 15:24:58 2014 +0200

    nls: always use XCOMM instead of # for comments in Compose.pre files
    
    Lines starting with # are considered as preprocessor directives in the
    .pre files.
    
    Fixes warnings like:
    <stdin>:3:0: error: invalid preprocessing directive #Khmer
    
    Signed-off-by: Ran Benita <ran234@gmail.com>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 470e2289a3ebc59c5a35e54e1adeb0f261d5bf88
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Feb 6 13:48:08 2014 -0800

    Fix typos in Xrm.c comments
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit aacf95dacc7c598e7297894580d4d655593813b2
Author: Marko Myllynen <myllynen@redhat.com>
Date:   Mon Jan 13 16:43:18 2014 +0200

    Annotate Finnish Compose map with Unicode code points
    
    Scripted annotation, no functional changes.
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 20fdccd81b54678376d49e00edfebbbe94951f07
Author: Teemu Likonen <tlikonen@iki.fi>
Date:   Fri Jul 20 19:21:04 2012 +0300

    Fix "RING ABOVE" key in the Finnish compose file
    
    The Finnish keyboard standard defines that <dead_abovering> <space> must
    insert the character U+02DA RING ABOVE. Currently the Finnish Compose
    file inserts U+00B0 DEGREE SIGN even though the line's comment says
    "RING ABOVE". This commit changes the character to U+02DA RING ABOVE.
    
    Signed-off-by: Teemu Likonen <tlikonen@iki.fi>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit 8757e2ac8e04f2932ff437127f3e2ae9ac20c1d7
Author: Ran Benita <ran234@gmail.com>
Date:   Wed Jan 29 02:11:47 2014 +0200

    nls: remove duplicate 'ohorn' and 'uhorn' compose sequences
    
    Since <Ohorn> == <U01A0> and <ohorn> == <U01A1>, when translated to
    keysyms:
    
     #define XK_Ohorn                      0x10001a0  /* U+01A0 LATIN CAPITAL LETTER O WITH HORN */
     #define XK_ohorn                      0x10001a1  /* U+01A1 LATIN SMALL LETTER O WITH HORN */
    
    (and similarly for uhorn), there is no need to have both names. Remove
    the unicode literal ones.
    
    Signed-off-by: Ran Benita <ran234@gmail.com>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit b98998cb3bea7cb3005f2e9d5bc5332d14b1d5d3
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jan 18 22:35:18 2014 -0800

    Add RANDR 1.4 requests & events to XErrorDB
    
    Checked against randrproto.txt & randr.h
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 321392ded15a7ee9d177d4ebe8846336ba76741c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jan 3 20:04:33 2014 -0800

    Remove unused ETEST & ESZTEST macros from XlibInt.c
    
    Left behind when 15e5eaf62897 removed support for building without XCB.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Jasper St. Pierre <jstpierre@mecheye.net>

commit 1ffc0c5503d4f419fdbc765243832a53491bf5bc
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Dec 26 09:26:13 2013 -0800

    _XkbReadGeomOverlay: check for NULL first, then use pointer
    
    Flagged by cppcheck 1.62:
    [lib/libX11/src/xkb/XKBGeom.c:479] -> [lib/libX11/src/xkb/XKBGeom.c:480]:
     (warning) Possible null pointer dereference: row - otherwise it is
     redundant to check it against null.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ddf5f130cc29bb3bf8b9c757dcbac31bc56e9379
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Dec 26 09:22:49 2013 -0800

    XkbSelectEventDetails: remove unnecessary assignments
    
    clear & selectAll are set to 0 already a few lines earlier,
    affectWhich is set to XkbMapNotifyMask a few lines later.
    None are used between the other assignments and the removed ones.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3d69b0a83e62f8f6fbdd952fc49cdbdf8825e1e6
Author: Jon TURNEY <jon.turney@dronecode.org.uk>
Date:   Thu Oct 7 18:46:08 2010 +0100

    Don't try so hard to find a matching font with the given encoding
    
    See http://sourceware.org/bugzilla/show_bug.cgi?id=10948
    
    Currently, if the locale is UTF-8, no CJK fonts are installed, and someone
    does XCreateFontSet() with a font name of "*", we end up asking the server
    to list the (non-existent) fonts 11 times for each CJK encoding, which can
    take a while.
    
    A * wildcard can match multiple components in a XLFD name in XListFonts(),
    so there's no need to try adding more than one to get a match.
    
    We do try once with a leading '*-' in case the fontname isn't a full
    well-formed XLFD name, maybe even that isn't needed?
    
    (See also http://invisible-island.net/xterm/xterm.faq.html#slow_menus)
    
    Signed-off-by: Jon TURNEY <jon.turney@dronecode.org.uk>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7e163300735d4bcd3386b86eec112acdad139c59
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Dec 2 21:51:27 2013 -0800

    unifdef -UISC
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 1e43c262d13cab2b759665f9f13bdedbc7afbfd4
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Thu Sep 19 13:20:05 2013 +0200

    nls: Fix transposed locale identifier for Khmer.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0e45f64766c0557c8e99a979c70ca6f55664dae7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Nov 16 20:21:54 2013 -0800

    Drop X_LOCALE fallback for OS'es without setlocale()
    
    C89 or bust!   This was documented as being needed for "only Lynx,
    Linux-libc5, OS/2" and has never been enabled in modular builds,
    since none of those platforms have had anyone step up to add support
    since the X11R7 conversion to autotools.
    
    Mostly performed with unifdef -UX_LOCALE, followed by removal of files
    left without any purpose, and manual cleanup of remaining references.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 6cb02b166361200da35ba14f52cd9aaa493eb0ea
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Oct 23 10:37:53 2013 -0700

    Xcms file parsing should not require the impossible to succeed
    
    The field2 helper function, to split lines from Xcms.txt files into
    two tab delimited fields, contained a check:
    
        if ((*pBuf != '\n') || (*pBuf != '\0')) {
            return(XcmsFailure);
    
    which would cause it to return failure unless *pBuf had a value that
    was simultaneously equal to both \n & \0, and no one wants to live in
    a world where that could ever be true.
    
    This has gone unnoticed since 1991, since this only caused lines
    in Xcms.txt that started with whitespace to be rejected, but now
    gcc -Wlogicalop has brought it to our attention, and
    https://bugs.freedesktop.org/show_bug.cgi?id=70803 was filed.
    
    Now that we see it, and cannot unsee it, we change it to use the
    same logic as the check at other points in this function, to return
    failure only if we hit \n or \0 before we find the first non-whitespace
    character, so that lines starting with whitespace will have the space
    skipped over to get to the color name to be defined.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>

commit 18a5278b008e9faa59b346fcab18a8d74b875fda
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Sat Sep 28 17:33:52 2013 -0400

    makekeys: don't need to use target-specific CFLAGS
    
    It's the only thing built in that directory, so we can use AM_CFLAGS
    and AM_CPPFLAGS as usual.
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 5dcb40f28d59587597d2ff6e6ac64c71cfe6ff7b
Author: James Cloos <cloos@jhcloos.com>
Date:   Tue Sep 17 12:50:42 2013 -0400

    nls/en_US.UTF-8/Compose.pre: Fix typo.
    
    Fix typo added in 215ce6a67863, s/actute/acute/.
    
    Fixes bug #69476.  Reported by Jean Krohn.
    
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit cb107760df33ffc8630677e66e2e50aa37950a5c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Sep 8 18:37:01 2013 -0700

    libX11 1.6.2

commit 215ce6a67863de7acfd6dd3562b4fd97ef87b411
Author: Benno Schulenberg <bensberg@justemail.net>
Date:   Sun Sep 1 12:38:30 2013 +0200

    nls: Adding more accessible compose sequences for J́ and j́.
    
    Few keyboards have an <acute> key, so this adds the much more
    accessible and usual compose sequences with <apostrophe>, ánd
    the most comfortable ones with <dead_acute>.
    
    Signed-off-by: Benno Schulenberg <bensberg@justemail.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit e9b14d10d0258bfcc273ff8bc84cd349dccda62c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 24 17:27:43 2013 -0700

    Bug 68413 - [Bisected]Error in `xterm': realloc(): invalid next size
    
    Pass *new* size to realloc, not old size.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c2b8e30790c21d6386767265263b3294ce1b1f9a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 16 21:04:02 2013 -0700

    Stop checking for HAVE_DIX_CONFIG_H on the client side
    
    Leftover from when these XKB files were shared with the server sources
    and could be compiled in either the client or server, with the different
    autoconf config files in each.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 84276609b2f0aec74fb464c428c7db5714b0fcfc
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 16 18:27:28 2013 -0700

    Rearrange some variable declarations & initializations in XKB
    
    Little things noticed during XKB restyling that seemed to make the
    code easier to read.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b90b7e859cf45ec76921fa21bbfc1f3840d6e8d1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 11 13:29:33 2013 -0700

    Reindent XKB code to X.Org standard style
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit c0a0f78eb49c2e4ad956209de77475c85b9314ea
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 16 18:14:14 2013 -0700

    Fix overflow checks in _XkbReadKeySyms when key_sym_map is already created
    
    We were checking to make sure that the largest keysym value was within
    the range of the allocated buffer, but checking against different limits
    in the not-yet-allocated vs. the already-allocated branches.
    
    The check should be the same in both, and reflect the size used for the
    allocation, which is based on the maximum key code value, so we move it
    to be a common check, before we branch, instead of duplicating in each
    branch.
    
    map->key_sym_map is an array of XkbSymMapRec structs, [0..max_key_code]
    map->syms is the array for which num_syms is recorded, hence is not the
    right value to check for ensuring our key_sym_map accesses are in range.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reported-by: Barry Kauler <bkauler@gmail.com>
    Tested-by: Barry Kauler <bkauler@gmail.com>

commit bea6cbd027973142fc64532274e1d16861b47190
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 11 17:02:21 2013 -0700

    Remove long unused src/udcInf.c
    
    I can find no record of what this file was for.  Neither the X11R6.8.2
    monolith Imakefile nor any modular release Makefile.am have ever built
    it and nothing else references it.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit bf3501e0395abe890acfea98fdd9f50a6966f118
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Aug 11 00:07:33 2013 -0700

    Remove unnecessary casts of pointers to (char *) in calls to Xfree()
    
    Left one cast behind that is necessary to change from const char *
    to char * in src/xlibi18n/lcCharSet.c.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6ead9dd92ab90aabd9f0e328d59597e6b5bc09d3
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 23:57:55 2013 -0700

    Don't cast sizeof() results to unsigned when passing to Xmalloc/Xcalloc
    
    sizeof() returns size_t, malloc() & calloc() expect sizes in size_t,
    don't strip down to unsigned int and re-expand unnecessarily.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 25a7a329def672fc8d26078538173777850c6390
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 23:51:08 2013 -0700

    Remove even more casts of return values from Xmalloc/Xrealloc
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f8fa16092a148b74ca35b4beb182053352606f2f
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 23:05:13 2013 -0700

    xlibi18n: fix argsize argument to _XlcParsePath
    
    The array is defined as having NUM_LOCALEDIR entries, so use that
    instead of hardcoded 256 value (the other two calls already did this).
    
    Reported by parfait:
       Buffer overflow (CWE 120): In pointer dereference of argv[argc] with index argc
          Pointer size is 64 elements (of 8 bytes each), index is 255
            at line 82 of src/xlibi18n/lcFile.c in function 'parse_line'.
            called at line 178 in function '_XlcParsePath' with argv = argv.
            called at line 722 in function '_XlcLocaleLibDirName' with argv = args, argsize = 256.
            at line 82 of src/xlibi18n/lcFile.c in function 'parse_line'.
            called at line 178 in function '_XlcParsePath' with argv = argv.
            called at line 638 in function '_XlcLocaleDirName' with argv = args, argsize = 256.
    
    [ This bug was found by the Parfait 1.2.0 bug checking tool.
      http://labs.oracle.com/pls/apex/f?p=labs:49:::::P49_PROJECT_ID:13 ]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e7d46c6452c0b90fd66ae9f538546b968e0dd608
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 22:32:42 2013 -0700

    i18n modules: Fix some const cast warnings
    
    imRm.c: In function '_XimSetICMode':
    imRm.c:2419:37: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    imRm.c:2420:30: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    lcGenConv.c: In function 'byteM_parse_codeset':
    lcGenConv.c:345:13: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit cbd86eccf175dc82a5cbcea54c8bd21ce18b70c0
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 22:21:54 2013 -0700

    xlibi18n: Fix a bunch of const cast warnings
    
    Add const qualifiers to casts where needed, remove other casts that
    are no longer needed.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit eb3676113fc2dd0f34d92b89beb81b3f61569aa1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 22:18:00 2013 -0700

    Fix const handling in XSetLocaleModifiers
    
    Instead of reusing the input parameter to store the output, make a
    result variable instead, so that there's less const confusion.
    
    Fixes gcc warnings:
    lcWrap.c: In function 'XSetLocaleModifiers':
    lcWrap.c:87:18: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    lcWrap.c:91:25: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    lcWrap.c:93:12: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 8ebbffa98563960910152e4f2e31cb032375d871
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 21:46:37 2013 -0700

    Constify lc_name argument to _XlcLocaleDirName() & _XlcLocaleLibDirName()
    
    Makes code considerably less crufty and clears gcc warnings:
    XlcDL.c: In function '_XlcDynamicLoad':
    XlcDL.c:384:44: warning: cast discards '__attribute__((const))' qualifier
     from pointer target type [-Wcast-qual]
    XlcDL.c:386:51: warning: cast discards '__attribute__((const))' qualifier
     from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 07e4e864107b38c2f393564fdacc90f4e858f23f
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 13:37:53 2013 -0700

    init_om: remove unneeded extra copy of string to local buffer
    
    Strings from the supported_charset_list[] were being copied one by
    one to a stack buffer, and then strdup called on that buffer.
    
    Instead, just strdup the original string, without the local copy,
    and use a more traditional for loop, so it's easier to figure out
    what the code is doing (cleaning up a gcc const-cast warning in
    the process).
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 1cec14dad904ba21a861f4af131be5982ecb83dd
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 12:34:53 2013 -0700

    Delete unused XKB_INSURE_SIZE macro from XKBlibint.h
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 5f32182c7c4045540ff3833c48ee24a3a25726e2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 12:19:17 2013 -0700

    miRegionOp(): ensure region size is not updated if realloc fails
    
    This function performs operations on a region, and when finished,
    checks to see if it should compact the rectangle list.  If the
    number of rectangles for which memory is allocated in the list is
    more than twice the number used, it tries to shrink.   realloc()
    should not fail in this case, but if it does, might as well keep
    the correct value for the number of allocated rectangles, so we
    don't try to grow it unnecessarily later if adding to the region.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit bd2a0b5a187798bb2e2f05dc5062ca79e37075dd
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 12:19:17 2013 -0700

    miRegionCopy(): handle realloc failure better
    
    Zero out the region size when freeing the region so callers don't think
    there's anything there.   (Pointer is already set to NULL from the realloc
    result itself.)  Return 0 to the callers, and have them cascade that back
    to their callers to indicate failure, instead of their usual return value
    of 1 on success.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5dc8b5385d513bbda88697c2372db750d23f46d4
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 11:27:22 2013 -0700

    Avoid memory leak/corruption if realloc fails in Xregion.h:MEMCHECK macro
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 453c4ee436ef32d91501d7736d7a91c1aeafc565
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 12:07:51 2013 -0700

    Avoid memory leak/corruption if realloc fails in imLcPrs.c:parseline()
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b3fea74ec5b7d4f83755a52a8d49c564b71c6d12
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 12:30:39 2013 -0700

    lcDB.c: ensure buffer size is updated correctly if realloc fails
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 43bb822c714a73c3b2d15e621ffb3333cd10da8c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Aug 10 11:07:47 2013 -0700

    Avoid memory leak/corruption if realloc fails in XlcDL.c:resolve_object()
    
    Previously, if realloc failed to increase the size, we'd still
    record that we had allocated the larger size, but the pointer
    to it would be NULL, causing future calls to be broken, and the
    previous allocation to be lost/leaked.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 5d47a39978e92bb34ec928b1b15d71c0c2434870
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 9 23:33:03 2013 -0700

    omGeneric.c: convert sprintf calls to snprintf
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 88a27a2aa9b7d35cb79b16334ea3413e572b724a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 9 23:30:30 2013 -0700

    ximcp/imRm.c: convert sprintf calls to snprintf
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 4fadae243fb485628c9a137f5da3489ed6214b21
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 9 23:02:12 2013 -0700

    xlibi18n: convert sprintf calls to snprintf
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 36a7edf0e5edfc5ef4ff2c3a8b4fa3dc4796e854
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 9 23:02:12 2013 -0700

    lcfile: skip over any null entries in args list
    
    Previous code seemed to assume that printf("%s", NULL) would result
    in a 0-length string, not "(null)" or similar, but since there's no
    point looking for files in "(null)/filepath...", instead we just
    skip over NULL entries in search paths when generating file names.
    
    In the *DirName() functions, this effectively just moves the "bail on
    NULL in arg[i]" check up from the later code that assigned it to targetdir
    and then bailed if that was NULL.
    
    Not sure how there ever could be a NULL in arg[i], given the current
    implementation of XlcParsePath, but it's easy enough to check once and
    reject up front instead of on every reference.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ee0824f24392d5ca3d5fd5f5ed8d78c0d892f7c0
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Aug 9 22:00:09 2013 -0700

    Fix file leak on malloc error in XlcDL.c:resolve_object()
    
    File Leak: Leaked File fp
       at line 219 of lib/libX11/src/xlibi18n/XlcDL.c in function 'resolve_object'.
          fp initialized at line 198 with fopen
    
    [ This bug was found by the Parfait 1.2.0 bug checking tool.
      http://labs.oracle.com/pls/apex/f?p=labs:49:::::P49_PROJECT_ID:13 ]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 9b291044a240e5b9b031ed814e0c84e53a1c3084
Author: Julien Cristau <jcristau@debian.org>
Date:   Sat Jun 15 18:02:21 2013 +0200

    Add missing locales to configure.ac
    
    Commits 40761898692e5063957bfa2518cca3d35b2e354a and
    f198c6aa98f88ff285d903175a3c4c0fd33a4575 added two new locales
    (sr_CS.UTF-8 and km_KH.UTF-8), but didn't list them in configure.ac,
    meaning they're not included in tarballs.
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Reviewed-by: James Cloos <cloos@jhcloos.com>

commit 8f58e54a5f46c3cd4897a23b89950f4800ae38d4
Author: ISHIKAWA,chiaki <ishikawa@yk.rim.or.jp>
Date:   Tue Dec 18 15:28:05 2012 +0000

    Fix bogus timestamp generated by XIM
    
    Fix bogus timestamp generted by XIM due to uninitialized
    data field. Also set appropriate serial, too.
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=39367
    
    Signed-off-by: Chiaki ISHIKAWA <ishikawa@yk.rim.or.jp>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e7fd6f0eda57300df4d6b695b7064610ca5dec57
Author: Egbert Eich <eich@freedesktop.org>
Date:   Thu Jun 16 18:47:49 2011 +0200

    XIM: Fix sync problem on focus change.
    
    XSetICFocus() and XUnsetICFocus() are both asynchronous events.
    This is a pretty stupid idea: those functions may undo certain
    settings on the client side for which requests from the server
    may still be in the queue unprocessed. Thus things may be set
    in the wrong order ie instead of set -> unest it will be unset -> set.
    Moreover there is no way for either the client or the server to
    cause the event queue to be flushed - which is pretty bad as
    XIM is bidirectional.
    The scenario is as follows:
    Two ICs are created:
            ic1 = XCreateIC(im,
                XNInputStyle, XIMPreeditCallbacks | XIMStatusCallbacks,
                XNClientWindow, window,
                XNPreeditAttributes, preedit_attr,
                XNStatusAttributes, status_attr,
                NULL);
            ic2 = XCreateIC(im, XNInputStyle,
                           XIMPreeditNothing | XIMStatusNothing,
                           XNClientWindow, window, NULL);
    Then the focus is removed from ic2:
            XUnsetICFocus(ic2);
    If SCIM is used as the input server it will send a bunch of requests
    following an XCreateIC(). One of the requests registers a key release
    filter. XUnsetICFocus() unsets both key press and release filters.
    Since it is asynchronous, the input server requests to register key
    press and release filters may not have been processed, when XUnsetICFocus()
    is called. Since there is no explicite way for client programs to enforce
    the request queue to be flushed explicitely before an X[Set/Unset]ICFocus()
    call it would be safest to make those two calls synchronous in the sense
    that they ensure the request queue has been handled before they execute.
    The easiest way to do this from Xlib is thru a call to XGetICValues()
    which sends a request to the server and subsequently reads the queue
    from the server to the client. This will cause all outstanding requests
    in the queue to be read and handled.
    This is an ugly hack and this could be fixed directly in the client,
    however it seems to be easier to fix Xlib than to fix numerous clients.
    This problem arose since there is no well documented way how to handle
    and synchronize XIM requests and not all input servers send requests
    when an IC is created.
    This has been discussed extensively in:
     https://bugzilla.novell.com/show_bug.cgi?id=221326
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>

commit 26ec7d3821bc19debc73c8c3e42e6e33ef6f856e
Author: Egbert Eich <eich@freedesktop.org>
Date:   Thu Jun 16 17:28:39 2011 +0200

    XIM: Fix race on focus change: set 'FABRICATED' only when keyev filters in place.
    
    When synthesized key events are sent on commit XIM sets the 'fabricated'
    flag so that the keypress handler knows that these were not real events.
    This also happens when committing due to the loss of focus. However in this
    case the keypress/release filters which consume and unset this flag are no
    longer in the filter chain.
    So the flag is erronously set when a real keyboard event is received after
    focus has been regained. So the first event is wrongly treated as a
    fabricated key in the keypress handler which will at the same time reset
    the flag so the second key event is treated correctly.
    This fix only sets the flag when at least one of the keyboard filters is in
    place.
    How to reproduce this bug: run scim, choose a Japanese input method start
    two instances of xterm: start typing in one xterm (this should pop up an
    IM window). Without comitting (hitting 'enter') move focus to the other
    xterm, then move focus back. Start typing again. The first character will
    be committed immediately without popping up an input window.
    With this fix this behavior is gone.
    
    See also: https://bugzilla.novell.com/show_bug.cgi?id=239698
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>

commit 44f84223f5e2dd46883fcbd352af2798bfa9aeb6
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jul 29 21:29:49 2013 -0700

    libX11 1.6.1
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d19cfaca15826943d3c637ef7fa5db0a23d5feed
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 27 12:19:00 2013 -0700

    Fix undefined XCMSDIR error when building lint library
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3083cd43d7dcd59da587975e7cadda681cd8a103
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 27 00:36:08 2013 -0700

    Add ku_TR.UTF-8 (Kurdish language, Turkey region) to compose/locale.dir
    
    Upstreaming from changes originally integrated into OpenSolaris
    under Sun bug id 6882572.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Thomas Klausner <wiz@NetBSD.org>

commit 208e586c808e88a2ee819e4450dc27f557afc2bf
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Jul 27 01:03:18 2013 -0700

    omGeneric: remove space between struct name & member name
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7db74514e454d3fc4ff70aa08ddac66bfffda4dd
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 23 22:18:46 2013 -0700

    Refactor common code from XAddHost & XRemoveHost into single function
    
    On the Xlib side, the only real difference is the mode flag we send
    to the server with the address, so just make that an argument to the
    function with the common code for packing the address into the request.
    
    (Aside from labels, gcc 4.7.2 generates identical code before & after
     this change due to inlining, verified via diff of gcc -S output.)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3292195a64a9ce4f0d27134cd544651ec647e728
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Tue Jul 23 22:11:34 2013 -0700

    XSetModifierMapping: Use Data instead of GetReqExtra
    
    Handle arbitrary length data in the same fashion as other calls,
    avoiding need to ensure it fits all in the request buffer.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit feb131b18aee31c2c125dc3275b0260940245882
Author: Kees Cook <kees@outflux.net>
Date:   Sun Jun 9 11:13:43 2013 -0700

    libX11: check "req" when calling GetReqExtra
    
    This fixes the two callers of GetReqExtra to check that "req" is non-NULL
    to avoid crashing now that GetReqExtra does internal bounds-checking on
    the resulting buffer sizes.
    
    Additionally updates comment describing return values to use names
    instead of only literal values.
    
    Signed-off-by: Kees Cook <kees@outflux.net>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 54540d7cba0c2bfe9176221c7bca910058d304df
Author: Kees Cook <kees@outflux.net>
Date:   Sun Jun 9 11:13:42 2013 -0700

    libX11: check size of GetReqExtra after XFlush
    
    Two users of GetReqExtra pass arbitrarily sized allocations from the
    caller (ModMap and Host). Adjust _XGetRequest() (called by the GetReqExtra
    macro) to double-check the requested length and invalidate "req" when
    this happens. Users of GetReqExtra passing lengths greater than the Xlib
    buffer size (normally 16K) must check "req" and fail gracefully instead
    of crashing.
    
    Any callers of GetReqExtra that do not check "req" for NULL
    will experience this change, in the pathological case, as a NULL
    dereference instead of a buffer overflow. This is an improvement, but
    the documentation for GetReqExtra has been updated to reflect the need
    to check the value of "req" after the call.
    
    Bug that manifested the problem:
    https://bugs.launchpad.net/ubuntu/+source/x11-xserver-utils/+bug/792628
    
    Signed-off-by: Kees Cook <kees@outflux.net>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 24d3ee0d08f24e23c91d55702f010f73d7b908e5
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Tue Jun 25 22:35:29 2013 +0200

    Tighten out-of-range comparisons.
    
    [For all of these, LONG_MAX was the correct value to prevent overflows
     for the recent CVEs.   Lowering to INT_MAX catches buggy replies from
     the server that 32-bit clients would reject but 64-bit would accept,
     so we catch bugs sooner, and really, no sane & working server should
     ever report more than 2gb of extension names, font path entries,
     key modifier maps, etc.  -alan- ]
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6d926088d80a08e13e6d6c4ff207b81ad52e667f
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Tue Jun 25 18:34:32 2013 +0200

    Fix out-of-range comparison in _XF86BigfontQueryFont
    
    clang complained (correctly):
    warning: comparison of constant 768614336404564650 with expression
    of type 'CARD32' (aka 'unsigned int') is always true
    [-Wtautological-constant-out-of-range-compare]
    
    [While LONG_MAX is correct, since it's used in size_t math, the
     numbers have to be limited to 32-bit range to be usable by 32-bit
     clients, and values beyond that range are far more likely to be
     bugs in the data from the server than valid numbers of characters
     in a font.   -alan- ]
    
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 383e2b0d029482a0f4c39fe00e15397538576fc1
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Tue Jun 25 18:33:56 2013 +0200

    Check for symbol existence with #ifdef, not #if
    
    Reviewed-by: Jamey Sharp <jamey@minilop.net>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9955d1c8de994a90fe7f2e3187e7362611d7d265
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Tue Jun 25 18:33:07 2013 +0200

    Use newer callback-based API for XIM.
    
    Let libX11 load and make available the newer (X11R6) callback-based
    API for XIM (expected by emacs).
    
    This patch updates the files to match the other nls/ files.
    
    Patch from Ian D. Leroux <idleroux@fastmail.fm> on pkgsrc-users@NetBSD.org
    following a hint by Nhat Minh Lê <nhat.minh.le@gmail.com>.
    
    Reviewed-by: James Cloos <cloos@jhcloos.com>
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a17ceb7100bd36c2db210473ee701deb5d515731
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Tue Jun 25 18:31:32 2013 +0200

    Stop truncating source to destination length if it is larger.
    
    It seems useless to do that since the code tests for both source
    length and destination to be non-zero. This fixes a cut'n'paste
    problem in xterm where the paste length was limited to 1024 (BUFSIZ)
    in button.c.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a336db9a0add3ae0783dda6e52459236622a12af
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jun 24 23:02:05 2013 -0700

    Require ANSI C89 pre-processor, drop pre-C89 token pasting support
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9dfb0f3c0a761590bcdc1f3396b1e064da4e18e8
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jun 7 11:30:11 2013 -0700

    troff macro expansion in specs/libX11
    
    Many of the custom nroff macros (.ds <macro> <contents>) were left
    unsubstituted in the nroff->docbook conversion.   This substitution
    is now performed, via the following perl script:
    
    #! /usr/bin/perl -w -i
    
    use Text::Wrap;
    
    while ($_ = <>) {
        while ($_ =~ m/\((\w+)\b/g) {
            my $m = $1;
            if (exists $macro{$m}) {
                $_ =~ s/\($m/$macro{$m}/;
                $_ = wrap('', '', $_);
                $_ =~ s/[ \t]+$//;
            }
        }
    
        if ($_ =~ /\<!-- .ds (\w+) (.*) -->/) {
            my ($m, $s) = ($1, $2);
            $macro{$m} = $s;
            while ($macro{$m} =~ /\\\s*$/) {
                $macro{$m} =~ s/\\\s*$//ms;
                $macro{$m} .= <>;
                chomp($macro{$m});
            }
            $macro{$m} =~ s/\\ / /g;
        } else {
            print $_;
        }
    }
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 20c17bd9ebf767a24643279e45866dddcb57b5ce
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Jun 7 09:27:26 2013 -0700

    specs/libX11: correct prototype for XListPixmapFormats/XImageByteOrder
    
    The XListPixmapFormats arguments was being shown with XImageByteOrder's
    name and return types.   Appears to have been a glitch in the nroff ->
    docbook conversion.
    
    Reported-by: ZHANG Zhaolong <zhangzl2013@126.com>
    Reviewed-by: Jamey Sharp <jamey@minilop.net>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit ed3d830243c8a0eefaf24e15b11823272ffe5049
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Sun Jun 2 20:49:55 2013 +0200

    Deal with the limited range of VAX floating point numbers when compiling for VAX.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0a48235d63639fb917c44d27c86e928e79fbac66
Author: Eric S. Raymond <esr@thyrsus.com>
Date:   Thu Jun 6 16:43:56 2013 -0400

    Remove call to undefined macro.

commit 9e4719b9b719f2f8d255f6778e2e8c1809e32599
Author: Eric S. Raymond <esr@thyrsus.com>
Date:   Thu Jun 6 16:42:20 2013 -0400

    Remove call to undefined macro.

commit 8496122eb00ce6cd5d2308ee54f64b68c378e455
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jun 3 20:06:43 2013 -0700

    Update README to reflect where to find the Xlib specs now
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 655d631e86c95b14888758b27ed2836ca3e3ce86
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Mon Jun 3 19:21:06 2013 -0700

    libX11 1.6.0
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 4a89b7ea908554628f374537a79931c8006a2de3
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Sun Jun 2 11:49:54 2013 -0700

    cmsMath.c: Add missing stdio header for printf(3) in DEBUG build.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 96dcf747f13b26b8e4d17b1bc8605d933c3e1dc6
Author: Thomas Klausner <wiz@NetBSD.org>
Date:   Sun Jun 2 20:49:48 2013 +0200

    XCreateGC man page: Avoid .TS H and .TH macros
    
    Avoid .TS H and .TH for now as it doesn't alter the output in this case,
    and improve the output with mandoc(1).
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 95a388158c9d73df7d24016d6a3d61506d7d53a4
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu May 23 19:43:35 2013 -0700

    libX11 1.5.99.902 (1.6 RC2)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a3bdd2b090915fe0163b062f0e6576fe05dd332e
Author: Julien Cristau <jcristau@debian.org>
Date:   Thu May 23 20:39:46 2013 +0200

    xkb: fix off-by-one in _XkbReadGetNamesReply and _XkbReadVirtualModMap
    
    The size of the arrays is max_key_code + 1.  This makes these functions
    consistent with the other checks added for CVE-2013-1997.
    
    Also check the XkbGetNames reply when names->keys was just allocated.
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Tested-by: Colin Walters <walters@verbum.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7e30056e78e4b7979ff47f102e00327617266019
Author: Niveditha Rau <Niveditha.Rau@Oracle.COM>
Date:   Fri May 17 15:26:21 2013 -0700

    Make sure internal headers include required headers
    
    Fixes builds with Solaris Studio 12.3 when lint is enabled, since it no
    longer ignores *.h files, but complains when they reference undefined
    typedefs or macros.
    
    Signed-off-by: Niveditha Rau <Niveditha.Rau@Oracle.COM>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 2820100bf8ba130b94253f415e7fa5ac28bb2037
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu May 16 23:05:36 2013 -0700

    Free fs->properties in _XF86BigfontQueryFont overflow error path
    
    Fixes small memory leak introduced in commit 5669a22081
    
    Reported-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3131740513133a9ff7cb12123d29ceb18584fc38
Author: Matthieu Herrb <matthieu.herrb@laas.fr>
Date:   Wed May 8 19:33:09 2013 +0200

    XListFontsWithInfo: Re-decrement flist[0] before calling free() on it.
    
    Freeing a pointer that wasn't returned by malloc() is undefined
    behavior and produces an error with OpenBSD's implementation.
    
    Signed-off-by: Matthieu Herrb <matthieu.herrb@laas.fr>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3fe4bea086149f06a142a8f1d575f627ec1e22c7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Apr 19 14:30:40 2013 -0700

    Give GNU & Solaris Studio compilers hints about XEatData branches
    
    Try to offset the cost of all the recent checks we've added by giving
    the compiler a hint that the branches that involve us eating data
    are less likely to be used than the ones that process it.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e1b457beb8d4e831ef44279dada6c475cb955738
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Mar 31 12:22:35 2013 -0700

    _XkbReadGetMapReply: reject maxKeyCodes smaller than the minKeyCode
    
    Various other bounds checks in the code assume this is true, so
    enforce it when we first get the data from the X server.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 12ad4c6432496897ff000eb7cfecd0fb4b290331
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 16 10:03:13 2013 -0700

    Use calloc in XOpenDisplay to initialize structs containing pointers
    
    Prevents trying to free uninitialized pointers if we have to bail out
    partway through setup, such as if we receive a corrupted or incomplete
    connection setup block from the server.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d38527e25f8b6e2f1174ecc21260c5c5416f972e
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Mar 7 23:46:05 2013 -0800

    Remove more unnecessary casts from Xmalloc/calloc calls
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b2c86b582c58f50c7b14da01cf7ebd20ef12a6b2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 16:56:16 2013 -0800

    Convert more _XEatData callers to _XEatDataWords
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 192bbb9e2fc45df4e17b35b6d14ea0eb418dbd39
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 9 11:04:37 2013 -0800

    Make XGetWindowProperty() always initialize returned values
    
    Avoids memory corruption and other errors when callers access them
    without checking to see if XGetWindowProperty() returned an error value.
    
    Callers are still required to check for errors, this just reduces the
    damage when they don't.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit db1b1c871da29aa0545182bf888df81627f165a5
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 15:08:21 2013 -0800

    Avoid overflows in XListExtensions() [CVE-2013-1997 15/15]
    
    Ensure that when breaking the returned list into individual strings,
    we don't walk past the end of allocated memory to write the '\0' bytes
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 8d5936594993921acdfec778dd8f41b555e2543a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 15:08:21 2013 -0800

    Avoid overflows in XGetFontPath() [CVE-2013-1997 14/15]
    
    Ensure that when breaking the returned list into individual strings,
    we don't walk past the end of allocated memory to write the '\0' bytes
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 0c404db6a92dc2c198328bf586c02d8abbe02013
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 15:08:21 2013 -0800

    Avoid overflows in XListFonts() [CVE-2013-1997 13/15]
    
    Ensure that when breaking the returned list into individual strings,
    we don't walk past the end of allocated memory to write the '\0' bytes
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 0b0f5d4358c3de7563d6af03f0d2ce454702a06a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 15:08:21 2013 -0800

    integer overflow in XGetModifierMapping() [CVE-2013-1981 13/13]
    
    Ensure that we don't underallocate when the server claims a very large reply
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit a351b8103b2ba78882e1c309e85893ca3abe2073
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 15:08:21 2013 -0800

    integer overflow in XGetPointerMapping() & XGetKeyboardMapping() [CVE-2013-1981 12/13]
    
    Ensure that we don't underallocate when the server claims a very large reply
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 833f6b70bc789d33607f6dbfee9e0a4178ec4b59
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 15:08:21 2013 -0800

    integer overflow in XGetImage() [CVE-2013-1981 11/13]
    
    Ensure that we don't underallocate when the server claims to have sent a
    very large reply.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 79d8dc08eb98842173ce239b9dd60df0e9e9ae72
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 8 22:25:35 2013 -0800

    integer overflow in XGetWindowProperty() [CVE-2013-1981 10/13]
    
    If the reported number of properties is too large, the calculations
    to allocate memory for them may overflow, leaving us returning less
    memory to the caller than implied by the value written to *nitems.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 164bf4dfe839b1cc75cdeee378a243d04a8200e4
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 13:18:48 2013 -0800

    integer overflows in TransFileName() [CVE-2013-1981 9/13]
    
    When trying to process file paths the tokens %H, %L, & %S are expanded
    to $HOME, the standard compose file path & the xlocaledir path.
    If enough of these tokens are repeated and values like $HOME are set to
    very large values, the calculation of the total string size required to
    hold the expanded path can overflow, resulting in allocating a smaller
    string than the amount of data we'll write to it.
    
    Simply restrict all of these values, and the total path size to PATH_MAX,
    because really, that's all you should need for a filename path.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 460e8a223b87d4fa0ea1e97823e998a770e0f2a2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 18:37:37 2013 -0800

    integer truncation in _XimParseStringFile() [CVE-2013-1981 8/13]
    
    Called from _XimCreateDefaultTree() which uses getenv("XCOMPOSEFILE")
    to specify filename.
    
    If the size of off_t is larger than the size of unsigned long (as in
    32-bit builds with large file flags), a file larger than 4 gigs could
    have its size truncated, leading to data from that file being written
    past the end of the undersized buffer allocated for it.
    
    While configure.ac does not use AC_SYS_LARGEFILE to set large file mode,
    builders may have added the large file compilation flags to CFLAGS on
    their own.
    
    size is left limited to an int, because if your Xim file is
    larger than 2gb, you're doing it wrong.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 226622349a4b1e16064649d4444a34fb4be4f464
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 12:39:58 2013 -0800

    Unbounded recursion in _XimParseStringFile() when parsing include files [CVE-2013-2004 2/2]
    
    parseline() can call _XimParseStringFile() which can call parseline()
    which can call _XimParseStringFile() which can call parseline() ....
    eventually causing recursive stack overflow and crash.
    
    Limit is set to a include depth of 100 files, which should be enough
    for all known use cases, but could be adjusted later if necessary.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 236b603d235dc264d1c6250dca09c745458a9088
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 12:01:39 2013 -0800

    Unbounded recursion in GetDatabase() when parsing include files [CVE-2013-2004 1/2]
    
    GetIncludeFile() can call GetDatabase() which can call GetIncludeFile()
    which can call GetDatabase() which can call GetIncludeFile() ....
    eventually causing recursive stack overflow and crash.
    
    Easily reproduced with a resource file that #includes itself.
    
    Limit is set to a include depth of 100 files, which should be enough
    for all known use cases, but could be adjusted later if necessary.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 076428918e6c35f66b9b55c3fa097ff06496d155
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 18:37:37 2013 -0800

    integer overflow in ReadInFile() in Xrm.c [CVE-2013-1981 7/13]
    
    Called from XrmGetFileDatabase() which gets called from InitDefaults()
    which gets the filename from getenv ("XENVIRONMENT")
    
    If file is exactly 0xffffffff bytes long (or longer and truncates to
    0xffffffff, on implementations where off_t is larger than an int),
    then size may be set to a value which overflows causing less memory
    to be allocated than is written to by the following read() call.
    
    size is left limited to an int, because if your Xresources file is
    larger than 2gb, you're very definitely doing it wrong.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 90fd5abac2faca86f9f100353a3c9c7b89f31484
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 11:44:19 2013 -0800

    Integer overflows in stringSectionSize() cause buffer overflow in ReadColornameDB() [CVE-2013-1981 6/13]
    
    LoadColornameDB() calls stringSectionSize() to do a first pass over the
    file (which may be provided by the user via XCMSDB environment variable)
    to determine how much memory needs to be allocated to read in the file,
    then allocates the returned sizes and calls ReadColornameDB() to load the
    data from the file into that newly allocated memory.
    
    If stringSectionSize() overflows the signed ints used to calculate the
    file size (say if you have an xcmsdb with ~4 billion lines in or a
    combined string length of ~4 gig - which while it may have been
    inconceivable when Xlib was written, is quite possible today), then
    LoadColornameDB() may allocate a memory buffer much smaller than the
    amount of data ReadColornameDB() will write to it.
    
    The total size is left limited to an int, because if your xcmsdb file
    is larger than 2gb, you're doing it wrong.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit b9ba832401734e1cbd30a930c0d11d850293f3f9
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 11:25:25 2013 -0800

    unvalidated length in _XimXGetReadData() [CVE-2013-1997 12/15]
    
    Check the provided buffer size against the amount of data we're going to
    write into it, not against the reported length from the ClientMessage.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit de2e6c322c4aca22856b380f67f8e488e7510015
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 11:11:08 2013 -0800

    unvalidated index/length in _XkbReadGetNamesReply() [CVE-2013-1997 11/15]
    
    If the X server returns key name indexes outside the range of the number
    of keys it told us to allocate, out of bounds memory writes could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 2df882eeb3a70256170127a746a9ba26376599a1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 11:01:04 2013 -0800

    unvalidated index in _XkbReadVirtualModMap() [CVE-2013-1997 10/15]
    
    If the X server returns modifier map indexes outside the range of the number
    of keys it told us to allocate, out of bounds memory writes could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 4d7c422a37eb9617fb22f8e37527c2b34b105665
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 11:04:44 2013 -0800

    unvalidated index in _XkbReadExplicitComponents() [CVE-2013-1997 9/15]
    
    If the X server returns key indexes outside the range of the number of
    keys it told us to allocate, out of bounds memory writes could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit e56a2ada719c5cfac5ed61a52a80ade86c0f5957
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 10:51:51 2013 -0800

    unvalidated index in _XkbReadModifierMap() [CVE-2013-1997 8/15]
    
    If the X server returns modifier map indexes outside the range of the number
    of keys it told us to allocate, out of bounds memory writes could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 06c086e8a1d8374ea9a95ff989f053c96bb1bdca
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 10:39:21 2013 -0800

    unvalidated index in _XkbReadKeyBehaviors() [CVE-2013-1997 7/15]
    
    If the X server returns key behavior indexes outside the range of the number
    of keys it told us to allocate, out of bounds memory writes could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 00626c3830b869259098985afa38933d77ccec72
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 09:40:22 2013 -0800

    unvalidated index in _XkbReadKeyActions() [CVE-2013-1997 6/15]
    
    If the X server returns key action indexes outside the range of the number
    of keys it told us to allocate, out of bounds memory access could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit fd7d4956bc7a1c4b5c38661b12777ebee4d685d9
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 09:28:33 2013 -0800

    unvalidated index in _XkbReadKeySyms() [CVE-2013-1997 5/15]
    
    If the X server returns keymap indexes outside the range of the number of
    keys it told us to allocate, out of bounds memory access could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 59ae16a00d18588e98af57d26e442af8ea42b7aa
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 09:18:26 2013 -0800

    unvalidated indexes in _XkbReadGetGeometryReply() [CVE-2013-1997 4/15]
    
    If the X server returns color indexes outside the range of the number of
    colors it told us to allocate, out of bounds memory access could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit bff938b9fe1629cbacb726509edfa2a3840b7207
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 09:12:47 2013 -0800

    unvalidated indexes in _XkbReadGeomShapes() [CVE-2013-1997 3/15]
    
    If the X server returns shape indexes outside the range of the number
    of shapes it told us to allocate, out of bounds memory access could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit f293659d5a4024bda386305bb7ebeb4647c40934
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 22:49:01 2013 -0800

    unvalidated index in _XkbReadGetDeviceInfoReply() [CVE-2013-1997 2/15]
    
    If the X server returns more buttons than are allocated in the XKB
    device info structures, out of bounds writes could occur.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit cddc4e7e3cb4b9b7ad25f8591971a86901c249f2
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 19:30:09 2013 -0800

    unvalidated lengths in XAllocColorCells() [CVE-2013-1997 1/15]
    
    If a broken server returned larger than requested values for nPixels or
    nMasks, XAllocColorCells would happily overflow the buffers provided by
    the caller to write the results into.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 2cd62b5eb99ffbb2fce99f3c459455e630b35bf7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 22:49:01 2013 -0800

    integer overflow in XListHosts() [CVE-2013-1981 5/13]
    
    If the reported number of host entries is too large, the calculations
    to allocate memory for them may overflow, leaving us writing beyond the
    bounds of the allocation.
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 1f6a3dbf699b85c0ea715ef21de7e7095a714e12
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 22:49:01 2013 -0800

    integer overflow in XGetMotionEvents() [CVE-2013-1981 4/13]
    
    If the reported number of motion events is too large, the calculations
    to allocate memory for them may overflow, leaving us writing beyond the
    bounds of the allocation.
    
    v2: Ensure nEvents is set to 0 when returning NULL events pointer
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 39515b7c3ba8cae9021bf6695e378ae19487082f
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 22:49:01 2013 -0800

    integer overflow in XListFontsWithInfo() [CVE-2013-1981 3/13]
    
    If the reported number of remaining fonts is too large, the calculations
    to allocate memory for them may overflow, leaving us writing beyond the
    bounds of the allocation.
    
    v2: Fix reply_left calculations, check calculated sizes fit in reply_left
    v3: On error cases, also set values to be returned in pointer args to 0/NULL
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5669a220816b7d58fcaf0c302ead16fbe5c87817
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 21:05:27 2013 -0800

    integer overflow in _XF86BigfontQueryFont() [CVE-2013-1981 2/13]
    
    Similar to _XQueryFont, but with more ways to go wrong and overflow.
    Only compiled if libX11 is built with XF86BigFont support.
    
    v2: Fix reply_left calculations, check calculated sizes fit in reply_left
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6df8a63d34b7514077188e2062a13774f920c085
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 21:05:27 2013 -0800

    integer overflow in _XQueryFont() on 32-bit platforms [CVE-2013-1981 1/13]
    
    If the CARD32 reply.nCharInfos * sizeof(XCharStruct) overflows an
    unsigned long, then too small of a buffer will be allocated for the
    data copied in from the reply.
    
    v2: Fix reply_left calculations, check calculated sizes fit in reply_left
    
    Reported-by: Ilja Van Sprundel <ivansprundel@ioactive.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9f5d83706543696fc944c1835a403938c06f2cc5
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 20:54:24 2013 -0800

    Add _XEatDataWords to discard a given number of 32-bit words of reply data
    
    Matches the units of the length field in X protocol replies, and provides
    a single implementation of overflow checking to avoid having to replicate
    those checks in every caller.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit d7f04c340ade3834e603c23d543132e1ee4e0c63
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 13:03:55 2013 -0800

    Move repeated #ifdef magic to find PATH_MAX into a common header
    
    Lets stop duplicating the mess all over
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit f3a553a4e4a55d9d19deda1ea01883e1d5d682b1
Author: Pander <pander@users.sourceforge.net>
Date:   Tue May 7 18:38:14 2013 -0400

    Add compose sequences for J́ and j́.
    
    The resulting sequences are:
    
      U+004A LATIN CAPITAL LETTER J  U+0301 COMBINING ACUTE ACCENT
      U+006A LATIN SMALL LETTER J    U+0301 COMBINING ACUTE ACCENT
    
    Used in Dutch, per:
    
      http://lists.x.org/archives/xorg-devel/2013-February/035514.html
      https://nl.wikipedia.org/wiki/Accenttekens_in_de_Nederlandse_spelling
    
    Signed-off-by: Pander <pander@users.sourceforge.net>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit f49bb2dd6d4ea45c55bd21acc0efe2b764441020
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 16 18:30:56 2013 -0700

    Move big request comment in XOpenDisplay to the right place
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3996543c1b2919e97d61a5d70fe1ebd7cd76fc83
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 9 19:16:03 2013 -0800

    libX11 1.5.99.901 (1.6 RC1)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f9cd175a471116a616e681fb0ca1a61b3d84a6a0
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 8 22:33:28 2013 -0800

    Fix very weird indenting in src/GetFProp.c
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit e9bd757630368afb374c5d1bcc5d4d85ad3c6c4c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 8 15:37:33 2013 -0800

    XAllocClassHint: Assume calloc sets pointers in allocated memory to NULL
    
    While the C standard technically allows for the compiler to translate
    pointer = 0 or pointer = NULL into something other than filling the
    pointer address with 0 bytes, the rest of the Xlib code already assumes
    that calloc initializes any pointers in the struct to NULL, and there
    are no known systems supported by X.Org where this is not true.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 39547d600a13713e15429f49768e54c3173c828d
Author: Karl Tomlinson <xmail@karlt.net>
Date:   Mon Feb 18 01:25:34 2013 +0000

    MakeBigReq: don't move the last word, already handled by Data32
    
    MakeBigReq inserts a length field after the first 4 bytes of the request
    (after req->length), pushing everything else back by 4 bytes.
    
    The current memmove moves everything but the first 4 bytes back.
    If a request aligns to the end of the buffer pointer when MakeBigReq is
    invoked for that request, this runs over the buffer.
    Instead, we need to memmove minus the first 4 bytes (which aren't moved),
    minus the last 4 bytes (so we still align to the previous tail).
    
    The 4 bytes that fell out are already handled with Data32, which will
    handle the buffermax correctly.
    
    The case where req->length = 1 was already not functional.
    
    Reported by Abhishek Arya <inferno@chromium.org>.
    
    https://bugzilla.mozilla.org/show_bug.cgi?id=803762
    
    Reviewed-by: Jeff Muizelaar <jmuizelaar@mozilla.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3cdb6c3a1646f670afa03d424ec12ac418181d1e
Author: Quentin Glidic <sardemff7+git@sardemff7.net>
Date:   Tue Jan 15 21:07:17 2013 +0000

    nls/Makefile.am: Use LOG_COMPILER
    
    TESTS_ENVIRONMENT is deprecated
    
    Signed-off-by: Quentin Glidic <sardemff7+git@sardemff7.net>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit df66d7a98e2bc7f44fb5583b645df87d525f07f1
Author: Quentin Glidic <sardemff7+git@sardemff7.net>
Date:   Tue Jan 15 21:07:16 2013 +0000

    nls/Makefile.am: Remove unneeded $(srcdir)
    
    Signed-off-by: Quentin Glidic <sardemff7+git@sardemff7.net>
    Reviewed-by: Gaetan Nadon <memsize@videotron.ca>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 3facbe5c0df1b5597571b7b00d5f7bdbc92fb278
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Mar 2 12:01:39 2013 -0800

    Add <X11/Xresource.h> hint to all Xrm* man pages
    
    Help users figure out which header file they need to #include
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 466404007f2c8f7166e4faddfea1454c5bfe1e9a
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 8 17:13:09 2013 -0800

    _xudc_code_to_glyph: check for NULL pointer *before* writing to it, not after
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 47d2eff64d167b3245d346d7f38ca703be645e26
Author: Ken Moffat <ken@linuxfromscratch.org>
Date:   Thu Mar 7 18:27:54 2013 -0500

    dead_double_grave and dead_inverted_breve should only have one underscore.
    
    Correct instances of dead_double_grave and dead_inverted_breve to
    dead_doublegrave and dead_invertedbreve.
    
    Signed-off-by: Ken Moffat <ken@linuxfromscratch.org>
    Signed-off-by: James Cloos <cloos@jhcloos.com>

commit c23d61d1b84dca3740bf4786978c7908d0065fb9
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 18:10:27 2013 -0800

    Assume size_t is always available, since it was defined in C89
    
    Don't provide a fallback definition #ifdef X_NOT_POSIX anymore.
    We already use size_t throughout the rest of Xlib, just had this
    one instance left in XKBGAlloc.c of a fallback definition.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9bcfd84aa1410387bc8cf002a5f90f44705aa0d1
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Mar 1 18:09:07 2013 -0800

    unifdef XKB_IN_SERVER
    
    Leftovers from XKB files that were previously shared between the client
    and server code, but aren't any more.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 769a0efa2298040fe8316a89fc9e75fb61e288e5
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Feb 28 20:04:25 2013 -0800

    unifdef CRAY & _CRAY
    
    (mostly performed with unifdef, followed by some manual cleanup of
     the remaining code)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ca106eb03e5f5468df8033300c5caae3d3c6936b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Feb 28 20:04:25 2013 -0800

    unifdef WORD64
    
    WORD64 seems to have only been defined in <X11/Xmd.h> when building for
    CRAY, to handle int being a 64-bit value (ILP64, not LP64) and having
    64-bit alignment requirements.
    
    It hadn't been fully supported even before autotooling, as can be
    seen by removed code such as:
    
     #ifdef WORD64
     _XkbWriteCopyData32 Not Implemented Yet for sizeof(int)==8
     #endif
    
    (mostly performed with unifdef, followed by some manual cleanup of
     the remaining code)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9399caf2c12cbe1ed56f4f6b368c5811cb5d0458
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Thu Feb 28 20:04:25 2013 -0800

    unifdef MUSTCOPY
    
    MUSTCOPY seems to have only been defined in <X11/Xmd.h> when building for
    CRAY, to handle missing some sizes of integer type.
    
    (mostly performed with unifdef, followed by some manual cleanup of
     spacing/indenting in the remaining code)
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b687440c28c7da6ee0ae44514d20248db5161606
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sat Feb 16 10:42:23 2013 -0800

    Convert more sprintf calls to snprintf
    
    You could analyze most of these and quickly recognize that there was no
    chance of buffer overflow already, but why make everyone spend time doing
    that when we can just make it obviously safe?
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit b092dabbd712d7b656abcf572d253b9b206c0237
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Feb 15 23:43:12 2013 -0800

    XKeysymToString: move variable declarations to the scope of their usage
    
    Makes it easier for readers to understand scope of variable usage, and
    clears up gcc warning:
    
    KeysymStr.c: In function 'XKeysymToString':
    KeysymStr.c:128:13: warning: declaration of 'i' shadows a previous local [-Wshadow]
    KeysymStr.c:73:18: warning: shadowed declaration is here [-Wshadow]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f0b171c8ea7b055ba520272ea9a2604e18841ac7
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Feb 15 23:34:40 2013 -0800

    Preserve constness in casting arguments through the Data*() routines
    
    Casts were annoying gcc by dropping constness when changing types,
    when routines simply either copy data into the request buffer or
    send it directly to the X server, and never modify the input.
    
    Fixes gcc warnings including:
    ChProp.c: In function 'XChangeProperty':
    ChProp.c:65:6: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    ChProp.c:65:6: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    ChProp.c:74:6: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    ChProp.c:74:6: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    ChProp.c:83:6: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    SetHints.c: In function 'XSetStandardProperties':
    SetHints.c:262:20: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    SetPntMap.c: In function 'XSetPointerMapping':
    SetPntMap.c:46:5: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    SetPntMap.c:46:5: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    StBytes.c: In function 'XStoreBuffer':
    StBytes.c:97:33: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    StName.c: In function 'XStoreName':
    StName.c:40:27: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    StName.c: In function 'XSetIconName':
    StName.c:51:27: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 6c558ee357292dd9dfc6d9006f4525f625327c52
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Feb 15 22:58:54 2013 -0800

    Fix comment typo & confusing indentation levels in Data() macro definition
    
    The final } matches the one on the #define line, not one that doesn't
    appear after the else statement it was lined up with
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit afd6593da90e51234d59f8921c411317f91ab48b
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Feb 15 23:25:38 2013 -0800

    XStringToKeysym: preserve constness when casting off unsignedness for strcmp
    
    Fixes gcc warning:
    StrKeysym.c:97:17: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 7e3bf4dd83fec22bd568146de75e6d59eff74e21
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Feb 15 23:14:40 2013 -0800

    XRebindKeysym: Drop unnecessary const-removing cast
    
    C89 defines memcpy as taking a const void *, so casting from
    const unsigned char * to char * simply angers gcc for no benefit:
    
    KeyBind.c:1017:24: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 54527eab93d46055cf11eb6c18abb353a03ae544
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Fri Feb 15 22:45:19 2013 -0800

    cmsColNm.c: maintain constness of arguments to qsort helper function
    
    Fixes gcc warning:
    
    cmsColNm.c: In function 'FirstCmp':
    cmsColNm.c:257:20: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    cmsColNm.c:257:45: warning: cast discards '__attribute__((const))' qualifier from pointer target type [-Wcast-qual]
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit deedeada53676ee529d700bf96fde0b29a3a1def
Author: Nickolai Zeldovich <nickolai@csail.mit.edu>
Date:   Tue Jan 22 10:03:00 2013 -0500

    XListFontsWithInfo: avoid accessing realloc'ed memory
    
    If exactly one of the two reallocs in XListFontsWithInfo() fails, the
    subsequent code accesses memory freed by the other realloc.
    
    Signed-off-by: Nickolai Zeldovich <nickolai@csail.mit.edu>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit f57fd760cba92ad846917f21e94e73e9c846185f
Author: Colin Walters <walters@verbum.org>
Date:   Wed Jan 4 17:37:06 2012 -0500

    autogen.sh: Implement GNOME Build API
    
    http://people.gnome.org/~walters/docs/build-api.txt
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 51c102d39e855cf1704d9eb3afba76a2e73c6b81
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Jan 15 14:28:48 2013 -0500

    configure: Remove AM_MAINTAINER_MODE
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 3cd974b1d4d1fa6389d3695fa9fcc0c22a51d50c
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Dec 26 22:57:39 2012 -0800

    Remove unused DECnet ("DNETCONN") code from Xlib
    
    Has never been converted to build in modular builds, so has been unusable
    since X11R7.0 release in 2005.  DNETCONN support was removed from xtrans
    back in 2008.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a6e5b36a3e6d4a7a9fb4bad905ed127e67b1957e
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Wed Dec 26 22:56:38 2012 -0800

    Remove unused TLI ("STREAMSCONN") code from Xlib
    
    Has never been converted to build in modular builds, so has been unusable
    since X11R7.0 release in 2005.  All known platforms with TLI/XTI support
    that X11R7 & later releases run on also have (and mostly prefer) BSD
    socket support for their networking API.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 59c9ee8cd58857c5769b643611cbe526005a9e45
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Dec 16 17:44:42 2012 -0800

    Tell clang not to report -Wpadded warnings on public headers we can't fix
    
    Better to silence the compiler warning than break ABI.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 0b148750027fd0557c5ed93afda861ddf4b92e0f
Author: Jon TURNEY <jon.turney@dronecode.org.uk>
Date:   Mon Nov 12 17:27:52 2012 +0000

    Fix config check for loadable modules
    
    The config check of the results of testing for dlfcn.h or dl.h just tests the
    value of the ac_cv_ variables, which will be 'yes' or 'no', rather than checking
    it is 'yes', so loadable module support would always be detected.
    
    This is necessary for successful compilation for the MinGW target without the
    optional dlfcn-win32 library.
    
    v2: Also, fixed typoed name of ac_cv_header_dlfcn_h, so check still works
    correctly when dlfcn.h is available
    
    Signed-off-by: Jon TURNEY <jon.turney@dronecode.org.uk>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>

commit cd25cab4b5b957641183ce72dd1ae0424aff1663
Author: Egbert Eich <eich@freedesktop.org>
Date:   Fri May 20 18:27:02 2011 +0200

    Install Xcms.txt in $(datadir) rather than $(libdir).
    
    This file is an architecture independent data and should be where
    other databases are.
    This is the Xlib provided sample file, applications are free to
    use a different one specifying its location in the XCMSDB env
    variable.
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 51fef7e273b5c6256e4c9604e3e1afe5dc8f6a1a
Author: Egbert Eich <eich@freedesktop.org>
Date:   Fri May 20 18:25:24 2011 +0200

    Don't hard code path to Xcms.txt file.
    
    The path to this file is configurable at build time. The source
    however contains a hard coded path.
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 9833489e6c3829a1e835bc0a11f028fc180809e4
Author: Colin Walters <walters@verbum.org>
Date:   Fri Dec 7 08:51:21 2012 -0500

    Fix build after dropping locales
    
    They also needed to be removed from configure.ac
    
    Signed-off-by: Colin Walters <walters@verbum.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>

commit 0a740a574aaf0c0eec78859b773a532cff3b74c3
Author: Egbert Eich <eich@freedesktop.org>
Date:   Fri May 20 13:04:11 2011 +0200

    i18n: Uppercased all occurances if 'iso8859' in the full locale name.
    
    Making all occurances of iso8859 upper case in the full local name
    makes the alias entries more consistent and match the entries on
    locale.dir.
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 5e7d589697755a70fb22d85c6a1ae82b39843e53
Author: Egbert Eich <eich@freedesktop.org>
Date:   Fri May 20 17:55:49 2011 +0200

    i18n: Remove ja.S90 and ja.U90 locales.
    
    Both locales carry a copyright notice and a prorietary statement:
    
    Copyright 1995 by FUJITSU LIMITED
    This is source code modified by FUJITSU LIMITED under the Joint
    Development Agreement for the CDEnext PST.
    This is unpublished proprietary source code of FUJITSU LIMITED
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 99eae3dcb7bf6764e3b243d2a2934a4d1ecce90e
Author: Egbert Eich <eich@freedesktop.org>
Date:   Fri May 20 16:46:15 2011 +0200

    i18n: Bring locale.dir and compose.dir in sync.
    
    Some entries for locale/encoding combinations were missing from
    either file or just misspelled, some entries were wrong or just
    aliases.
    
    Signed-off-by: Egbert Eich <eich@freedesktop.org>
    Reviewed-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d1e6baa4e290b758e430077cb74e7c03ad850771
Author: Egbert Eich <eich@freedesktop.org>
